<?php
/**
 * Allows 3rd party clients to authenticate with ARDI
 *
 * Returns a unique key that can be included with calls
 *
 * @author Steven Harding
 */
	
	require_once($_SERVER['DOCUMENT_ROOT'].'/include/login.php');
	require_once('apiauth.inc');
	
	$apicode = "";
	
	if (!isset($_REQUEST['username']))
	{
		APIError(401,'Missing Parameter - username');
	}
	
	if (!isset($_REQUEST['password']))
	{
		APIError(401,'Missing Parameter - password');
	}
	
	ob_start();
	
	$auth = new AuthSystem();
	if ($auth->AuthUser($_REQUEST['username'],$_REQUEST['password']))
	{
		$dbx = $auth->GetDatabase();
		$bits = openssl_random_pseudo_bytes(16);
		$apicode = bin2hex($bits);
		$dbx->query("DELETE FROM userapi WHERE lastaccessed < DATE(NOW()) - INTERVAL 30 MINUTE");
		
		$dbx->query("INSERT INTO userapi (userid,apicode,lastaccessed) VALUES (".$_SESSION['userid'].','.$dbx->quote($apicode).",NOW())");
		
		echo '<login><authcode>'.$apicode.'</authcode></login>';
	}	
	else
	{
		APIError(310, "Invalid Authentication Details");
	}

	include('apioutput.inc');
?>