<?php
	
	$format = "xml";
	if (isset($_REQUEST['format']))
	{
		if ($_REQUEST['format'] == 'json')
		{
			$format = "json";
		}
	}
	
	//Get the profile 1 submission details...
	$query = $db->query('SELECT reqport,subport, address FROM profiles WHERE id=1');

	$info = array();
	if($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$info = $row;
	}
	
	if ($format == "xml") {
		header('Content-type: text/xml');
		echo '<?xml version="1.0" encoding="UTF-8" standalone="no"?>';	
		
		$authrequired = 'yes';
		if ($ini['auth']['guestmode'] == 'yes')
		{
			$authrequired = 'no';
		}
		
		echo '<ardi>';
		echo '  <auth>'.$authrequired.'</auth>';
		if (($sitemode == 'combined') || ($sitemode == 'integrated'))
		{
			echo '  <sites>';
			foreach($sitelist as $k => $v)
			{
				echo '      <subsite url="'.$k.'">'.$v['name'].'</subsite>';
			}
			echo '  </sites>';
		}
		//echo '  <';
		echo '  <name>'.$ini['server']['company'].'</name>';
		
		//$webport = 80;
		if (!isset($ini['services']['webport'])) $ini['services']['webport'] = 80;
		echo '  <service name="web" port="'.$ini['services']['webport'].'"';
		if (isset($ini['services']['webhost']))
		{
			echo ' host="'.$ini['services']['webhost'].'"';
		}
		echo '/>';
		
		echo '  <service name="data" port="'.$info['reqport'].'"';
		if ($info['address'] != "localhost")
		{
			echo ' host="'.$info['address'].'"';
		}
		echo '/>';
		
		if (!isset($ini['services']['collabport'])) $ini['services']['collabport'] = 4583;
		echo '  <service name="collab" port="'.$ini['services']['collabport'].'"';
		if (isset($ini['services']['collabhost']))
		{
			echo ' host="'.$ini['services']['collabhost'].'"';
		}
		echo '/>';
		
		if (!isset($ini['services']['mumbleport'])) $ini['services']['mumbleport'] = 64738;
		echo '  <service name="mumble" port="'.$ini['services']['mumbleport'].'"';
		if (isset($ini['services']['mumblehost']))
		{
			echo ' host="'.$ini['services']['mumblehost'].'"';
		}
		echo '/>';
		
		if (isset($ini['features']))
		{
			if ((isset($ini['features']['isolation'])) && ($ini['features']['isolation'] == 0))
			{
				echo '  <setting name="isolation">disabled</setting>';
			}
		}
		
		echo '</ardi>';
	}
	else
	{
		header('Content-type: application/json');
		echo "{ \r\n";
		echo "   \"services\": [ ";
		echo " { \r\n      \"name\": \"data\"";
		echo ",\r\n      \"port\": \"".$info['reqport']."\"";
		if ($info['address'] != "localhost")
		{
			echo ",\r\n      \"host\": \"".$info['address']."\"";
		}
		echo "},\r\n";
		
		echo " { \r\n      \"name\": \"web\"";
		echo ",\r\n      \"port\": \"".$ini['services']['webport']."\"";
		if (isset($ini['services']['webhost']))
		{
			echo ",\r\n      \"host\": \"".$ini['services']['webhost']."\"";
		}
		echo "}\r\n";
		echo "  ] \r\n}";
	}
?>