<?php
/**
 * Driver Function - Get driver details
 * 
 * During initialisation, this function is called to determine what
 *    sources need to be launched by each driver.
 *
 * Individual sources then get their own information from 'sourcedata'
 *
 * @author Steven Harding
 */	
 
	header('Content-type: text/xml');
	echo '<?xml version="1.0" encoding="UTF-8" standalone="no"?>';
	
	echo '<drivers>';	
	
	//OK - fetch the data we need...
	$query = $db->query('SELECT port,name FROM datadriver ORDER BY name');
	
	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		echo '     <driver port="'.htmlspecialchars($row['port']).'"/>'."\r\n";
	}	
	
	//echo '  </sources>';
	
	echo '</drivers>'."\r\n";
?>