<?php
/**
 * Gets a list of obects AND THEIR POSITIONS inside an environment
 *
 * Creates a list of objects within a given environment. 
 *
 * The 'id' parameters is the ID of the environment object.
 *
 * @author Steven Harding
 */	
		
	
		$itemid = $_REQUEST['id'];
	
	$query = $db->query("SELECT typename,id FROM properties WHERE typename='MODEL' OR typename='LOCATION'");
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			if ($row['typename'] == 'MODEL')
			{
				$modelprop = $row['id'];
			}
			if ($row['typename'] == 'LOCATION')
			{
				$locationprop = $row['id'];
			}
		}
	
		header("Content-type: text/xml");
		echo '<contents>';
					       		
		$query = $db->query("SELECT DISTINCT id,name,value FROM assets JOIN assetrelclosures ON (assetrelclosures.childasset=assets.id) JOIN assetvalues ON (assets.id = assetvalues.assetid) WHERE assetvalues.propertyid=".$locationprop." AND assetrelclosures.parentasset = ".$itemid);
		
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$ps = $row['value'];
			$bits = explode('|',$ps);
			
			$fname = $_SERVER['DOCUMENT_ROOT'].'/media/assets/'.$row['id'];
			if (file_exists($fname))
			{
				echo '  <asset id="'.$row['id'].'"';
				echo '>';
														
				if (!isset($asset[$row['id']]))
				{
					include($_SERVER['DOCUMENT_ROOT'].'/cache/relationships/'.$row['id'].'.inc');					
				}
							
				$flist = scandir($fname);
				
				foreach($flist as $f)
				{
					if ($f[0] == ".") continue;
					$pth = pathinfo($f);
					if ($pth['extension'] == 'path')
					{
						echo '  <item source="'.$pth['filename'].'">';
						echo '    ';
						include($fname.'/'.$f);
						echo '</item>';
					}
					if ($pth['extension'] == 'feature')
					{		
						echo '  <item source="'.$pth['filename'].'">';				
						include($fname.'/'.$f);
						echo '</item>';
					}
				}
				
				echo '</asset>'."\r\n";
			}
										    						
		}
		
		
	echo '</contents>';
?>