<?php
/**
 * Gets details of a particular 3D environment/layout
 *
 * @author Steven Harding
 */	
		//require_once($_SERVER['DOCUMENT_ROOT'].'/config/settings.php');
		//require_once($_SERVER['DOCUMENT_ROOT'].'/include/db.php');
				
		if (!isset($_REQUEST['id'])) exit;
		
		$itemid = filter_var($_REQUEST['id'],FILTER_VALIDATE_INT);
		if ($itemid === FALSE) exit;
		
		$path = $sitefolder.'/media/layouts/'.$itemid.'/details.inc';
		//echo 'Checking '.$path;
	
		header("Content-type: text/xml");
		echo '<environment>';
		
		if (file_exists($path))
		{				
			include($path);
			
			echo '  <name>'.$name.'</name>';
			
			echo '  <physicalextents>';
			echo $scalex.','.$scaley.','.$scalez;
			echo '  </physicalextents>';
			
			echo '   <levels>';
			foreach ($levels as $k => $lev)
			{
				echo '     <level>'.$lev['name'].'</level>';
			}
			echo '   </levels>';
		}
		else
		{
			echo '   <name>Level One</name><physicalextents>20,20,-1</physicalextents> <levels> <level>*</level></levels>';
		}
		
		echo '</environment>';
?>
