<?php
/**
 * Gets a list of objects and their relationships inside an environment
 *
 * Creates a list of objects within a given environment. 
 *
 * The 'id' parameters is the ID of the environment object.
 *
 * @author Steven Harding
 */	
	
		$itemid = $_REQUEST['id'];
	
		header("Content-type: text/xml");
		echo '<contents>';
		
		$query = $db->query("SELECT DISTINCT id FROM assets JOIN assetrelclosures ON (assetrelclosures.childasset=assets.id) WHERE assetrelclosures.parentasset=".$itemid);
		
		$idset = array();
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{			
			$any = false;
			
			$idset[] = $row['id'];
			
		}
		
		$inlist = "";
		foreach($idset as $i)
		{
			if ($inlist != "") $inlist .= ',';
			$inlist .= $i;
		}
		
		if ($inlist != "")
		{
			//echo "SELECT childasset,name FROM assetrelclosures JOIN assets ON (assets.id = assetrelclosures.parentid) WHERE assetrelclosures.relationship = 3 AND childasset IN (".$inlist.")";
		
			$query = $db->query("SELECT childasset,name FROM assetrelclosures JOIN assets ON (assets.id = assetrelclosures.parentasset) WHERE assetrelclosures.relationship = 3 AND name != 'Tags' AND childasset <> parentasset AND childasset IN (".$inlist.")");
			
			$idset = array();
			while($row = $query->fetch(PDO::FETCH_ASSOC)) 
			{			
				echo '  <tag name="'.$row['name'].'" asset="'.$row['childasset'].'"/>';
			}
		};
	echo '</contents>';
?>