<?php
/**
 * Get history data
 * 
 * Requests a set of history data from the appropriate historian server
 * and outputs it in a variety of possible formats.
 *
 * @author Steven Harding
 */	
	
	
	
	$format = "json";
	
	$itemid = $_REQUEST['id'];
	include($_SERVER['DOCUMENT_ROOT'].'/include/historian.php');
	
	$start = $_REQUEST['start'];
	$end = $_REQUEST['end'];
	$property = $_REQUEST['property'];
	$node = $_REQUEST['node'];
	
	date_default_timezone_set('Australia/Sydney');
	
	$p = strpos($start,"-");
	if ($p === FALSE)
	{
		$start = date('Y-m-d H:i:s', $start/1000);
	}
	
	$p = strpos($end,"-");
	if ($p === FALSE)
	{
		$end = date('Y-m-d H:i:s', $end/1000);
	}
	
	//echo 'Calling Function...';
	$res = GetHistoryRaw($itemid,$property,$node,$start,$end);		
	if ($res === FALSE)
	{		
		$res = array();
	}
	//echo 'Got Response!';
	
	if ($format == "json")
	{
		header('Content-Type: application/json');
		echo "{  \"records\" : [";
		$first = true;
		foreach($res as $q)
		{
			if (!isset($q[1])) continue;
			if ($first == true)
				$first = false;
			else
				echo ',';
			$tm = strtotime($q[1])*1000;
			echo '[ '.$tm.','.$q[2].' ]';
		}
		echo "] }";
	}
?>