<?php
/**
 * Gets a list of obects that have an APPEARANCE but no POSITION
 *
 * Creates a list of unplaced objects within a given environment. 
 *
 * The 'id' parameters is the ID of the environment object.
 *
 * @author Steven Harding
 */	
		require_once($_SERVER['DOCUMENT_ROOT'].'/config/settings.php');
		require_once($_SERVER['DOCUMENT_ROOT'].'/include/db.php');
	
		$itemid = $_REQUEST['id'];
	
		header("Content-type: text/xml");
		echo '<contents>';
		
		$query = $db->query("SELECT typename,id FROM properties WHERE typename='MODEL' OR typename='LOCATION'");
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			if ($row['typename'] == 'MODEL')
			{
				$modelprop = $row['id'];
			}
			if ($row['typename'] == 'LOCATION')
			{
				$locationprop = $row['id'];
			}
		}
	       
		$found = array();    
		
		$query = $db->query("SELECT assets.id,assetvalues.value FROM assets JOIN assetrelclosures ON (assetrelclosures.childasset=assets.id) JOIN assetvalues ON (assets.id = assetvalues.assetid) WHERE assetvalues.propertyid=".$modelprop." AND assetrelclosures.parentasset = ".$itemid);       
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$bits = explode('|',$row['value']);
			$found[$row['id']] = true;
		}
		
		$query = $db->query("SELECT link.childasset as id, value FROM assetrelclosures as link JOIN assetrelclosures as tagged ON (tagged.childasset=link.childasset AND tagged.relationship=3) JOIN assetvalues ON (tagged.parentasset = assetvalues.assetid) WHERE assetvalues.propertyid=".$modelprop." AND link.parentasset = ".$itemid);       
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$bits = explode('|',$row['value']);
			if (!isset($modelid[$row['id']]))
			{
				$found[$row['id']] = true;
			}
		}
				
		$notfound = array();

		$query = $db->query("SELECT DISTINCT id FROM assets JOIN assetrelclosures ON (assetrelclosures.childasset=assets.id) JOIN assetvalues ON (assets.id = assetvalues.assetid) WHERE assetvalues.propertyid=".$locationprop." AND assetrelclosures.parentasset = ".$itemid);
		
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			if (isset($found[$row['id']]))
			{
				unset($found[$row['id']]);
			}
		}
		
		$instring = "";
		foreach($found as $k => $v)
		{
			if ($instring != "") $instring .= ",";
			$instring .= $k;
		}
		
		if ($instring != "")
		{
			$query = $db->query("SELECT id,name FROM assets WHERE id IN (".$instring.")");
			
			while($row = $query->fetch(PDO::FETCH_ASSOC)) 
			{
				echo '   <unplacedasset id="'.$row['id'].'" name="'.$row['name'].'"/>';
			}
		}
	
	echo '</contents>';
?>