<?php
/**
 * Gets a list of objects and their relationships inside an environment
 *
 * Creates a list of objects within a given environment. 
 *
 * The 'id' parameters is the ID of the environment object.
 *
 * @author Steven Harding
 */	
	
		$itemid = $_REQUEST['id'];
	
		header("Content-type: text/xml");
		echo '<contents>';
		

		$query = $db->query("SELECT DISTINCT id FROM assets JOIN assetrelclosures ON (assetrelclosures.childasset=assets.id)");
		
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{			
			$any = false;
			
			include($sitefolder.'/cache/relationships/'.$row['id'].'.inc');
			
			
			if (isset($asset[$row['id']]))
			{				
				foreach($asset[$row['id']]['relationships'] as $k => $v)
				{
					if ($k <= 3) continue;
					
					if ($any == false) 
					{
						echo '  <asset id="'.$row['id'].'">';
						$any = true;
						
						foreach($asset[$row['id']]['values'] as $k2 => $v2)
						{
							if ($v2['type'] == "ISOPOINT")
							{
								echo '<isolationpoint>';
								foreach($v2['rels'] as $r)
								{
									echo '  <rel>'.$r.'</rel>'; 
								}
								echo '</isolationpoint>';
							}
						}
					}
				
					foreach($v as $itm)
					{
						if ($itm['upstream'] == true)
						{
							echo '  <relationship rel="'.$k.'" to="'.$itm['target'].'">';
						}
						else
						{
							echo '  <relationship rel="'.$k.'" from="'.$itm['target'].'">';
						}
						
						//OK - time to consider the relationship connection structure...
						if ($itm['upstream'] == false)
						{
							$qrx = $db->query("SELECT * FROM links WHERE relationshipid=".$k." AND previd=0 AND anchor='A:".$row['id']."'");
							
							if ($qrx !== FALSE)
							{		
								$foundit = false;	
								while($rw = $qrx->fetch(PDO::FETCH_ASSOC)) 
								{	
									//OK - we have the start of a chain...
									
									$chainparts = array();
									
									echo '      <!-- We Have A Chain Here, Starting At '.$row['id'].'! -->';
																																													
									$cp = array();
									$cp['anchor'] = $rw['anchor'];
									$cp['pos'] = $rw['pos'];
									$cp['id'] = $rw['id'];
									$chainparts[] = $cp;
									
									$linklist = array();								
									$linklist[] = $rw['nextid'];
									//Now, start hitting the cache to follow the chain to terminal points...
									
									unset($linkset);
									$linkset = array();
									for($x=0;$x<count($linklist);$x++)
									{
										if ($linklist[$x] == 0) continue;
																														
										include($sitefolder.'/cache/relationships/link_'.$linklist[$x].'.inc');
										
										$v = $linkset[$linklist[$x]];
										
										if ($v['anchor'] == 'A:'.$itm['target'])
										{
											$foundit = true;											
										}
										
										$cp = array();
										$cp['anchor'] = $v['anchor'];
										$cp['pos'] = $v['pos'];
										$cp['id'] = $linklist[$x];
										$chainparts[] = $cp;
										
										if ($foundit == true) break;
										
										if (isset($v["next"]))
										{
											$linklist[] = $v["next"];
										}																				
									}
									
									if ($foundit == true)
									{
										echo '  	<chain>';
										foreach($chainparts as $cp)
										{
											echo '			<link anchor="'.$cp['anchor'].'" pos="'.$cp['pos'].'" id="'.$cp['id'].'"/>';
										}
										echo '     	</chain>';
										break;
									}
								}
							}
						}
						
						echo '</relationship>';
					}				 
				}
			}
		    												
	    	if ($any == true) echo '</asset>';
		}
	
	echo '</contents>';
?>