<?php
/**
 * Driver Function - Get driver details
 * 
 * During initialisation, this function is called to determine what
 *    sources need to be launched by each driver.
 *
 * Individual sources then get their own information from 'sourcedata'
 *
 * @author Steven Harding
 */	
 
	header('Content-type: text/xml');
	echo '<?xml version="1.0" encoding="UTF-8" standalone="no"?>';
	
	echo '<profiles>';	
	
	//OK - fetch the data we need...
	$query = $db->query('SELECT name,reqport,subport FROM profiles WHERE address=\'\' OR address=\'localhost\'');
	
	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		echo '     <profile name="'.$row['name'].'" in="'.htmlspecialchars($row['subport']).'" out="'.htmlspecialchars($row['reqport']).'"/>'."\r\n";
	}	
	
	//echo '  </sources>';
	
	echo '</profiles>'."\r\n";
?>