<?php
/**
 * 3D Editor Function - Save A Connection
 * 
 * Called when a new connection has been created in the 3D editor - this
 *   saves the 3D points that the connection travels through, as well
 *   as type and display information.
 *
 * @author Steven Harding
 */	
	require_once($_SERVER['DOCUMENT_ROOT'].'/config/settings.php');
	require_once($_SERVER['DOCUMENT_ROOT'].'/include/db.php');

	/*$itemid = FALSE;
	if (isset($_REQUEST['id']))
	{
		$itemid = filter_var($_REQUEST['id'],FILTER_VALIDATE_INT);
	}
	if ($itemid === FALSE)
	{
		exit;
	}
	
	if ($itemid == 0)
	{
		echo "Bad ID!";
		exit;
	}*/

	if (isset($_REQUEST['fromid']))
	{
		$fromid = filter_var($_REQUEST['fromid'],FILTER_VALIDATE_INT);
		if ($fromid === FALSE) exit;
	}		
	
	if (isset($_REQUEST['toid']))
	{
		$toid = filter_var($_REQUEST['toid'],FILTER_VALIDATE_INT);
		if ($toid === FALSE) exit;
	}
	
	if (isset($_REQUEST['points']))
	{
		$points = $_REQUEST['points'];
	}		
	
	//echo 'Working...';
	
	$qry = "SELECT relationship FROM assetrelationships WHERE parentasset = ".$fromid." AND childasset=".$toid;
	$relid = 0;
	if (isset($_REQUEST['rel']))
	{
		$relid = filter_var($_REQUEST['rel'],FILTER_VALIDATE_INT);
		if ($relid === FALSE) exit;
		$qry = "SELECT COUNT(*) as cnt FROM assetrelationships WHERE parentasset = ".$fromid." AND childasset=".$toid." AND relationship=".$relid;
	}

	//OK - establish the nature of the relationship...
	$query = $db->query($qry);
	
	$rel = 0;
			
	if($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		if ($relid == 0)
			$rel = $row['relationship'];		
		else
		{
			if ($row['cnt'] != 0)
			{
				$rel = $relid;
			}
			else
			{
				exit;
			}
		}
	}
	
	if ($rel == 0) 
	{
		echo 'No Relationship Between Items';
		exit;
	}
	
	echo $points;
	
	$finalpoints = array();
	
	$segments = explode('|',$points);
	foreach($segments as $seg)
	{
		$pnt = array();
		$pnt['pos'] = $seg;
		$pnt['anchor'] = '';
		
		$bits = explode(':',$seg);
		if (count($bits) == 2)
		{
			$pnt['pos'] = $bits[1];
			$pnt['anchor'] = str_replace("-",":",$bits[0]);
		}
		
		if (count($finalpoints) > 0)
		{
			if ($pnt['pos'] == $finalpoints[count($finalpoints)-1]['pos'])
			{
				if ($pnt['anchor'] == $finalpoints[count($finalpoints)-1]['anchor'])
				{
					continue;
				}
			}
		}
		
		$finalpoints[] = $pnt;
	}
	
	$x = -1;
	$prev = 0;
	foreach($finalpoints as $pnt)
	{
		$x++;
		
		$db->query('INSERT INTO links (relationshipid,anchor,pos,previd,nextid) VALUES ('.$rel.','.$db->quote($pnt['anchor']).','.$db->quote($pnt['pos']).','.$prev.',0)');
		
		echo 'INSERT INTO links (relationshipid,anchor,pos,nextid,previd) VALUES ('.$rel.','.$db->quote($pnt['anchor']).','.$db->quote($pnt['pos']).','.$prev.',0)'.'<br/>';;
		
		$newid = $db->lastInsertId();
		
		echo 'Created '.$newid.'<br/>';
		
		$db->query('UPDATE links SET nextid='.$newid.' WHERE id='.$prev);
		
		echo 'UPDATE links SET nextid='.$newid.' WHERE id='.$prev.'<br/>';
		
		$prev = $newid;		
	}
	
	//$db->query("DELETE FROM links WHERE ");

	//Get Current Value (If Any)
	/*$query = $db->query("SELECT cnt(*) as Count FROM connections WHERE fromasset=".$fromid." AND toasset=".$toid);
			
	if($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		if ($row['Count'] != 0)
		{
			$exiting = true;
			$db->query("DELETE FROM connections WHERE fromasset=".$fromid." AND toasset=".$toid);
		}
	}
	
	$db->query('INSERT INTO connections (fromasset,toasset,startpoint,endpoint,points,style,options) VALUES ('.$fromid.','.$toid.','.$db->quote($start).','.$db->quote($end).','.$db->quote($points).',0,'.$db->quote('').')');		*/

?>