<?php

/**
 * Driver Function - Update alert information
 * 
 * Performs the logic on alerts to trigger them when incoming data
 *   to 'sourcepush' includes alert information.
 *
 * @author Steven Harding
 */	

	require_once($_SERVER['DOCUMENT_ROOT'].'/config/settings.php');
	require_once($_SERVER['DOCUMENT_ROOT'].'/include/db.php');

	$query = $db->query("SELECT alerts.id,datalinks.assetid, lastvalue FROM datalinks JOIN alerts ON (alerts.assetid=datalinks.assetid) AND (alerts.id = datalinks.node) WHERE propertyid=-1 AND updaterequired=1");

	$alertstatus = array();	
	$assetsforupdate = array();
	
	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$ar = array();
		$ar['value'] = $row['lastvalue'];
		$ar['asset'] = $row['assetid'];
		$ar['node'] = $row['id'];
		
		$alertstatus[$row['id']] = $ar;
		$assetsforupdate[] = $row['assetid'];		
	}
	
	foreach($alertstatus as $k => $v)
	{
		if ($v['value'] == '^') $v['value'] = 1;
		
		$db->query("UPDATE alerts SET state=".$v['value']." WHERE id=".$v['node']);	
		
		//echo "UPDATE alerts SET state=".$v['value']." WHERE id=".$v['node'];			
		
		$db->query("UPDATE datalinks SET updaterequired=0 WHERE assetid=".$v['asset'].' AND propertyid=-1 AND node=\''.$v['node'].'\'');
	}
			
	$processed = array();
	
?>