<?php	

	$param = $_REQUEST['param'];	
	
	$errormessage = "";
	
	$site = getenv('ARDISITE');	
	if ($site == "") $site = 'default';
	
	$sitepicked = false;
	$urlparts = explode('/',$param);	
	if ($urlparts[0] == 's')
	{
		$sitepicked = true;
		$site = $urlparts[1];
		$siteroot = '/'.$urlparts[0].'/'.$urlparts[1];
		$urlparts = array_slice($urlparts,2);
	}
	
	if ($urlparts[0] == 'docs')
	{
		include($installfolder.'/docs/index.php');
		exit;
	}
	
	$breadcrumprelationship = 2;
	$defaulttree = 2;
	$defaulttreeroot = 1;
	$datarelationship = 6;		
	
	//$site = "default";
	$installfolder = $_SERVER['DOCUMENT_ROOT'];
	$basefolder = $_SERVER['DOCUMENT_ROOT'];
	
	function FatalError()
	{
		global $page;
		global $installfolder;
		$arr = error_get_last();
		if ($arr != NULL)
		{
			//print_r($arr);
			$title = 'Critical Error';
			$style = 'page-error';
			include($installfolder.'/include/tmpl.php');
			Page404('Fatal Error','A Major Error Occured - '.$arr['message'].' at '.$arr['file'].', line '.$arr['line']);
			exit;			
		}
	}
	
	//register_shutdown_function("FatalError");
	
	if ($installfolder[strlen($installfolder)-1] == '/')
	{
		$installfolder = substr($installfolder,0,strlen($installfolder)-1);
		$basefolder = $installfolder;
	}
	
	if ($site == "")
	{
		$site = 'default';		
	}
	
	$sitefolder = $installfolder.'/sites/'.$site;		
	
	$inipath = $sitefolder.'/config/settings.ini';
    $ini = parse_ini_file($inipath,true);  
	
	$themefolder = '/themes/default';
	$theme = $ini['server']['theme'];
	if ($theme != 'default')
	{
		$themefolder = '/themes/'.$theme;
	}
	
	include($sitefolder.'/config/dbsettings.php');
	
	$guestmodeenabled = false;
	if (($ini['auth']['guestmode'] == 'yes') || ($ini['auth']['guestmode'] == 1))
	{
		$guestmodeenabled = true;
	}
	global $guestmodeenabled;
	
	global $sitefolder;
	global $basefolder;
	global $errormessage;
	global $ini;
	global $siteroot;
	global $site;
	global $themefolder;
	
	require_once($basefolder.'/include/settings.php');
	require_once($basefolder.'/include/db.php');	
	require_once($basefolder.'/include/security.php');	
	
	if (!file_exists($installfolder.'/sites/installed.flag'))
	{
		include($installfolder.'/install/firsttime.php');
		exit;
	}
	
	//OK - if no site has been picked, first offer the site list.
	if (($sitemode == 'combined') || ($sitemode == 'integrated'))
	{
		if ($sitepicked == false)
		{
			$pass = false;
			if ($urlparts[0] == 'api')
			{
				if ($urlparts[1] == 'connect')
				{
					$pass = true;
				}
			}
			if ($pass == false)
			{
				if (count($sitelist) > 1)
				{
					include($installfolder.'/pages/user/choosesite.php');
					exit;
				}
			}
		}
	}
	
	global $db;
	
	$companyname = $ini['server']['company'];
	global $companyname;
	
	$publicservername = $ini['server']['url'];
	global $publicservername;
	
	//OK - now start working.
	
	//print_r($ini);
	//print_r($urlparts);
	
	if ($ini['auth']['maintenance'] == 1)
	{
		echo 'Maintenance Mode Enabled';
		if (($urlparts[0] != 'admin') && ($urlparts[0] != 'login'))
		{
			echo "Showing Maintnance Page";
			//Maintenance Mode
			$style = 'page-reject';
			include($installfolder.'/include/tmpl.php');
			PageError('Maintenance Mode','This ARDI site is currently undergoing maintenance. Please check back shortly.');
			exit;
		}
	}
	//exit;
	
	$fl = $basefolder.'/pages/'.implode("/",$urlparts);
	
	//echo $fl;
	if (count($urlparts) == 0)
	{
		$urlparts = array('');
	}
	
	$bypasssecurity = false;
	if ($urlparts[0] == 'api')
	{
		$bypasssecurity = true;
		$fl = $basefolder.'/'.implode("/",$urlparts);
	}	
	
	if ($urlparts[0] == 'data')
	{
		$fl = $basefolder.'/'.implode("/",$urlparts);
	}	
	
	if ($urlparts[0] == 'media')
	{
		//echo 'Processing Media!';
		//exit;
		if (count($urlparts) > 1)
		{
			if ($urlparts[1] == 'fileupload')
			{
				include($installfolder.'/pages/media/fileupload.php');
				exit;
			}
			if ($urlparts[1] == 'webupload')
			{
				include($installfolder.'/pages/media/webupload.php');
				exit;
			}
			if ($urlparts[1] == 'delete')
			{
				include($installfolder.'/pages/media/delete.php');
				exit;
			}
			if ($urlparts[1] == 'update')
			{
				include($installfolder.'/pages/media/update.php');
				exit;
			}
		}
		
		$fl = $sitefolder.'/'.implode("/",$urlparts);
		
	        if (!file_exists($fl))
	    {
		$fl = $installfolder.'/'.implode("/",$urlparts);
	    }
		if (file_exists($fl))
		{
			//echo 'File Exists!';
			//exit;
		
			$finfo = finfo_open(FILEINFO_MIME_TYPE);
			
			$ctype = finfo_file($finfo, $fl);
			$ext = pathinfo($fl,PATHINFO_EXTENSION);
			
			if ($ext == 'css') $ctype = 'text/css';
			if ($ext == 'text/javascript') $ctype = 'text/javascript';
			
			header('Content-Type: '.$ctype);
			
			finfo_close($finfo);

			echo file_get_contents($fl);
			exit;
		}
		
	}
	
	if (!file_exists($sitefolder.'/cache/relationships/2.inc'))
	{
		//Time to rebuild the asset cache...
		$background = true;
		include($installfolder.'/pages/admin/tools/cacherebuild.php');
		unset($background);
	}
	
	if (!isset($_SESSION)) session_start();
	$editable = false;
	
	//echo 'WTF?';
	
	if ($bypasssecurity == false)
	{
		if ($urlparts[0] != 'login')
		{
			//Check security!
			if (!isset($_SESSION['userid']))
			{
				global $guestmodeenabled;
				
				if ($guestmodeenabled == false)
				{
					if (isset($_REQUEST['apicode']))
					{
						//Logging in via API code....
						global $db;
						
						$dbx = $db;
						if (($sitemode == 'combined') || ($sitemode == 'integrated'))
						{
							//Change database to handle centralised authentication...
							include($installfolder.'/sites/default/config/dbsettings.php');
							
							$srvr = "localhost";
							if ($dbserver != "") $srvr = $dbserver;
							
							$dbcommandstring = $dbtype.":host=".$srvr.';dbname='.$dbname.";charset=utf8";
							
							if (isset($dboptions))	
								$dbx = new PDO($dbcommandstring,$dbuser,$dbpass,$dboptions);	
							else
								$dbx = new PDO($dbcommandstring,$dbuser,$dbpass);
							
							include($sitefolder.'/config/dbsettings.php');
						}
						
						$dbx->query("DELETE FROM userapi WHERE lastaccessed < DATE(NOW()) - INTERVAL 30 MINUTE");
						
						$query = $dbx->query('SELECT users.userid,lastaccessed,username,basegroup FROM userapi JOIN users ON (users.userid = userapi.userid) WHERE apicode='.$db->quote($_REQUEST['apicode']));
		
						if($row = $query->fetch(PDO::FETCH_ASSOC)) 
						{
							//Bingo - we have an API authentication...
							$_SESSION['userid'] = $row['userid'];
							$_SESSION['username'] = $row['username'];
							$_SESSION['usertoken'] = $row['userid'];
							$_SESSION['userread'] = true;
							$_SESSION['useredit'] = false;
							$_SESSION['usercreate'] = false;
							$_SESSION['userdelete'] = false;
							$_SESSION['useradmin'] = false;
							$_SESSION['useroverlord'] = false;
							
							if ($row['basegroup'] == 'Editor')
							{
								$_SESSION['useredit'] = true;
								$_SESSION['usercreate'] = true;
								$_SESSION['userdelete'] = true;
							}
							if ($row['basegroup'] == 'Builder')
							{
								$_SESSION['useredit'] = true;
								$_SESSION['usercreate'] = true;
								$_SESSION['userdelete'] = true;
								$_SESSION['useradmin'] = true;
							}
							if ($row['basegroup'] == 'Superuser')
							{
								$_SESSION['useredit'] = true;
								$_SESSION['usercreate'] = true;
								$_SESSION['userdelete'] = true;
								$_SESSION['useradmin'] = true;
								$_SESSION['usersuper'] = true;
							}
							
						}	
						//OK - redirect back to the same page, but this time without the auth code (clean the url)...
						
					}
					
					if (!isset($_SESSION['userid']))
					{
						$dest = $siteroot.'/login';
						if (isset($_SERVER['REQUEST_URI']))
						{
							$ext = pathinfo($_SERVER['REQUEST_URI'],PATHINFO_EXTENSION);
							if (($ext === FALSE) || ($ext == "") || ($ext == "php"))
							{
								
								$_SESSION['bounceto'] = $_SERVER['REQUEST_URI'];
								if (isset($_SESSION['QUERY_STRING']))
								{
									if ($_SESSION['QUERY_STRING'] != "")
									{
										$_SESSION['bounceto'] = '?'.$_SERVER['QUERY_STRING'];
									}
								}
							}
						}
						header("Location: ".$dest);
						exit;
					}
				}
				else
				{
					$_SESSION['userid'] = -1;
					$_SESSION['username'] = 'Guest';
				}
			}
		}
		else
		{
			include($installfolder.'/pages/user/login.php');
			exit;
		}
	}
	
	//OK - redirect back to the same page, but this time without the auth code (clean the url)...
	if (isset($_GET['apicode']))
	{
		unset($_GET['apicode']);
		unset($_GET['param']);
		$srv = $_SERVER['REQUEST_URI'];
		$ps = strpos($srv,'?');
		if ($ps !== FALSE)
		{
			$srv = substr($srv,0,$ps);
		}
		
		$dest = $srv;
		
		$qry = http_build_query($_GET);
		if ($qry != "")
		{
			$dest = $srv.'?'.$qry;
		}
		header("Location: ".$dest);
		exit;
	}
	
	if (isset($_SESSION['useredit']))
	{
		if ($_SESSION['useredit'] == true)
		{
			$editable = true;
		}
	}
	
	
	if (file_exists($fl))
	{
		if (!is_dir($fl))
		{
		        //echo 'Sending File...';
		    //exit;
			$finfo = finfo_open(FILEINFO_MIME_TYPE);
			
			$ctype = finfo_file($finfo, $fl);
			$ext = pathinfo($fl,PATHINFO_EXTENSION);
			
			if ($ext == 'css') $ctype = 'text/css';
			if ($ext == 'text/javascript') $ctype = 'text/javascript';
			
			header('Content-Type: '.$ctype);
			
			finfo_close($finfo);

		        if (($ext == 'php') || ($ext == 'inc'))
		          include($fl);
		        else
		          readfile($fl);
			exit;
		}
	}
	
	if (!file_exists($fl.'.php'))
	{	
		if (is_dir($fl))	
			$fl .= '/index.php';		
		else
			$fl .= '.php';	
	}
	else
	{
		$fl .= '.php';
	}
	
	if (file_exists($fl))
	{
		if (!is_dir($fl))
		{
		    //echo 'Boo!'; exit;
			include($fl);
			exit;
		}
	}
	
	
	if ($urlparts[0] == 'test')
	{
		//echo 'Booya!';
		if (!isset($urlparts[1])) $urlparts[1] = 'index';
		$fx = $basefolder.'/tests/'.$urlparts[1].'.php';
		if (file_exists($fx))
		{
			include($fx);
			exit;
		}
	}
	
	if ($urlparts[0] == 'diagram')
	{		
		if (count($urlparts) >= 2)
		{
			$_REQUEST['assetid'] = $urlparts[1];
			if (count($urlparts) >= 3)
			{
				$_REQUEST['rel'] = $urlparts[2];
			}			
			include($basefolder.'/pages/asset/diagram.php');
			exit;
		}
	}
	
	if ($urlparts[0] == 'dashboard')
	{
		if (count($urlparts) >= 2)
		{
			$_REQUEST['assetid'] = $urlparts[1];			
			include($basefolder.'/pages/asset/dashboard.php');
			exit;
		}
	}
	if ($urlparts[0] == 'rdashboard')
	{
		if (count($urlparts) >= 3)
		{
			$_REQUEST['assetid'] = $urlparts[1];	
			$_REQUEST['rel'] = $urlparts[2];				
			include($basefolder.'/pages/asset/dashboard-relationships.php');
			exit;
		}
	}
	
	if (($urlparts[0] == 'edit') || ($urlparts[0] == 'ipedit'))
	{
		if (count($urlparts) >= 3)
		{
			$_REQUEST['assetid'] = $urlparts[1];			
			$_REQUEST['property'] = $urlparts[2];
			if ($urlparts[0] == 'ipedit')
			{
				$_REQUEST['inplace'] = true;
			}
			
			include($basefolder.'/pages/asset/editproperty.php');
			exit;
		}
	}
	
	if (($urlparts[0] == 'save'))
	{
		if (count($urlparts) >= 3)
		{
			$_REQUEST['assetid'] = $urlparts[1];			
			$_REQUEST['property'] = $urlparts[2];
			
			include($basefolder.'/pages/asset/saveproperty.php');
			exit;
		}
	}
	
	if (($urlparts[0] == 'properties') || ($urlparts[0] == 'detail'))
	{
		echo $basefolder.'/pages/asset/detail-properties.php';
		$pt = 'properties';
		if ($urlparts[0] == 'details')
		{
			if (isset($_SESSION['lastdetail']))
			{
				$pt = $_SESSION['lastdetail'];
			}
		}
		
		$_SESSION['lastdetail'] = 'properties';
	
		if (count($urlparts) >= 2)
		{
			$_REQUEST['assetid'] = $urlparts[1];			
			include($basefolder.'/pages/asset/detail-properties.php');
			exit;
		}
	}
	
	if ($urlparts[0] == 'editor')
	{
		$_SESSION['lastdetail'] = 'properties';
	
		if (count($urlparts) >= 2)
		{
			$_REQUEST['assetid'] = $urlparts[1];			
			include($basefolder.'/pages/asset/quickbuild.php');
			exit;
		}
	}
	
	if ($urlparts[0] == 'appearance')
	{
		$_SESSION['lastdetail'] = 'appearance';
	
		if (count($urlparts) >= 2)
		{
			$_REQUEST['assetid'] = $urlparts[1];			
			include($basefolder.'/pages/asset/detail-3d.php');
			exit;
		}
	}
	if ($urlparts[0] == 'alerts')
	{
		$_SESSION['lastdetail'] = 'alerts';
	
		if (count($urlparts) >= 2)
		{
			$_REQUEST['assetid'] = $urlparts[1];			
			include($basefolder.'/pages/asset/detail-alerts.php');
			exit;
		}
	}
	if ($urlparts[0] == 'model')
	{
		if (count($urlparts) >= 2)
		{
			$_REQUEST['id'] = $urlparts[1];			
			include($basefolder.'/pages/asset/modelselector.php');
			exit;
		}
	}
	
	if ($urlparts[0] == 'isostatus')
	{
		$_SESSION['lastdetail'] = 'isostatus';
	
		if (count($urlparts) >= 2)
		{
			$_REQUEST['assetid'] = $urlparts[1];			
			include($basefolder.'/pages/asset/isostatus.php');
			exit;
		}
	}
	
	if ($urlparts[0] == 'route')
	{	
		if (count($urlparts) >= 3)
		{
			$_REQUEST['from'] = $urlparts[1];
			$_REQUEST['to'] = $urlparts[2];				
			include($basefolder.'/pages/asset/route.php');
			exit;
		}
	}
	
	if ($urlparts[0] == 'assettools')
	{
		$_SESSION['lastdetail'] = 'appearance';
	
		if (count($urlparts) >= 2)
		{
			$_REQUEST['assetid'] = $urlparts[1];			
			include($basefolder.'/pages/asset/detail-tools.php');
			exit;
		}
	}

	if ($urlparts[0] == 'medialist')
	{
		$_SESSION['lastdetail'] = 'medialist';
	
		if (count($urlparts) >= 2)
		{
			$_REQUEST['assetid'] = $urlparts[1];			
			include($basefolder.'/pages/asset/detail-media.php');
			exit;
		}
	}
	
	if ($urlparts[0] == 'measurement')
	{
		if (count($urlparts) >= 2)
		{
			$_REQUEST['assetid'] = $urlparts[1];
			$_REQUEST['prop'] = $urlparts[2];
			
			include($basefolder.'/pages/measurements/measurement.php');
			exit;
		}
	}
	
	if ($urlparts[0] == 'history')
	{
		if (count($urlparts) >= 3)
		{
			$_REQUEST['assetid'] = $urlparts[1];
			$_REQUEST['prop'] = $urlparts[2];
			
			include($basefolder.'/pages/measurements/history.php');
			exit;
		}
	}
	
	if ($urlparts[0] == 'chart')
	{
		//echo 'Working On Charts';
	
		$_REQUEST['assetid'] = $urlparts[1];	
		if ($_REQUEST['assetid'] == 'custom')
		{
			include($basefolder.'/pages/measurements/chart-display.php');
			exit;
		}
		if ($_REQUEST['assetid'] == 'linkedto')
		{
			$mode = 'horizontal';
			$assetid = $urlparts[2];
			$rel = $urlparts[3];
			$_REQUEST['prop'] = $urlparts[4];
			include($basefolder.'/pages/measurements/chart-refine.php');
			exit;
		}
		if ($_REQUEST['assetid'] == 'under')
		{
			$mode = 'vertical';
			$assetid = $urlparts[2];
			$rel = $urlparts[3];
			$_REQUEST['prop'] = $urlparts[4];
			include($basefolder.'/pages/measurements/chart-refine.php');
			exit;
		}
				
		//echo 'Charting...';
		include($basefolder.'/pages/measurements/chart.php');
		exit;
	}
	
	if ($urlparts[0] == 'relationships')
	{
		//OK - let's figure this out...
		$_SESSION['lastdetail'] = 'relationships';
	
		if (count($urlparts) >= 2)
		{
			$_REQUEST['assetid'] = $urlparts[1];			
			include($basefolder.'/pages/asset/detail-relationships.php');
			exit;
		}
	}
	
	if ($urlparts[0] == 'flow')
	{
		//OK - let's figure this out...
		$_SESSION['lastdetail'] = 'flow';
	
		if (count($urlparts) >= 2)
		{
			$_REQUEST['assetid'] = $urlparts[1];			
			include($basefolder.'/pages/asset/detail-flow.php');
			exit;
		}
	}
	
	if ($urlparts[0] == 'sources')
	{
		//OK - let's figure this out...
		$_SESSION['lastdetail'] = 'sources';
	
		if (count($urlparts) >= 2)
		{
			$_REQUEST['assetid'] = $urlparts[1];			
			include($basefolder.'/pages/asset/detail-sources.php');
			exit;
		}
	}
	
	if ($urlparts[0] == 'alert')
	{
		if (count($urlparts) >= 2)
		{
			$_REQUEST['assetid'] = $urlparts[1];			
			include($basefolder.'/pages/alerts/alert.php');
			exit;
		}
	}
	
	if ($urlparts[0] == '3D-VE')
	{
		if (count($urlparts) >= 2)
		{
			$_REQUEST['assetid'] = $urlparts[1];	
			if (strpos($urlparts[1],'.'))
			{
				$fl = $basefolder.'/pages/3d/'.$urlparts[1];
				if (file_exists($fl))
				{
				    readfile($fl);
					//include($fl);
				}
				exit;
			}
			include($basefolder.'/pages/3d/virtual-environment.php');
			exit;
		}
	}
	
	if ($urlparts[0] == "crossdomain.xml")
	{
		include($basefolder.'/crossdomain.xml');
		exit;
	}
	
	if ($urlparts[0] == '')
	{
		include($basefolder.'/pages/index.php');
		exit;
	};
	
	$style = 'page-404';
	http_response_code(404);
	include($installfolder.'/include/tmpl.php');
	Page404('Unknown URL','The page you tried to visit does not exist.');
	
?>
