<?php

	require_once($_SERVER['DOCUMENT_ROOT'].'/config/settings.php');
	require_once($_SERVER['DOCUMENT_ROOT'].'/include/db.php');

	$query = $db->query("SELECT assets.name,lastwd, gatewayport, driver,assets.id,datasources.address, COUNT(datalinks.sourceid) FROM datasources JOIN assets ON (datasources.assetid = assets.id) JOIN datalinks ON (datalinks.sourceid = datasources.assetid)");
	
	$info = array();
	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$restart = false;
		echo $row['lastwd'].' / '.$row['gatewayport'].'<br/>';
		
		$gatewayexe = $_SERVER['DOCUMENT_ROOT'].'/datalink/'.$row['driver'].'/gateway/'.$row['driver'];
		
		switch(PHP_OS)
		{
		case "WIN32":
		case "Windows":
		case "WINNT":	
			$gatewayexe .= '.exe';			
		}		
		
		echo $row['name'].' ( '.strtoupper($row['driver']).' ) : ';
		
		if (file_exists($gatewayexe))
		{
			if ($row['gatewayport'] == 0)
			{
				$restart = true;
			}
			$tw = strtotime($row['lastwd']);
			$tx = time();
			
			//echo ($tx - $tw);
			
			if (($tx - $tw) > 60)
			{
				//Gateway Appears To Be Offline or Slow...
				$restart = true;
			}
			
			if ($restart == false)
			{
				echo 'Online!';
			}
			else
			{
				echo 'Offline';
				
				//Launch application!
				switch(PHP_OS)
				{
				case "WIN32":
				case "Windows":
				case "WINNT":								
					$cmd = $gatewayexe.' '.$row['id'];
					
					echo 'Restarting DAQ Process: '.$cmd;
					$WshShell = new COM("WScript.Shell"); 
					$oExec = $WshShell->Run($cmd, 0, false); 
																							
					break;
				default:
					//echo 'Executing Process in Linux';
					exec($gatewayexe.' > /dev/null 2>/dev/null &');
					break;
				}
			}
		}
		else
		{
			echo 'No Gateway Available!';
		}
				
		echo '<br/>';
	}
		
?>