<?php
	
	print_r($_REQUEST);
	
	$asset = filter_var($_REQUEST['asset'],FILTER_VALIDATE_INT);
	if ($asset === FALSE) exit;

	$targetmode = 0;
	$targetprofile = 1;
	
	if ($_SERVER['REQUEST_METHOD'] == 'POST')
	{
		//OK - let's find out if things are enabled...
		$transform = "";
		
		//print_r($_REQUEST);
		
		if (!isset($_REQUEST['offsetenabled']))
		{
			exit;
		}
		
		if ($_REQUEST['offsetenabled'] == true)
		{
			$off = filter_var($_REQUEST['offset'],FILTER_VALIDATE_FLOAT);
			if ($off === FALSE) exit;
			$transform .= 'OFFSET|'.$off;
		}
		
		if ($_REQUEST['lowcutenabled'] == true)
		{
			$off = filter_var($_REQUEST['lowcut'],FILTER_VALIDATE_FLOAT);
			if ($off === FALSE) exit;
			if ($transform != "") $transform .= ":";
			$transform .= 'LOWCUT|'.$off;
		}
		
		if ($_REQUEST['scaleenabled'] == true)
		{
			$offa = filter_var($_REQUEST['scaleinmin'],FILTER_VALIDATE_FLOAT);
			if ($offa === FALSE) exit;
			$offb = filter_var($_REQUEST['scaleinmax'],FILTER_VALIDATE_FLOAT);
			if ($offb === FALSE) exit;
			if ($transform != "") $transform .= ":";
			$transform .= 'SCALE|'.$offa.'|'.$offb;
			
			$offa = filter_var($_REQUEST['scaleoutmin'],FILTER_VALIDATE_FLOAT);
			if ($offa === FALSE) exit;
			$offb = filter_var($_REQUEST['scaleoutmax'],FILTER_VALIDATE_FLOAT);
			if ($offb === FALSE) exit;
			
			$transform .= '|'.$offa.'|'.$offb;
		}
		
		$asset = filter_var($_REQUEST['asset'],FILTER_VALIDATE_INT);
		$property = filter_var($_REQUEST['property'],FILTER_VALIDATE_INT);
		$profile = filter_var($_REQUEST['profile'],FILTER_VALIDATE_INT);
		$mode = filter_var($_REQUEST['mode'],FILTER_VALIDATE_INT);
		$node = $_REQUEST['node'];
		
		global $db;
		$db->query('UPDATE datalinks SET transform='.$db->quote($transform).' WHERE assetid='.$asset.' AND propertyid='.$property.' AND node='.$db->quote($node).' AND profile='.$profile.' AND mode='.$mode);
		
		//echo 'UPDATE datalinks SET transform='.$db->quote($transform).' WHERE assetid='.$asset.' AND propertyid='.$property.' AND node='.$db->quote($node).' AND profile='.$profile.' AND mode='.$mode;

		
		//echo 'Final Transform: '.$transform;
		
		header('Location: '.$siteroot.'/data/connect?asset='.$_REQUEST['asset'].'&property='.$_REQUEST['property']);
		exit;
	}
	
	if (isset($_REQUEST['profile']))
	{
		$bits = explode('-',$_REQUEST['profile']);
		if (count($bits) == 2)
		{
			$targetprofile = $bits[0];
			if ($bits[1] == 'H') $targetmode = 1;
		}
	}
	
	$title = "Data Point Transform";

	require_once($basefolder.'/include/tmpl.php');
			
	$property = filter_var($_REQUEST['property'],FILTER_VALIDATE_INT);
	if ($property === FALSE) exit;
	
	$itemdata = array();		
	$query = $db->query('SELECT * FROM assets WHERE id='.$_REQUEST['asset']);
	if($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$itemdata = $row;
	}	
	
	$mode = 'live';
	$modeid = 0;
	if (isset($_REQUEST['mode']))
	{
		$mode = $_REQUEST['mode'];
		if ($mode == 'hist') $modeid = 1;		
		if ($mode == 'sim') $modeid = 2;
		
		if ($modeid == 0) 
		{
			$mode = 'live';
		}
	}
	
	$sources = array();	
	$query = $db->query('SELECT * FROM datasources JOIN assets ON (assets.id = datasources.assetid) WHERE datasources.profile='.$targetprofile.' AND datasources.mode = '.$modeid.' ORDER BY name');
	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$sources[] = $row;
	}	
	
	if ($property > 0)
	{
		//echo 'Positive Property ('.$property.')';
		
		$query = $db->query('SELECT name,typename FROM properties WHERE id='.$property);
		if($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$propname = $row['name'];
			$proptype = $row['typename'];
		}	
	
		if (!file_exists($installfolder.'/modules/inputs/'.strtolower($proptype).'.php'))
		{
			//$template->StartSection('content'); 
			//echo '<h2>This module does not support external content.</h2>';
			//$template->Write();
			exit();
		}
		
		include($_SERVER['DOCUMENT_ROOT'].'/modules/inputs/'.strtolower($proptype).'.php');
	}
	else
	{
		$inputs = array();
		
		if ($property == -1)
		{							
			$node = filter_var($_REQUEST['node'],FILTER_VALIDATE_INT);
			if ($node === FALSE) exit;
				
			$inputs[] = array();
			$indx = count($inputs) - 1;
			$inputs[$indx]['name'] = 'alert_'.$node;
			$inputs[$indx]['displayname'] = 'Status';
			$inputs[$indx]['desc'] = 'The current status (1 or 0) of the alert';				
		}
	}
	
	?>
	
function expander(event)
{
	if (!$(event.target).closest('i').hasClass('fa-minus'))
	{
		$('#txenabled_' + event.data.name).val(1);
	}
	else
	{
		$('#txenabled_' + event.data.name).val(0);
	}
}
	
  $('#offset i').on('click',{ name: "offset" }, expander);
  $('#lowcut i').on('click',{ name: "lowcut" }, expander);

  $('#scale i').on('click',{ name: "scale" }, expander);
  $('#enumerate i').on('click',{ name: "enum" }, expander);
  
	<?php

	SS('onload'); 
//echo 'SELECT * FROM datalinks WHERE assetid='.$_REQUEST['asset'].' AND propertyid='.$_REQUEST['property'];	
	?>	

<?php SS('addscripts'); 

T('header-basic','title='.$title.'|backtrace=<li><a href="'.$siteroot.'/data/connect?id='.$asset.'">'.$itemdata['name'].'</a></li><li><a href="'.$siteroot.'/properties/'.$asset.'">'.$itemdata['name'].'</a></li>');

ST('section','class=content');
	ST('row');
		ST('half');
			echo '<form method="POST">';
			ST('box-collapsible','title=Offset|collapsed=1|id=offset');
				echo '<input type="hidden" name="offsetenabled" id="txenabled_offset" value="0"/>';
				ST('ftable');?>
				<tr><td><label>Amount:</label></td><td style="width: 80%;"><input type="text" style="width: 6em;" name="offset"/></td></tr><?php
				ET();
			ET();
			ST('box-collapsible','title=Lowcut|collapsed=1|id=lowcut');
				echo '<input type="hidden" name="lowcutenabled" id="txenabled_lowcut" value="0"/>';
				ST('ftable');?>
				<tr><td><label>Cut When Less Than:</label></td><td style="width: 80%;"><input type="text" style="width: 6em;" name="lowcut"/></td></tr><?php
				ET();
			ET();
			ST('box-collapsible','title=Scale|collapsed=1|id=scale');
				echo '<input type="hidden" name="scaleenabled" id="txenabled_scale" value="0"/>';
				ST('ftable');?>
				<tr><td><label>Input Minimum</label></td><td style="width: 80%;"><input type="text" style="width: 6em;" name="scaleinmin"/></td></tr>
				<tr><td><label>Input Max</label></td><td style="width: 80%;"><input type="text" style="width: 6em;" name="scaleinmax"/></td></tr>
				<tr><td><label>Output Minimum</label></td><td style="width: 80%;"><input type="text" style="width: 6em;" name="scaleoutmin"/></td></tr>
				<tr><td><label>Output Max</label></td><td style="width: 80%;"><input type="text" style="width: 6em;" name="scaleoutmax"/></td></tr><?php
				ET();
			ET();
			ST('box-collapsible','title=Value to Text|collapsed=1|id=enumerate');
				echo '<input type="hidden" name="enumenabled" id="txenabled_enumerate" value="0"/>';
				ST('ftable');?>
				<tr><th>When Value Is</th><th style="width: 80%;">Output</th><th>&nbsp;</th></tr>
				<tr><td><input type="text" name="enum_in_1"/></td><td style="width: 70%;"><input type="text" name="enum_out_1"/>&nbsp;&nbsp;&nbsp;<a href="#"><i class="fa fa-plus-circle"></i></a></td></tr>
				<?php
				ET();
			ET();
			ST('box-collapsible','title=Special|collapsed=1|id=special');
				echo '<input type="hidden" name="senabled" id="txenabled_special" value="0"/>';?>
				<input type="checkbox" value="1" name="special_signfix"/>&nbsp;&nbsp;Joy Mining Negative Number Fix
				<?php
			ET();
			echo '<input type="hidden" value="'.$_REQUEST['asset'].'" name="asset"/>';
			echo '<input type="hidden" value="'.$_REQUEST['property'].'" name="property"/>';
			echo '<input type="hidden" value="'.$_REQUEST['node'].'" name="node"/>';
			echo '<input type="hidden" value="'.$_REQUEST['profile'].'" name="profile"/>';
			echo '<input type="hidden" value="'.$_REQUEST['mode'].'" name="mode"/>';
			echo '<input type="submit" value="Save Changes And Return" class="btn btn-success"/>';
			echo '</form>';
		ET();
		ST('half');
			ST('box','title=Descriptions');?>
				<!--<input type="submit" value="Save And Continue" class="btn btn-success"/>&nbsp;&nbsp;<input type="submit" value="Save And Close" class="btn btn-success"/>-->
<?php
			SS('footer');
?>
			<h4>Offset</h4>
			<p>Offset adds a certain amount to the value <i>before</i> it is scaled. To lower the value, simply add a negative value.</p>
			<h4>Low Cut</h4>
			<p>Low cut sets a threshold under which your value is fixed to 'zero'. This is most often used in flow applications where meters have issues with very low flow rates.</p>
			<h4>Scale</h4>
			<p>Scales the value from one range to another. This is commonly used in direct data aquisition, such as when dealing with data from a MODBUS source.</p>
			<h4>Enumerate</h4>
			<p>Changes a number to text. This is most commonly used with digital inputs to change '0' and '1' to 'On' and 'Off'.</p>
			<h4>Round</h4>
			<p>Rounds the final value to a given number of decimal places.</p>
    <?php	
				
			ET();
		ET();
	ET();
ET();
?>