<?php
 /**
 * Closure Rebuid Function
 *
 * Attempts to rebuild closure tables on a specific asset and relationship.
 * This operation is quite expensive so should only be used when required.
 */	

$set = array();
global $set;

$handled = array();
global $handled;

$lines = array();
global $lines;

function RebuildObjectClosureTable($asset, $rel)
{
	$debug = false;
		
	/*$settoupdate[] = array();
	$settoupdate[count($settoupdate)-1]['asset'] = $asset;
	$settoupdate[count($settoupdate)-1]['relationship'] = $rel;
	$settoupdate[count($settoupdate)-1]['name'] = "Active Relationship";		*/
	
	//if ($debug == true) print_r($settoupdate);
	
	$set = array();
	global $set;
	global $db;
	
	global $handled;
	$handled = array();
	global $handled;
	
	global $lines;
	$lines = array();
	global $lines;
				
	if ($debug == true) echo 'Updating From Node '.$asset.' :' ;
	$depth = ROCTClimb($asset,$rel,$asset);	
						
	//global $lines;
	//print_r($lines);
	
	$set = array();
	
	//ROCTDescend($asset,$rel,$depth);
	
	if ($debug == true) echo 'Closure Update Complete';
	
}

function ROCTClimb($assetid,$relationship,$ultimateparent)
{
		//echo 'Climbing Table - '.$assetid;
		
		$debug = true;
		global $db;
		global $set;
		global $handled;
		global $lines;
		$mydepth = 0;
				
		if (!is_array($set)) $set = array();
		array_push($set,$assetid);
		
		//echo '<br/>Set: ';
		//print_r($set);
		//echo '<br/>';
		
		if (in_array($assetid,$handled)) return;
		
		if ($assetid != $ultimateparent)
		{
			$lines[] = 'INSERT IGNORE INTO assetrelclosures (childasset,parentasset,relationship,depth) VALUES ('.$ultimateparent.','.$assetid.','.$relationship.',%DEPTH%)';	
			//echo $lines[count($lines)-1];
			//echo '</br>';		
		}
		
		$handled[] = $assetid;
		
		$settoupdate = array();			
				
		for($x=0;$x<count($set);$x++)
		{												
			$query = $db->query('SELECT * FROM assetrelationships WHERE childasset='.$assetid.' AND relationship='.$relationship);
			while($row = $query->fetch(PDO::FETCH_ASSOC)) 
			{
				//print_r($row);
				//echo '<br/>';
				
				if (!in_array($row['parentasset'],$handled))
				{																						
					//$handled[] = $row['parentasset'];
					
					if (!in_array($row['parentasset'],$settoupdate)) $settoupdate[] = $row['parentasset'];
															
					if ($debug == true)
					{
						//echo 'Adding '.$row['parentasset'].' To Update Set';
										
					}						
				}
			}
														
		}			
								
		foreach($settoupdate as $i)
		{
			ROCTClimb($i,$relationship,$ultimateparent);
		}
		array_pop($set);
		
		if ($assetid == $ultimateparent)
		{
			//echo '<br/>--------###--------<br/>';
			
			for($x=0;$x<count($lines);$x++)
			{
				$lines[$x] = str_replace("%DEPTH%","".(count($lines) - ($x+1)),$lines[$x]);
			}
			//print_r($lines);
			
			$mydepth = count($lines);
		
			if (($assetid == $ultimateparent) && ($mydepth == 0))
			{
				$v = 0;
			}
			else
			{
				$lines[] = 'INSERT IGNORE INTO assetrelclosures (childasset,parentasset,relationship,depth) VALUES ('.$ultimateparent.','.$assetid.','.$relationship.','.$mydepth.')';
			}
			
			foreach($lines as $l)
			{
				$db->query($l);
				//echo $l;
			}
			
			//echo '<br/>--------###--------<br/>';
		}		
		
		return $mydepth;
}

function ROCTDescend($asset,$relationship)
{
		$debug = true;
		global $db;
		global $set;
		global $handled;
		
		array_push($set,$asset);
		
		if (in_array($asset,$handled)) return;
		
		$handled[] = $asset;
				
		for($x=0;$x<count($set);$x++)
		{						
			if (($set[$x] == $asset) && ($x > 0)) continue;
			
			if ($debug == true)
			{
				echo 'INSERT IGNORE INTO assetrelclosures (childasset,parentasset,relationship,depth) VALUES ('.$asset.','.$set[$x].','.$relationship.','.$x.')';				
			}
			
			$db->query('INSERT IGNORE INTO assetrelclosures (childasset,parentasset,relationship,depth) VALUES ('.$asset.','.$set[$x].','.$relationship.','.$x.')');
		}
		
		$settoupdate = array();				
				
		$query = $db->query('SELECT * FROM assetrelationships WHERE parentasset='.$asset.' AND relationship='.$relationship);
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			if (!in_array($row['childasset'],$handled))
			{									
				$settoupdate[] = $row['childasset'];
			}
		}
		
		foreach($settoupdate as $i)
		{
			ROCTDescend($i,$relationship);
		}
		array_pop($set);
		return true;
}
?>

