<?php
/**
 * An include file
 *
 * TODO: Relocate to '/includes' for consistency and code protection
 *
 * @author Steven Harding
 */

	$datalinkstried = array();
	$datalinks = array();
	global $datalinkstried;
	global $datalinkes;
	
	$isdynamic = false;
	
	global $isdynamic;	
	global $phppath;
	
	//Checks a property to get the most recent live data associated with it,
	//  should the item be connected.
	function LinkedData($id, $prop, $node, $default,&$isdynamic = "")
	{
		global $datalinks;
		global $datalinkstried;
		//global $isdynamic;
		global $db;		
		
		if (!is_array($datalinkstried))
		{
			$datalinkstried = array();
		}
		
		//First - have we loaded the dynamic data links for this item?
		if (!in_array($id, $datalinkstried))
		{
			//If no, then it's time to load them from the database...
			$query = $db->query('SELECT * FROM datalinks WHERE assetid='.$id);

			while($row = $query->fetch(PDO::FETCH_ASSOC)) 
			{
				$datalinks[] = $row;
			}
			$datalinkstried[] = $id;
		}
		
		//OK - we now have the data links loaded. Now go through them and mark the ones we are using...
		$dta = $default;
		
		for($x=0;$x<count($datalinks);$x++)
		{
			if (($datalinks[$x]['assetid'] == $id) && ($datalinks[$x]['propertyid'] == $prop) && ($datalinks[$x]['node'] == $node))
			{				
				//This is the data link we are interested in!
				$datalinks[$x]['used'] = true;
				
				$dta = $datalinks[$x]['lastvalue'];
				
				/*if ($datalinks[$x]['updaterequired'] == 0)
				{				
					//If it's old, flag it for update.
					$tm = strtotime($datalinks[$x]['lastupdate']);
					$dst = time() - $tm;									
																
					if (($dst) > $datalinks[$x]['frequency'])
					{
						if (($dst) > ($datalinks[$x]['frequency']*2))
						{
							$dta = "##";
						}
						$datalinks[$x]['aged'] = true;
					}
					
					//echo 'Aged!';
					
					//If I've requested data within 30 seconds of the most recent update and it's a fast-updating data point, it's probably worth flagging again.
					
					if (($dst < 30) && ($datalinks[$x]['frequency'] <= 30))
					{
						$datalinks[$x]['aged'] = true;
					}
				}
				else
				{
					$datalinks[$x]['aged'] = true;
				}*/
				
				//echo 'Found Dyanamic Data';
				if ($isdynamic === false)
				{
					//echo 'Setting Flag!';
					$isdynamic = true; 
				}
				break;
			}
		}
		
		return $dta;
		
	}
	
	//Deprecated - this function is no longer in use as it has been
	//   replaced by other functions
	function StartUpdateService()
	{
		return;		
	}
	
	//Refresh a specific data source due to source changes....
	function UpdateDataSource($srcno)
	{
		//Determine the IP and port number of the ARDI driver...				
		
		global $db;
		$query = $db->query('SELECT * FROM datasources JOIN datadriver ON (datadriver.port = datasources.gatewayport) WHERE datasources.assetid='.$srcno);

		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$ip = $row['address'];
			if ($ip == "") $ip = "localhost";
			$port = $row['port'];
		
			//Upgrade to v2 (socket-based IPC, not Web Service)
			if (isset($ip))
			{
				$ip = gethostbyname($ip);
				try
				{
					$client = stream_socket_client("tcp://".$ip.":".$port,$err,$errmsg);
					if ($client !== FALSE)
					{
						fwrite($client,"reload|".$srcno);
						fclose($client);
					}
				}
				catch(Exception $ex)
				{
				}
			}
		}	
		
		
		/*$url = "http://".$ip.":".$port."/reload?id=".$srcno;
		
		//echo 'Sending Reset Command To '.$url;
		
		//Send Request via CURL
		$ch = curl_init();
 
 	    curl_setopt($ch, CURLOPT_URL, $url);    
	    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_TIMEOUT, 3);
        $output = curl_exec($ch);
 
        // Close the cURL resource, and free system resources
        curl_close($ch);*/
	}
	
	function SpinupDataSource($srcno)
	{
		//Determine the IP and port number of the ARDI driver...
		global $db;
		$query = $db->query('SELECT * FROM datasources LEFT OUTER JOIN datadriver ON (datadriver.port = datasources.gatewayport) WHERE datasources.assetid='.$srcno);

		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			if ((!isset($row['port'])) || ($row['port'] == 0))
			{
				$query = $db->query('SELECT * FROM datadriver WHERE driver='.$db->quote($row['driver']));
				if ($query !== FALSE)
				{
					if($rx = $query->fetch(PDO::FETCH_ASSOC)) 
					{
						$row['address'] = $rx['address'];
						$row['port'] = $rx['port'];
						$db->query('UPDATE datasources SET gatewayport='.$rx['port'].' WHERE assetid='.$srcno);
					}
				}
			}
			$ip = $row['address'];
			if ($ip == "") $ip = "localhost";
			$port = $row['port'];
		}		
		
		//Upgrade to v2 (socket-based IPC, not Web Service)
		if (isset($ip))
		{
			$ip = gethostbyname($ip);
			$client = stream_socket_client("tcp://".$ip.":".$port,$err,$errmsg);
			fwrite($client,"spinup|".$srcno);
			fclose($client);
		}
		
	}
	
	//Perform cleanup and modifications to the DAQ tables and notify
	//   ARDI services of the users interest in new data that may not 
	//   currently be sampled (for interest-based sources)
	function UpdateLinkedData()
	{
		global $datalinks;
		global $db;
				
		//print_r($datalinks);
				
		//Make an SQL string...
		/*$qry = "";
		$updateme = false;
		foreach($datalinks as $dta)
		{
			if (($dta['updaterequired'] == 0) && (isset($dta['aged'])))
			{
				if ($qry != "")
				{
					$qry .= ' OR ';
				}
				$qry .= "((assetid = ".$dta['assetid'].") AND (propertyid = ".$dta['propertyid'].") AND (node = '".$dta['node']."'))";
			}
			
			if (isset($dta['aged'])) $updateme = true;
		}
		
		if ($qry != "")
		{	
			$db->query('UPDATE datalinks SET updaterequired=1 WHERE '.$qry);
		}
		if ($updateme == true) StartUpdateService();*/
		
	}

?>