<?php

function LogEvent($etype, $id, $content)
{	
	$logconstants = ["system" => 0, "asset" => 1,"property" => 2, "relationship" => 3, "other", 255];
	$logcode = 255;
	if (isset($logconstants[$etype])) $logcode = $logconstants[$etype];
	
	global $db;
	
	$uid = -1;
	if (isset($_SESSION['userid']))
	{
		$uid = $_SESSION['userid'];
	}
	$db->query("INSERT INTO ardilog (stamp, userid, area, id,content) VALUES (NOW(),".$uid.",".$logcode.",".$id.",".$db->quote($content).")");
}

function LogLinkify($str)
{
	require($_SERVER['DOCUMENT_ROOT'].'/cache/relationships/all.inc');
	require($_SERVER['DOCUMENT_ROOT'].'/cache/relationships/properties.inc');
	
	do
	{
		$ps = strpos($str,"[ass:");
		if ($ps !== FALSE)
		{
			$en = strpos($str,"]",$ps + 3);
			if ($en !== FALSE)
			{
				$code = substr($str,$ps+5,$en-($ps+5));
				
				$final = "";
				if (file_exists($_SERVER['DOCUMENT_ROOT'].'/cache/relationships/'.$code.'.inc'))
				{
					include ($_SERVER['DOCUMENT_ROOT'].'/cache/relationships/'.$code.'.inc');
					$final = '<a href="/assets/ddashboard.php?id='.$code.'">'.$asset[$code]['name'].'</a>';
				}
				else
				{
					$final = 'Deleted Asset #'.$code;
				}			
				
				$str = str_replace("[ass:".$code."]",$final,$str);				
			}
		}
	} while ($ps !== FALSE);
	
	do
	{
		$ps = strpos($str,"[prop:");
		if ($ps !== FALSE)
		{
			$en = strpos($str,"]",$ps + 3);
			if ($en !== FALSE)
			{
				$code = substr($str,$ps+6,$en-($ps+6));
				
				if (isset($propertyset[$code]))
				{
					$final = $propertyset[$code]['name'];
				}
				else
				{
					$final = 'Deleted Prop. #'.$code;
				}	
				
				$str = str_replace("[prop:".$code."]",$final,$str);				
			}
		}
	} while ($ps !== FALSE);
	
	$ps = strpos($str,"[rel:");
	if ($ps !== FALSE)
	{
		$en = strpos($str,"]",$ps + 3);
		if ($en !== FALSE)
		{
			$code = substr($str,$ps+5,$en-($ps+5));
			
			$final = "";
			if (isset($relationships[$code]))
			{
				$final = $relationships[$code]['name'];
			}
			else
			{
				$final = 'Deleted Rel. #'.$code;
			}			
			
			$str = str_replace("[rel:".$code."]",$final,$str);				
		}
	}
	
	return $str;		
}

?>