<?php
	require_once($_SERVER['DOCUMENT_ROOT'].'/include/templateengine.php');
	require_once($_SERVER['DOCUMENT_ROOT'].'/config/settings.php');
		
	$template = new Template('ARDI',$templatename);
	$template->Set('description','Installation');			
	$template->Set('heading','Installation');		
	
	$template->AddStyleSheet('/css/select2.css');
	$template->AddScript('/js/select2.js');  	
	$template->PublicPage();
	
	$template->Set('params','');
			
	$template->StartSection('content'); 
	
	$stage = 1;
	
	if (isset($_REQUEST['servertype']))
	{
		$stage = 2;
		if (isset($_REQUEST['hostname']))
		{
			$stage = 3;
			
			//Attempt Connection...
			$cstring = "";
			if ($_REQUEST['servertype'] == 'MySQL Server')
			{
				$cstring = "mysql:host=".$_REQUEST['hostname'].";dbname=".$_REQUEST['dbname'].";charset=utf8";
				
			}
			
			if ($cstring == "")
			{
				$stage = 1;
				$error = "Unknown Database Type";
			}
			else
			{
			
				$dbusername = $_REQUEST['username'];
				$dbpassword = $_REQUEST['password'];
				try {
					if (isset($dboptions))	
						$db = new PDO($cstring,$dbusername,$dbpassword,$dboptions);	
					else
						$db = new PDO($cstring,$dbusername,$dbpassword);
						
					//Save details
					$config = "<?php\r\n";
					$config .= '  $dbcommandstring = "'.$cstring.'";';
					$config .= '  $dbusername = "'.$dbusername.'";	$dbpassword = "'.$dbpassword.'";';
					$config .= "?>\r\n";
					file_put_contents($_SERVER['DOCUMENT_ROOT'].'/config/db.php',$config);
					
					//Copy database structure	
					
				}
				catch (PDOException $e)
				{
					$stage = 2;
					$error = $e->getMessage();
				}
			}
		}
		else
		{
			
		}
	}
	else
	{
	}

if ($stage == 1)
{
	?>	
<div class="12u" >	
	<br/>
    <h3>Select Database</h3>    
	        
</div>

<div class="12u">
    <p>Which type of database are you planning on using?</p>
    <form method="POST" style="width: 50%;margin-left: auto; margin-right: auto;">
    <p><select name="servertype"><option selected>MySQL Server</option><option>Microsoft SQL Server</option><option>PostGRESQL Server</option></select></p>
    <input type="submit" value="Next"/>
    </form>
    <br/><br/>    
</div>

<?php
}

if ($stage == 2)
{
	?>	
<div class="12u" >	
	<br/>
    <h3>Database Login</h3>    
	        
    <?php if (isset($error))
	{
		echo '<h4 style="color: red; margin-bottom: 1em;">'.$error.'</h4>';
	}
	?>
</div>

<div class="12u">
    <p>Please enter the following attributes of your database...</p>
    <form method="POST" style="width: 50%; margin-left: auto; margin-right: auto; text-align: center;">
    <input type="hidden" name="servertype" value="<?php echo $_REQUEST['servertype'];?>"/>
	<label style="text-align: center; width: 100%">Host Name / Address</label>
    <input type="text" value="localhost" name="hostname"/><br/>
    <label style="text-align: center; width: 100%">Database Name</label>
    <input type="text" value="ardi" name="dbname"/><br/>
   	<label style="text-align: center; width: 100%">Database Username</label>
    <input type="text" value="ardiuser" name="username"/><br/>
   	<label style="text-align: center; width: 100%">Database Password</label>
    <input type="password" value="" name="password"/><br/><br/>    
    <input type="submit" value="Next"/>
    </form>
    <br/><br/>    
</div>

<?php
}

if ($stage == 3)
{
	header("Location: login.php");
}
	
	$template->Write();
?>