<?php
	require_once($_SERVER['DOCUMENT_ROOT'].'/include/templateengine.php');
	require_once($_SERVER['DOCUMENT_ROOT'].'/config/settings.php');
		
	$template = new Template('ARDI',$templatename);
	$template->Set('description','Installation');			
	$template->Set('heading','Installation');		
	
	$template->AddStyleSheet('/css/select2.css');
	$template->AddScript('/js/select2.js');  	
		$template->PublicPage();
	
	$template->Set('params','');
			
	$template->StartSection('content'); 
?>	

<div class="12u" >	
	<br/>
    <h3>Prerequisites</h3>    
	        
</div>

<?php
function LoadedExt($ext, $name){
	$pass = true;
	echo '<span style="color: ';
	if (extension_loaded($ext) == false)
	{
		$pass = false;
		echo 'red';
	}
	else
		echo 'green';
	echo ';">'.$name.'</span><br/>';
	return $pass;
}
?>

<div class="12u">
    <p>ARDI requires a number of PHP extensions and options in order to operate.</p>
    <?php 
	
	$pass = true;
	$warn = false;

	if (!LoadedExt('curl','CURL (Web Query Module)')) $pass = false;	
	if (!LoadedExt('gd','GD (Graphics Editor Library)')) $pass = false;
	if (!LoadedExt('pdo_mysql','PDO_MYSQL (MySQL DB Driver)')) $pass = false;
	if (!LoadedExt('ldap','LDAP (LDAP Protocol Module)')) $warn = true;

	if ($warn == true) { ?>
    	<br/>
        WARNING: Some modules for <em>optional</em> features are not installed.<br/> Basic features of your ARDI installation will function, but some advanced options will not be available.<br/>
    <?php	
	}
			
	if ($pass == true) {
	?>
    <br/><button onclick="window.location = '/install/dbchoice.php'">Next</button><?php } else { ?>
    <br/><h4>ERROR: One or more of the above prerequisites (marked in red) have not been installed or enabled correctly.</h4><p>Installation can not continue until all of the modules are installed.
    <?php }; ?><br/><br/>
</div>


    <?php
	
	$template->Write();
?>