<?php

//Provides an interface to get information about particular relationships.

class Profile
{
	public $id;
	public $name;
	public $sources;
	public $subport;
	public $reqport;
	
	public function LoadFromArray($arr)
	{
		$this->id = $arr['id'];
		$this->name = $arr['name'];
		$this->subport = $arr['subport'];
		$this->reqport = $arr['reqport'];
		$this->sources = array();
	}
	
	public function HasLive()
	{
		return true;
	}
	
	public function HasHistorical()
	{
		return true;
	}
}

class Profiles
{
	public static function GetAllProfiles()
	{	
		global $db;
		$rt = array();
		$qry = 'SELECT * FROM profiles ORDER BY name ASC';
		
		$query = $db->query($qry);
		
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$nw = new Profile($row['id']);
			$nw->LoadFromArray($row);
			$rt[] = $nw;
		}
		return $rt;
	}
}

?>