<?php

OnlyShowIf(CheckAdmin());

$title = "Driver Logs";

include($installfolder.'/include/tmpl.php');
include($installfolder.'/model/relationship.php');

T('header-basic','title='.$title.'|backtrace=<li><a href="'.$siteroot.'/admin">Administration</a></li>');

ST('section','class=content');
	ST('row');
		
		ST('half');
			ST('box-collapsible','title=Driver List');?>
				<a href="<?php echo $siteroot; ?>/admin/drivers" class="btn btn-success">Return to Driver List</a><?php
				SS('footer');
				ST('table');
					$query = $db->query("SELECT port,assetid,datadriver.name as dname, assets.name as aname, datadriver.mode, datasources.profile as prof, datadriver.mode as mode, datadriver.driver FROM datadriver JOIN datasources ON (datadriver.port = datasources.gatewayport) JOIN assets ON (assets.id = datasources.assetid) ORDER BY datadriver.name");
		
					$driverid = 0;
					while($p = $query->fetch(PDO::FETCH_ASSOC)) 
					{
						
						if ($p['port'] != $driverid)
						{
							$running = '<span class="label label-warning">Offline</span>';
							$lockfile = '/var/run/drv-'.$p['driver'].'-'.$p['port'].'.pid';
							
							try
							{
								if (file_exists($lockfile))
								{
								    $pid = file_get_contents($lockfile);
								    
								    $dta = shell_exec("ps -p ".$pid);
								    
								    if (count(explode("\n",$dta)) > 1)
								    {
										$running = '<span class="label label-success">Online</span>';
								    }
								}
							}
							catch (Exception $e) 
							{
								echo 'Well, that didn\'t work out so well...';
							}
						
							echo '<tr><td><a href="showlog?type=driver&id='.$p['port'].'">'.$p['dname'].' ( '.$p['port'].' )</a></td><td>'.$running.'</td></tr>';
						}
						echo '<tr><td>&nbsp;&nbsp;&nbsp;<a href="showlog?id='.$p['port'].'&src='.$p['assetid'].'&profile='.$p['prof'].'&mode='.$p['mode'].'">'.$p['aname'].'</td><td>&nbsp;</td></tr>';
					}
				ET();
			ET();
		ET();
	ET();	
ET();

?>
