<?php

OnlyShowIf(CheckAdmin());
global $siteroot;

$title = "Property Administration";

include($installfolder.'/include/tmpl.php');
include($installfolder.'/model/property.php');

	$styles = array();
	global $installfolder;
	$fn = $installfolder.'/modules/info';

	$dirs = glob( $fn.DIRECTORY_SEPARATOR.'*');
	$ln = strlen($fn)+1;

	foreach($dirs as $d)
	{
		$file = $d;
		//echo $file;
		
		$src = array();
		
		if (file_exists($file))
		{
			include($file);
			$src['module'] = strtoupper($modulename);
			$src['friendly'] = $modulefullname;
			$styles[] = $src;
		}
	}
	
	$src = array();
	$src['module'] = 'MEASUREMENT';
	$src['friendly'] = 'An Analogue Measurement';
	$styles[] = $src;
	
	$src = array();
	$src['module'] = 'STATUS';
	$src['friendly'] = 'A Digital Status';
	$styles[] = $src;

T('header-basic','title='.$title.'|backtrace=<li><a href="'.$siteroot.'/admin">Administration</a></li>');

ST('section','class=content');
	ST('row');
		
		ST('half');
			ST('box-collapsible','title=Property List');?>
				<a href="<?php echo $siteroot; ?>/admin/properties/update&mode=add" class="btn btn-success">Add New Property</a><?php
				SS('footer');
				ST('table');
					$prps = Properties::GetAllProperties();
					foreach($prps as $p)
					{
						$pass = false;
						//if ($p->type == "MEASUREMENT") $pass = true;
						foreach($styles as $s)
						{
							if ($p->type == $s['module'])
							{
								$pass = true;
								break;
							}
						}
						if ($pass == false) continue;
						
						echo '<tr><td><a href="'.$siteroot.'/admin/properties/update?id='.$p->id.'">'.$p->name.'</a></td><td style="text-align: right;">';
						if ($p->type == "MEASUREMENT")
							echo '<a title="Display Options" href="'.$siteroot.'/admin/properties/mdisplay?id='.$p->id.'"><i class="fa fa-camera"></i></a>';
						
						echo '<a title="Duplicate Property" href="'.$siteroot.'/admin/properties/update?mode=duplicate&id='.$p->id.'" style="border: none;"><i class="fa fa-files-o"></i></a>';
						echo '<a title="Delete Property" href="'.$siteroot.'/admin/properties/update?mode=delete&id='.$p->id.'" style="border: none;"><i class="fa fa-trash-o"></i></a></td></tr>';
					}
				ET();
			ET();
		ET();
	ET();	
ET();

?>
