<?php

OnlyShowIf(CheckAdmin());

function write_php_ini($array, $file)
{
    $res = array();
    foreach($array as $key => $val)
    {
        if(is_array($val))
        {
            $res[] = "[$key]";
            foreach($val as $skey => $sval) $res[] = "$skey = ".(is_numeric($sval) ? $sval : '"'.$sval.'"');
        }
        else $res[] = "$key = ".(is_numeric($val) ? $val : '"'.$val.'"');
    }
	file_put_contents($file,implode("\r\n",$res));
    //safefilerewrite($file, implode("\r\n", $res));
}

$ini = parse_ini_file($sitefolder.'/config/settings.ini',true);

if ($_SERVER['REQUEST_METHOD'] == 'POST')
{
	if (isset($_REQUEST['sitename']))
	{
	
		print_r($ini);
		
		if ($_REQUEST['sitename'] != "")
		{
			$ini['server']['company'] = $_REQUEST['sitename'];
		}
		
		if (isset($_REQUEST['guestmode']))
		{
			$ini['auth']['guestmode'] = "yes";
		}
		else
		{
			$ini['auth']['guestmode'] = "no";
		}
		
		if (isset($_REQUEST['maintmode']))
		{
			$ini['auth']['maintenance'] = "yes";
		}
		else
		{
			$ini['auth']['maintenance'] = "no";
		}
		
		print_r($ini);
		
		
		write_php_ini($ini,$sitefolder.'/config/settings.ini');
		header("Location: ".$siteroot."/admin");
		exit;
	}
}

$title = $companyname." System Settings";

include('include/tmpl.php');

T('header-basic','title='.$title);

ST('section','class=content');
	ST('row');
		/*if ($_SESSION['userid'] == 1)
		{
			ST('half');
				ST('boxform','title=Server-Wide Settings');?>
			<input type="submit" value="Save Server-Wide Settings" class="btn btn-success"/><?php
					SS('footer');
					ST('ftable');?>
			<tr><td><label>Multi-Site Behaviour:</label></td><td><select name="sitemode"><option value="combined">Combined (Single Company)</option><option value="isolated">Isolated (Multi-Tennant)</option></select></td></tr>
					<?php
					ET();
				ET();
			ET();
		}*/
		ST('half');
			ST('boxform','title=Site Settings');?>
			<input type="submit" value="Save Site Settings" class="btn btn-success"/><?php
				SS('footer');
				ST('ftable');?>
			<tr><td><label>Company/Site Name:</label></td><td><input type="text" name="sitename" value="<?php echo $companyname;?>"/></td></tr>
			<tr><td><label>Options:</label></td><td>
				<input type="checkbox" name="guestmode"<?php if ($ini['auth']['guestmode'] == 1) echo ' checked';?>/>&nbsp;&nbsp;Enable Guest Mode<br/>
				<input type="checkbox" name="maintmode"<?php if ($ini['auth']['maintenance'] == 1) echo ' checked';?>/>&nbsp;&nbsp;Enable Maintenance Mode<br/>
			</td></tr>
					<?php
				ET();
			ET();
		ET();
		
	ET();	
	
ET();

?>
