<?php
	
	OnlyShowIf(CheckAdmin());
	
	$code = "";
	if (isset($_REQUEST['code'])) 
	{
		$code = $_REQUEST['code'];
		if (strpos($code,".") !== FALSE) exit;
	}
	else
	{
		exit;
	}
	
	//echo 'Hello?';
	
	if ($_SERVER['REQUEST_METHOD'] == "POST")
	{
		if (isset($_REQUEST['name']))
		{
			if (trim($_REQUEST['name']) != "")
			{
				$inx = parse_ini_file($installfolder.'/sites/'.$code.'/config/settings.ini',true);
				$inx['server']['company'] = $_REQUEST['name'];
				
				if (isset($_REQUEST['guestmode']))
				{
					$inx['auth']['guestmode'] = "yes";
				}
				else
				{
					$inx['auth']['guestmode'] = "no";
				}
				
				if (isset($_REQUEST['maintmode']))
				{
					$inx['auth']['maintenance'] = "yes";
				}
				else
				{
					$inx['auth']['maintenance'] = "no";
				}
		
				write_php_ini($inx,$installfolder.'/sites/'.$code.'/config/settings.ini');
				header('Location: '.$siteroot.'/admin/sites');
				exit;
			}
		}
	}
	
function write_php_ini($array, $file)
{
    $res = array();
    foreach($array as $key => $val)
    {
        if(is_array($val))
        {
            $res[] = "[$key]";
            foreach($val as $skey => $sval) $res[] = "$skey = ".(is_numeric($sval) ? $sval : '"'.$sval.'"');
        }
        else $res[] = "$key = ".(is_numeric($val) ? $val : '"'.$val.'"');
    }
	file_put_contents($file,implode("\r\n",$res));
    //safefilerewrite($file, implode("\r\n", $res));
}
	
	$title = "Update Site";
	$modename = 'Update Site';
	
	if (!file_exists($installfolder.'/sites/'.$code.'/config/settings.ini')) 
	{
		echo 'Couldn\'t Find It!';
		exit;
	}
	$inx = parse_ini_file($installfolder.'/sites/'.$code.'/config/settings.ini',true);
	
	$sitename = $inx['server']['company'];
	
	include($installfolder.'/include/tmpl.php');

	T('header-basic','title='.$title.'|backtrace=<li><a href="'.$siteroot.'/admin/sites">Site List</a></li><li><a href="'.$siteroot.'/admin">Administration</a></li>');

	ST('section','class=content');?>
		<form method="POST" action="update"><?php
		ST('row');
			ST('half');?>
				<?php
				ST('box','title='.$modename);?>
				<input type="hidden" name="code" value="<?php echo $code;?>"/>
        
				<input type="submit" class="btn btn-success" value="<?php echo $modename; ?>"/><?php
					SS('footer');
					ST('ftable');?>
						
    	<tr><td><label>Name : </label></td>
		<td><input type="text" name="name" style="width: 90%" value="<?php echo $sitename;?>"/></td></tr>
		<tr><td><label>Options:</label></td><td>
				<input type="checkbox" name="guestmode"<?php if (($inx['auth']['guestmode'] == 1) || ($inx['auth']['guestmode'] == 'yes')) echo ' checked';?>/>&nbsp;&nbsp;Enable Guest Mode<br/>
				<input type="checkbox" name="maintmode"<?php if (($inx['auth']['maintenance'] == 1) || ($inx['auth']['maintenance'] == 'yes')) echo ' checked';?>/>&nbsp;&nbsp;Enable Maintenance Mode<br/>
			</td></tr>
        <?php
					ET();
				ET();
			ET();
		ET();
		 ?>
    </form>
 <?php
	ET();?>