<?php
	
	if ($editable != true) exit;
	
	include($installfolder.'/model/property.php');
	include($installfolder.'/model/asset.php');
	
	$parent = 0;
	
	if (!isset($_REQUEST['asset']))
	{
		exit;
	}
	
	$parent = filter_var($_REQUEST['asset'],FILTER_VALIDATE_INT);
	if ($parent === FALSE) exit;
	
	$id = 0;
	if (isset($_REQUEST['id'])) 
	{
		$id = filter_var($_REQUEST['id'],FILTER_VALIDATE_INT);
		if ($id === FALSE) exit;
	}
	
	$propinfo = array();
	if ($id != 0)
	{
		$query = $db->query('SELECT * FROM alerts WHERE id='.$id);
	
		if($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$propinfo = $row;
		}
		
		$parent = $propinfo['assetid'];

		$modename = "Update Alert";
		
		if ((isset($_REQUEST['delete'])) || ((isset($_REQUEST['mode'])) && ($_REQUEST['mode'] == 'delete')))
		{
			$modename = "Delete Alert";
			
			if (isset($_POST['confirm']))
			{
				//Delete It!
				$db->query("DELETE FROM alert WHERE id=".$id);
				header("Location: ".$siteroot.'/alerts/'.$parent);
				exit;
			}
		}
		
		if ($_SERVER['REQUEST_METHOD'] == 'POST')
		{
			if (!isset($_REQUEST['name'])) exit;
			if (!isset($_REQUEST['type'])) exit;
			
			if (!isset($_REQUEST['usname'])) exit;
			if (!isset($_REQUEST['dsname'])) exit;
			
			$name = $_REQUEST['name'];
			$usname = $_REQUEST['usname'];			
			$dsname = $_REQUEST['dsname'];			
			$type = filter_var($_REQUEST['type'],FILTER_VALIDATE_INT);
			if ($type === FALSE) exit;
			$options = "";
			
			if (trim($name) == "") 
				$errormsg = "You must specify a valid, unique name for your relationship.";
			else
			{			
				$query = $db->query('SELECT * FROM relationships WHERE name='.$db->quote($name).' AND id <> '.$id);
									
				if($row = $query->fetch(PDO::FETCH_ASSOC)) 
				{
					$errormsg = "Your relationship name is not unique. Please select another name.";
				}
			}
			
			if (!isset($errormsg))
			{
				$db->query("UPDATE assets SET name=".$db->quote($name)." WHERE id=".$id);
				//include ($installfolder.'/include/updaterelcache.php');
				header("Location: ".$siteroot.'/alerts/'.$parent);
				exit;
			}
		}

	}
	else
	{		
		
		$propinfo['name'] = '';
		$propinfo['description'] = '';
		$propinfo['relationship'] = 0;
				
		$modename = "Add Alert";
		
		//echo 'Adding Alert';
		
		if ($_SERVER['REQUEST_METHOD'] == 'POST')
		{
			if (!isset($_REQUEST['name'])) exit;
				
			$name = $_REQUEST['name'];
				
			if (trim($name) == "") 
				$errormessage = "You must specify a valid name for your alert.";
			else
			{			
				$query = $db->query('SELECT * FROM alerts WHERE assetid='.$parent.' AND name='.$db->quote($name));
	
				if($row = $query->fetch(PDO::FETCH_ASSOC)) 
				{
					$errormessage = "Your alert name is not unique to this asset. Please select another name.";
				}
			}
			
			//echo 'Saving...';
			if ($errormessage == "")
			{
			
				//$type = filter_var($_REQUEST['type'],FILTER_VALIDATE_INT);
				//if ($type === FALSE) exit;
				$options = "";
				$rel = filter_var($_REQUEST['rel'],FILTER_VALIDATE_INT);
				if ($rel === FALSE) exit;
				
				$db->query("INSERT INTO alerts (name,assetid,state,function,relationship) VALUES (".$db->quote($name).",".$parent.',0,'.$db->quote('').','.$rel.')');
					
				//include ($installfolder.'/include/updaterelcache.php');
				header("Location: ".$siteroot.'/alerts/'.$parent);
				exit;
			}
			else
			{
				//echo 'Dropped Out "'.$errormessage.'"';
				exit;
			}
		}
	}
	
	//include($installfolder.'/include/tmpl.php');
	
	
	if ($modename == "Delete Alert")
	{
		$title = "Delete ".$propinfo['name'];
	
		T('header-basic','title='.$title);	
		
		ST('section','class=content');
			ST('row');
				ST('half');?>
				    <form method="POST" action="update.php"><?php
					ST('box','title='.$modename);?>
					<a href="" class="btn btn-success" onclick="history.go(-1); return false;">No - Cancel</a>&nbsp;&nbsp;<input type="submit" value="Yes - Delete It" class="btn btn-warning"/><?php
						SS('footer');
						
?>	
    	Are you sure you want to delete your '<?php echo $propinfo['name']?>' alert?<br/>
        <input type="hidden" name="id" value="<?php echo $id;?>"/>
        <input type="hidden" name="delete" value="true"/>
        <input type="hidden" name="confirm" value="true"/>        
<?php 				ET();?>
					</form><?php
				ET();
			ET();
		ET();
		exit;
	};
	
	if ($propinfo['name'] != "")
		$title = "Edit ".$propinfo['name'];
	else
		$title = "Add Alert";
	
	include($installfolder.'/include/tmpl.php');

	T('header-basic','title='.$title);
	?>
	
	<script>
function ChangeType()
{
	if ($('#typ').val() == "compare")
		$('.comparison').fadeIn(500);
	else
		$('.comparison').fadeOut(500);
}
	</script>
	
	<?php
	ST('section','class=content');?>
		<form method="POST" action="update"><?php
		ST('row');
			ST('half');?>
				<?php
				ST('box','title='.$modename);?>
				<input type="hidden" name="id" value="<?php echo $id;?>"/>
				<input type="hidden" name="asset" value="<?php echo $parent;?>"/>
        
				<br/><input type="submit" class="btn btn-success" value="<?php echo $modename; ?>"/><?php
					SS('footer');
					ST('ftable');?>
						
    	<tr><td><label>Name : </label></td><td><input style="width: 100%" type="text" name="name" value="<?php echo $propinfo['name']; ?>"/></td></tr>
		<tr><td><label>Description : </label></td><td><textarea style="width: 100%;" name="desc"><?php echo $propinfo['description']; ?></textarea></td></tr>
		<tr><td><label>Relationship : </label></td><td><select name="rel">
		<?php
			include($installfolder.'/model/relationship.php');
			$dta = Relationships::GetAllRelationships();
			foreach($dta as $d)
			{
				echo '<option value="'.$d->id.'">'.$d->name.'</option>';
			}
		?></select></td></tr>
		<tr><td><label>Media : </label></td><td><select name="media"><option value="">[ None ]</option>
		<?php
			$thisasset = new Asset($parent);
			$media = $thisasset->GetMedia();
			
			foreach($media as $m)
			{
				echo '<option value="'.$d->id.'">'.$d->name.'</option>';
			}
		?></select></td></tr>
		<tr><td><label>Alert Type : </label></td><td><select id="typ" name="typ" onchange="ChangeType();">
		<option value="dynamic">From A Data Source</option>
		<option value="compare">Compare Values</option>
		</select></td></tr>
		
		<?php
		$thisasset = new Asset($parent);
		$prop = $thisasset->GetLocalProperties();
		
		?>
		
		<tr class="comparison" style="display: none;"><td><label>Trigger Alert When</label></td><td>
		<select name="prop">
<?php
		foreach($prop as $p)
		{
			echo '<option value="'.$p->id.'">'.$p->name.'</option>';
		}
?>
		</select><br/>
		<select name="cmp">
		<option value="=">Is Equal To</option>
		<option value="!=">Is Not Equal To</option>
		<option value=">">Is Greater Than</option>
		<option value="<">Is Less Than</option>
		</select><br/>
		<input type="text" name="value"/></td></tr>
		        
        <?php
					ET();
				ET();
			ET();
		ET();
		 ?>
    </form>
 <?php
	ET();?>