<?php

	//print_r($_REQUEST);
	
	if (!isset($thisasset))
	{
		$itemid = filter_var($_REQUEST['assetid'],FILTER_VALIDATE_INT);
		if ($itemid === FALSE) exit;

		include($installfolder.'/model/asset.php');

		//echo 'Loading Asset '.$itemid;
		
		$thisasset = new Asset($itemid);
		$thisasset->Load();

		$dta = $thisasset->GetProperties();
		$thisasset->GetValues($dta);
					
		foreach($dta as $prop)
		{
			if ($prop->type == "MODEL")
			{
				$mdl = $prop->value;
								
				break;
			}
		}
	}

	if (!isset($mdl))
	{
		echo 'You don\'t have a model associated with this asset';
		return;
	}
	
	$query = $db->query("SELECT * FROM models WHERE id=".$mdl['model']);
	if($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$model = $row;
	}		
				
	$path_parts = pathinfo($sitefolder.$model['obj']);
	
	$existing = array();
	
	$fn = $sitefolder.'/cache/bindings/'.$itemid.'.xml';
	if (file_exists($fn))
	{
		//echo 'Load Existing Bindings...';
		$xml=simplexml_load_file($fn);
		
		foreach($xml->identity as $ident)
		{
			$obname = $ident->attributes()['path'];
			foreach($ident->property as $p)
			{
				$aid = $p->attributes()['boundasset'];
				$pid = $p->attributes()['boundproperty'];
				$existing[$obname.'.'.$p->attributes()['fromname']] = $aid.'-'.$pid;
			}	
		}
		
	}
		
	$alist = array();
	$query = $db->query("SELECT name,id FROM assets JOIN assetrelclosures ON (assetrelclosures.childasset = assets.id) WHERE assetrelclosures.parentasset=".$itemid);
	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$alist[] = $row;
	}	
	
	$ar = array();
	foreach($alist as $r)
	{
		$ar[] = $r['id'];
	}
	
	$ar[] = $itemid;
	
	$instring = implode(',',$ar);		
	
	$plist = array();
	foreach($ar as $as)
	{
		$ast = new Asset($as);
		$props = $ast->GetProperties();
		foreach($props as $p)
		{
			$p->origin = $as;
			$plist[] = $p;
		}
	}
	
	//echo 'Method: '.$_SERVER['REQUEST_METHOD'];
	
	if ($_SERVER['REQUEST_METHOD'] == 'POST')
	{		
		$modelprop = 0;
		
		$modelid = $mdl['model'];		
		
		//echo "SELECT value FROM assetvalues WHERE assetid=".$itemid." AND propertyid=".$modelprop;
		
		if ($modelid == 0) exit;
		//Get details of this model...
		
		//OK - save this binding!
		$xmlfile = $path_parts['dirname'].'/'.$path_parts['filename'].'.bindings';
			
		$xml=simplexml_load_file($xmlfile) or die("Error: Cannot create object");
		
		//echo 'Saving Binding...';
		//print_r($_REQUEST);
		
		$content = "<binding>\r\n";
		
		//print_r($xml);
		
		//echo $content;
		
		if (count($xml->identity) > 0)
		{
			//Multiple Identities			
			$x = 0;			
			
			foreach($xml->identity as $id)
			{											
				/*$newnm = "";
				foreach($alist as $a)
				{
					if ($a['id'] == $_REQUEST['ob'.$x])
					{
						$newnm = $a['name'];
					}
				}*/
							
				$content .= '  <identity path="'.$id->attributes()['path'].'">'."\r\n";
								
				$p=0;
				foreach($id->property as $prop)
				{
					foreach ($plist as $pq)
					{
						$parts = explode('-',$_REQUEST['ob'.$x.'prop'.$p]);
						$obj = $parts[0];
						$prp = $parts[1];
						if ($pq->id == $prp)
						{
							$content .= '		<property fromname="'.$prop->attributes()['name'].'" toname="'.$pq->name.'" boundasset="'.$obj.'" boundproperty="'.$prp.'"/>'."\r\n";
							break;
						}
					}
					$p++;
				}
				$content .= "  </identity>\r\n";
				$x++;
			}
		}
		
		$content .= "\r\n</binding>";
		
		//echo $content;
		if (!file_exists($sitefolder.'/cache/bindings'))
		{
			mkdir($sitefolder.'/cache/bindings');
		}
		file_put_contents($sitefolder.'/cache/bindings/'.$itemid.'.xml',$content);
		
		//echo 'Saved!';
		
		header("Location: ".$siteroot."/appearance/".$itemid);
		
		exit;
	}
?>

<!--<script>

var PropSet = [
<?php	
	$first = true;
	foreach($plist as $row)
	{
		if ($first == true)
			$first = false;
		else
			echo ", \r\n";
			
		echo '{  "name": "'.$row->name.'", "id": '.$row->id.' }';
	}

?>  ];

function LoadMatchingProperties(target,parent)
{	
	if (parent == "*")
	{
		alert('Bindings to Non-Child Objects Are Not Currently Supported');
		//$('#ob' + target).parent().append('<input type="text" style="height: 1.6em; margin-top: 5px; margin-bottom: 5px;"/>');
	}
	content = "";
	for(x=0;x<PropSet.length;x++)
	{
		if (PropSet[x].parent == parent)
		{
			content += "<option value=\"" + PropSet[x].id + "\">" + PropSet[x].name + "</option>";
		}
	}
		
	content += "<option value=\"0\">Not Bound</option>";
	
	$('.prop' + target).empty().append(content);
}
</script>-->

<?php
	$content = "";
		
	//Get the 'model' asset property...
	
	$modelprop = 0;
	$query = $db->query("SELECT id FROM properties WHERE typename='MODEL'");
	if($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$modelprop = $row['id'];
	}	
	
	if ($modelprop == 0) exit;
	
	//Get the model number for this asset...
	
	$modelid = 0;	
	$query = $db->query("SELECT value FROM assetvalues WHERE assetid=".$itemid." AND propertyid=".$modelprop);
	if($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$bits = explode('|',$row['value']);
		$modelid = $bits[0];
	}	
	
	//echo "SELECT value FROM assetvalues WHERE assetid=".$itemid." AND propertyid=".$modelprop;
	
	$ext = $path_parts['extension'];
	
	//echo 'Extension: '.$ext;
	
	if (strtoupper($ext) != "UNITY3D")
	{
		echo 'This model does not have any bindable components';
	}
	else
	{		
		//echo 'Scanning '.$path_parts['dirname'].'/'.$path_parts['filename'].'.bindings';
		$xmlfile = $path_parts['dirname'].'/'.$path_parts['filename'].'.bindings';
						
		if (file_exists($xmlfile))
		{
			$xml=simplexml_load_file($xmlfile) or die("Error: Cannot open ".$xmlfile);
					          
			$scriptnames = "";
						
			$first = false;
			$x = 0;
			if (count($xml->identity) > 0)
			{
				//Multiple Identities
					
				ST('ftable');
				//echo '<table style="text-align: left; width: auto;">';
				//echo '<tr><th style="padding-right: 10px;">In Model</th><th>In ARDI</th></tr>';				
								
				foreach($xml->identity as $id)
				{?>                
					<!--<tr><td style="padding-right: 10px;"><label><?php echo $id->attributes()['name']; ?>: </label></td><td><select name="ob<?php echo $x;?>"  onchange="LoadMatchingProperties(<?php echo $x; ?>,$(this).val());" style="text-align: left; padding: 2px;" id="ob<?php echo $x;?>"><?php
					echo '<option value="'.$itemid.'">This</option>';
					foreach($alist as $a)
					{						
						echo '<option value="'.$a['id'].'">'.$a['name'].'</option>';
					}
					//echo '<option value="*">Other</option>';
?></select></td></tr>-->
<?php
					$p=0;
					foreach($id->property as $prop)
					{
						//OK - find out if there is already an existing value for this one...
						$nm = $id->attributes()['name'].'.'.$prop->attributes()['name'];
						$nm2 = $id->attributes()['path'].'.'.$prop->attributes()['name'];
						$value = "";
						if (isset($existing[$nm2]))
						{
							$value = $existing[$nm2];
						}
						
						//Highlight columns where we transition from one bound sub-object to another...
						?>
						<tr<?php
							if ($first == true) echo ' style="border-top: 1px solid black;"';
							$first = false;
						?>><td style="padding-right: 10px;"><label><?php echo $nm; ?>: </label></td><td><select name="ob<?php echo $x;?>prop<?php echo $p;?>" class="prop<?php echo $x; ?>" style="text-align: left; padding: 2px;"><option value="">[ Not Bound ]</option><?php
						foreach($plist as $a)
						{
							//print_r($a);
							//if ($a['aid'] != $itemid) continue;
							$ast = new Asset($a->origin);
							$code = $a->origin.'-'.$a->id;
							echo '<option value="'.$code.'"';
							if ($value == $code) echo ' selected';
							echo '>'.$ast->name.'.'.$a->name.'</option>';
						}
	?></select></td></tr>
	<?php
						$p++;
					}
					$x++;
					$first = true;
				}	
				ET();
			}
			
			//echo "<script>\r\n  var names=[ ".$scriptnames." ];\r\n</script>";
			
		}
		else
		{
			echo '<h3>Unable to read any bindable components on this asset.</h3>';
		}
	}
	
	?>