<?php

//$editable = true;

$itemid = filter_var($_REQUEST['assetid'],FILTER_VALIDATE_INT);
if ($itemid === FALSE) exit;

include($installfolder.'/model/asset.php');
include($installfolder.'/model/property.php');

$thisasset = new Asset($itemid);
$thisasset->Load();

$title = $thisasset->name.' Properties';

//Create a label control that includes a link button
function Label($name,$itemid,$property,$editable = false)
{
	if ($editable == true)
		echo '<a class="linkbutton" href="#" onclick="PropertyMenu('.$property.',event,this); return false;"><i class="fa fa-caret-down linkbutton"/></a></td><td>';
	echo '<label>'.$name.'</label></td><td data-property="'.$property.'">';
	
}

if ($_SERVER['REQUEST_METHOD'] == 'POST')
{
	print_r($_REQUEST);
	if (isset($_REQUEST['refasset']))
	{
		if ($_REQUEST['action'] == 'delete')
		{
			if (isset($_REQUEST['refid']))
			{
				$ass = $_REQUEST['refasset'];
				$prp = $_REQUEST['refid'];
				$db->query("DELETE FROM assetreferences WHERE parentasset=".$itemid." AND childasset=".$ass." AND childproperty=".$prp);
			
				require_once($installfolder.'/include/cacheobject.php');	
				RebuildObjectCacheByID($itemid);
			}
		}
		else
		{
			if (isset($_REQUEST['refprop']))
			{
				$ass = $_REQUEST['refid'];
				$prp = $_REQUEST['refprop'];
				
				$db->query("INSERT INTO assetreferences (parentasset, childasset, childproperty) VALUES (".$itemid.",".$ass.",".$prp.")");
				
				require_once($installfolder.'/include/cacheobject.php');	
				RebuildObjectCacheByID($itemid);
			}
		}
	}
}

$perspective = true;

global $installfolder;

include($installfolder.'/include/tmpl.php');

//$title = 'Asset Detail';

?>

	<li class="active treeview">
	  <a href="/">
		<i class="fa fa-photo"></i> <span>Current Asset</span>
	  </a>
	  <ul class="treeview-menu">
		<li>
			<a href="<?php echo $siteroot;?>/diagram/<?php echo $itemid;?>/2"><i class="fa fa-circle-o"></i> Diagram</a>
			<a href="<?php echo $siteroot;?>/dashboard/<?php echo $itemid;?>"><i class="fa fa-circle-o"></i> Dashboard</a>
			<a href="<?php echo $siteroot;?>/detail/<?php echo $itemid;?>"><i class="fa fa-circle"></i> Detail</a>
			<a href="<?php echo $siteroot;?>/chart/<?php echo $itemid;?>"><i class="fa fa-circle-o"></i> Charts</a>
		</li>
	  </ul>
    </li>

<?php SS('sidebar');  ?>

$('a.popup-editor').attr('href','javascript://');

$('a.popup-editor').popover({
    "html": true,
    "content": function(){
        var div_id =  "tmp-id-" + $.now();
        return PopupEditor($(this).attr('data-url') + "&inplace=true", $(this).attr('data-name'), div_id);
    }
});

$('#properties').on('click','.popupedit',function( event ) {
	event.preventDefault();
	ReplaceWithEditor(this);
	return false;
});

<?php if ($perspective == true)
{?>
var assetlist = new Bloodhound({
  datumTokenizer: Bloodhound.tokenizers.obj.whitespace('text'),
  queryTokenizer: Bloodhound.tokenizers.whitespace,
  remote: '<?php echo $siteroot;?>/ajax/assetnamesearch?q=%QUERY',  
  //local: $.map(assets, function(state) { return { value: state }; })
});
 
// kicks off the loading/processing of `local` and `prefetch`
assetlist.initialize();

$("#lookitup").typeahead({
    	hint: true,
        highlight: true,
        minLength: 2
    },{
	    name: 'assets',
        displayKey: 'text',
        source: assetlist.ttAdapter(),
        templates: {
            empty: [
              '<div class="tt-suggestions" style="font-size: small;"><div class="tt-suggestion">This asset could not be found.</a>',
              '</div>'
            ].join('\n')            
        }        
    });
    
    var nm = $('#lookitup').attr('name');    
    
    $("#lookitup").on('typeahead:selected',function (evt,item) {    	
        $('#refid').val(item.id);
        SelectedAsset();
    });
    
    $("#lookitup").after('<input type="hidden" name="refid" id="refid"/>');
<?php
}?>

<?php SS('onload'); ?>
	<!--<script src="/plugins/bootstrap-tagsinput/bootstrap-tagsinput.min.js"></script>
	<script src="/plugins/typeahead/typeahead.jquery.js"></script>
	<script src="/plugins/typeahead/bloodhound.js"></script>-->
	<?php if ($editable == true) { ?>
	<script src="/plugins/optrix/fixedtagger.js"></script>
	<?php }; ?>
	<script src="/plugins/typeahead/typeahead.bundle.min.js"></script>
<?php
	SS('addscripts');?>
	<!--<link rel="stylesheet" href="/plugins/bootstrap-tagsinput/bootstrap-tagsinput.css">-->
	<link rel="stylesheet" href="/plugins/optrix/fixedtagger.css">
<?php
	SS('head');
?>

<script>
function PopupEditor(link,name, div_id){
    $.ajax({
        url: link,
        success: function(response){
            $('#'+div_id).html('<form method="POST" onsubmit="$(\'#squiggle\').click(); return false;" action="<?php echo $siteroot;?>/save/<?php echo $itemid; ?>/' + name + '" id="frm_' + div_id + '">' + response + '</form>');
        }
    });
    return '<div id="'+ div_id +'">Loading...</div>';
}

function ClosePopover(ob)
{
	var od = $(ob);
	var obx = od.closest('.popover');
	obx.popover('hide');
}

function SubmitPopover(ob)
{
	var od = $(ob);
	var frm = od.closest('form');
	var obx = od.closest('.popover');
	var nm = obx.attr('id');
	var link = frm.attr('action');
	//alert(frm.attr('method') + " / " + frm.serialize() + " / " + link);
	$.post(link,frm.serialize(),function(response){
			location.reload();
    }).error(function() { 
		alert("Error in AJAX Call"); 
	});
}

function ShowAllProperties()
{
	$('.unset').toggle();
}

var CurrentBackup = "";
var CurrentObject = null;

function SelectedAsset()
{
	var value = $('#lookitup').val();
	var id = $('#refid').val();
	
	//OK, update the list...
	$.post('<?php echo $siteroot; ?>/asset/propertylist',{ id: id },function(data) {
		$('#refprop').html(data);
	}).error(function () {
		$('#refprop').html('<option>Error Loading Properties</option>');
	});
}

function CloseExistingEditor()
{
	if (CurrentObject != null)
	{
		CurrentObject.html(CurrentBackup);
	}
	CurrentObject = null;
}

function ReplaceWithEditor(ob)
{
	var toreplace = $(ob).closest('td');
	CloseExistingEditor();
	CurrentBackup = toreplace.html();
	toreplace.html('<div class="editor" id="currenteditor">Loading...</div>');
	var link = '<?php echo $siteroot; ?>/edit/<?php echo $itemid; ?>/' + toreplace.attr('data-property');
	$.ajax({
        url: link,
        success: function(response){
            toreplace.html('<form method="POST" action="<?php echo $siteroot; ?>/save/<?php echo $itemid; ?>/' + toreplace.attr('data-property') + '" id="activepoppit">' + response + '</form>');
			
			$("#activepoppit").submit(function (e) {
				e.preventDefault();
				SubmitPoppit();
			});
        }
    });
	CurrentObject = toreplace;
}

function SubmitPoppit()
{
	var frm = $('#activepoppit');
	var link = frm.attr('action');
	$.post(link,frm.serialize(),function(response){
			CurrentBackup = response;
			CloseExistingEditor();
    }).error(function(request, status, error) { 
		alert(status); 
	});
	
}

function AddReference(ths)
{
	if ($('#referenceform').css('display') == 'none')
	{
		$('#referenceform').fadeIn(500);
	}
	else
	{
		var ob = $(ths);
		//alert('Trying To Submit On ' + ob.closest('form').length);
		
		ob.closest('form').submit();
	}
}

function ReloadTagValues()
{
	//alert('Saving Tags: ' + $('#tags').val());
	$.post('<?php echo $siteroot;?>/asset/tag',{id: <?php echo $itemid; ?>, tags: $('#tags').val()},function(response){
		//alert(response);	
    }).error(function() { 
		alert("Error Saving Tag Details"); 
	});
}

function RemoveReference(ass,prp)
{
	$('#refaction').val('delete');
	$('#refprop').val(prp);
	$('#refid').val(prp);
	$('#lookitup').val(ass);
	$('#refform').submit();
}
</script>

<?php 

if ($editable == true)
{
	if ($thisasset->description == "")
	{
		$thisasset->description = "Click Here To Set A Description";
	}
}


T('header-basic','title='.$title);

	ST('section','class=content');
		ST('row');
			ST('full');
				ST('box','title=Details');
?>
							<h3><?php if ($editable == true) { ?><a href="javascript://" role="button" data-url="<?php echo $siteroot;?>/edit/<?php echo $itemid;?>/name" data-placeholder="Asset Name" data-emptytext="No Name" data-value="<?php echo $thisasset->name; ?>" data-title="Enter Name" class="popup-editor" id="name" data-name="name"><?php  }; echo $thisasset->name;?><?php if ($editable == true) { ?></a><?php }; ?></h3>
                           	<h4><?php if ($editable == true) { ?><a href="javascript://" role="button" data-type="textarea" data-pk="<?php echo $itemid;?>" data-url="<?php echo $siteroot;?>/edit/<?php echo $itemid;?>/desc" data-placeholder="Asset Description" data-emptytext="No Description" data-value="<?php echo $thisasset->description; ?>" data-title="Enter Description" class="popup-editor" id="desc" data-name="desc"><?php  }; echo $thisasset->description;?><?php if ($editable == true) { ?></a><?php }; ?></h4>
                            
                            <p style="margin-bottom: 2px;">
    <?php
	
	$dta = $thisasset->GetProperties();
	$thisasset->GetValues($dta);
	$tags = $thisasset->GetDirectTagIDs();
	$prps = Properties::GetAllProperties();
					
	?>
	 <p>
							<!--<input type="text" id="assettags"/>-->
		<div class="tagcontrol"<?php if ($editable == false) echo ' style="background-color: transparent;"';?>>			
			<?php
			foreach($tags as $t)
			{
				echo '<div class="tag" id="tag'.$t.'"';
				if ($editable == false) echo ' style="padding-right: 10px;"';
				echo '>';
				$otherasset = new Asset($t);
				echo $otherasset->name;
				if ($editable == true) echo '<a href="#" data-value="'.$t.'" onclick="DeleteTag(this); return false;"><i class="fa fa-minus-circle"></i></a>';
				echo '</div>';
			}?>
			
			<?php if ($editable == true) { ?><div id="addtag"><select id="newtag" class="display: none;"><option></option><?php
			$filter = "";
			if (count($tags) > 0)
			{
				$filter = "AND id NOT IN (".implode(',',$tags).") ";
			};
			
			$query = $db->query('SELECT name,id FROM assets WHERE type=1 '.$filter.'ORDER BY name');
			while($row = $query->fetch(PDO::FETCH_ASSOC)) 
			{
				echo '<option value="'.$row['id'].'">'.$row['name'].'</option>';
			};
			?></select><a href="javascript://" onclick="AddTag(); return false;"><i class="fa fa-plus-circle"></i></a></div><?php }; ?>
			<input type="hidden" name="tags" id="tags" value="<?php echo implode(',',$tags);?>"/>
		</div>
							
							</p>
<?php
				ET();
			ET();
		ET();
		
		ST('row');
			
			ST('half');
				ST('box','title=Properties');
					
					?>
					
					<?php if ($editable == true) { ?>
					<a href="#" onclick="ShowAllProperties(); return false;" class="btn btn-success" title="Display All Empty Properties">Show All Properties</a>
<?php				};
					SS('footer');
					echo '<div id="properties">';
					ST('table');
					?>
						
						<tr><?php if ($editable == true) echo '<th>&nbsp;</th>'; ?><th style="width: 25%">Name</th><th style="width: 100%">Value</th></tr>
<?php					
						foreach($prps as $p)
						{
							if ($p->type == "LOCATION") continue;
							if ($p->type == "APPEARANCE") continue;
							if ($p->type == "MODEL") continue;
							
							$found = false;
							if (is_array($dta)) {
								foreach($dta as $d)
								{
									if ($d->id == $p->id) {
										if (($d->origintype != "local") && ($d->origintype != "template")) continue;?>
									<tr><td><?php
											$name = $d->name;
											$propid = $d->id;
											$value = $d->value;
											$cnt = "";
											
											Label($name,$itemid,$propid,$editable);
			
											include($installfolder.'/modules/'.strtolower($d->type).'.php');
											
									?></td></tr><?php
										$found = true;
										break;
									};
								};
							};
							if ($found == false)
							{
								echo '<tr class="unset"><td>';
								if ($editable == true)
								{
									echo '</td><td>';
								}
								echo $p->name.'</td><td data-property="'.$p->id.'"><a href="javascript://" class="popupedit">Not Set</a></td></tr>';
							};
						}
						
					ET();
					echo '</div>';
				ET();
				
			
				if ($perspective == true)
				{
				ST('boxform','title=References|id=refform');
				ST('table');
					$query = $db->query('SELECT childasset, childproperty FROM assetreferences WHERE parentasset='.$itemid);
					if ($query !== FALSE)
					{
						while($row = $query->fetch(PDO::FETCH_ASSOC)) 
						{
							$otherasset = new Asset($row['childasset']);
							$prname = "Unknown";
							foreach($prps as $p)
							{
								if ($p->id == $row['childproperty'])
								{
									$prname = $p->name;
									break;
								}
							}
							echo '<tr><td><a href="/dashboard/'.$row['childasset'].'">'.$otherasset->name.'.'.$prname.'</td><td><a href="#" data-id="'.$row['childasset'].'-'.$row['childproperty'].'" onclick="RemoveReference('.$row['childasset'].','.$row['childproperty'].'); return false;"><i class="fa fa-trash"></i></a></td></tr>';
						};
					};?>				
<?php			ET();
				?>
				<input type="hidden" name="action" id="refaction" value="add"/>
				<div class="popunder" id="referenceform" style="display: none;"><?php
					ST('table');?>
						<tr><td><label>Asset:</label></td><td><input type="text" id="lookitup" name="refasset"/></td></tr>
						<tr><td><label>Property:</label></td><td><select id="refprop" name="refprop"><option>Choose An Asset First</option></select></td></tr>
<?php				ET();
				?>
				</div>
				<a href="#" class="btn btn-success" onclick="AddReference(this); return false;">Add Reference</a>
				<?php
				SS('footer');
					ST('table');
					ET();
					
				ET();
				}
			ET();
			
			include('detail-navigation.php');
		ET();
	ET(); ?>
	
	<script>
<?php //Update information ?>
	
var selectedproperty;
	
function LinkToSource()
{
	window.location = "<?php echo $siteroot;?>/data/connect?asset=<?php echo $itemid; ?>&property=" + selectedproperty;
}

function RemoveProperty()
{
	//alert('Removing Property!');
	
	$.post('<?php echo $siteroot;?>/asset/removeprop',{asset:<?php echo $itemid; ?>, property: selectedproperty}, function(data) { 
		if (data != "") alert(data);
		location.reload();
	});
}
	
function PropertyMenu(propid,e,o)
{
	selectedproperty = propid;
	
	var ob = $('#propmenu');	
	var off = $(o).offset();
	off.top += $(o).height();
	ob.css('left',off.left + "px");
	ob.css('top',off.top + "px");
	ob.fadeIn(500);
}

</script>

<div id="propmenu" style="display: none;">
	<a href="#" onclick="LinkToSource(); return false;" class="btn btn-primary">Link To...</a><br/>
    <a href="#" onclick="RemoveProperty(); return false;" class="btn btn-default">Remove...</a><br/><hr style="margin: 0px; padding: 0px;"/>
        <a href="#" onclick="$('#propmenu').fadeOut(500); return false;" class="btn btn-success">Cancel</a>
</div>