<?php

//$editable = true;

$itemid = filter_var($_REQUEST['assetid'],FILTER_VALIDATE_INT);
if ($itemid === FALSE) exit;

include($installfolder.'/model/asset.php');

$thisasset = new Asset($itemid);
$thisasset->Load();

$title = $thisasset->name.' Data Sources';

global $installfolder;

include('include/tmpl.php');

//$title = 'Asset Detail';

?>

	<li class="active treeview">
	  <a href="/">
		<i class="fa fa-photo"></i> <span>Current Asset</span>
	  </a>
	  <ul class="treeview-menu">
		<li>
			<a href="<?php echo $siteroot;?>/diagram/<?php echo $itemid;?>/2"><i class="fa fa-circle-o"></i> Diagram</a>
			<a href="<?php echo $siteroot;?>/dashboard/<?php echo $itemid;?>"><i class="fa fa-circle-o"></i> Dashboard</a>
			<a href="<?php echo $siteroot;?>/detail/<?php echo $itemid;?>"><i class="fa fa-circle"></i> Detail</a>
			<a href="<?php echo $siteroot;?>/chart/<?php echo $itemid;?>"><i class="fa fa-circle-o"></i> Charts</a>
		</li>
	  </ul>
    </li>

<?php SS('sidebar');  

T('header-basic','title='.$title);

	ST('section','class=content');
		ST('row');
			ST('half');
				ST('box','title=Data Sources');
				
					ST('ftable');
					
	$activesources = array();
	
	$query = $db->query('SELECT * FROM datasources WHERE assetid='.$itemid);

	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$activesources[$row['profile']][$row['mode']] = $row;
	}
	
	//print_r($activesources);

?>                
     <?php /*if ($editable == true) { ?><a href="<?php echo $siteroot; ?>/data/datasource?id=<?php echo $itemid;?>"><?php echo $vl; ?></a> <?php
	 if (isset($address))
	 {
		$rt = $row['samplerate'];
		echo ' ( ';
		echo '<a href="#" data-type="text" data-pk="'.$itemid.'" data-url="/modules/save/urate.php" data-placeholder="Update Rate" data-emptytext="'.$vl.'" data-value="'.$rt.'" data-title="Update Rate (seconds)" class="popupedit" id="rate" data-name="rate">';
		if ($row['samplerate'] != -1) 
			echo $row['samplerate'].' second updates';
		else
			echo 'default update rate';
		
		echo '</a> )';
	 } }; */
					
	$query = $db->query("SELECT id,name FROM profiles ORDER BY name");
	
	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{?>
		
		<?php
		$mode = 0;
		while(true)
		{
			echo '<tr><td><label>'.$row['name'];
			
			if ($mode == 0) 
				echo ' - Live';
			else
				echo ' - Historical';
				
			echo '</label></td><td>';
			
			$found = false;
			if (isset($activesources[$row['id']]))
			{
				if (isset($activesources[$row['id']][$mode]))
				{
					//Hello, we have a source here.
					$found = true;
					
					$rx = $activesources[$row['id']][$mode];
					$address = $rx['address'];
					
					$fldr = "live";
					if ($rx['mode'] == 1) $fldr = "historical";
					if ($rx['mode'] == 10) $fldr = "asset";
		
					include($installfolder.'/data/'.$fldr.'/'.$rx['driver'].'/friendlyname.php');
					
					echo '<strong>'.$friendlyname.'</strong>';
					if ($mode == 0)
					{
						echo '<br/>';
						if ($rx['samplerate'] != -1) 
							echo 'With '.$rx['samplerate'].' second updates';
						else
							echo 'With default update rate';
					};
						
					echo '<br/>';
					echo '<a href="'.$siteroot.'/data/datasource?id='.$itemid.'&profile='.$row['id'].'&mode='.$mode.'" style="margin-top: 10px;" class="btn btn-success">Reconfigure</a>';
					if ($rx['mode'] == 0) echo '&nbsp;&nbsp;<a href="'.$siteroot.'/data/datarate?id='.$itemid.'&profile='.$row['id'].'&mode='.$mode.'" style="margin-top: 10px;" class="btn btn-success">Timing / Rate</a>';
				}
			}
			
			if ($found == false)
			{
				echo '<a href="'.$siteroot.'/data/datasource?id='.$itemid.'&profile='.$row['id'].'&mode='.$mode.'" class="btn btn-default">Create</a>';
			}
			
			echo '</td></tr>';
			
			if ($mode == 0)
				$mode = 1;
			else
				break;

		};
	}	
					
					ET();
	
				ET();	
			ET();
			include('detail-navigation.php');
		ET();
	ET(); ?>