<?php
/**
 * Creates a new asset based on an existing Bundle file
 *
 * @author Steven Harding
 */
						
	$childid = 0;
	
	$rel = 0;
	if (isset($_REQUEST['rel']))
	{
		$rel = $_REQUEST['rel'];
	}
	
	if (isset($_REQUEST['child']))
	{
		$child = $_REQUEST['child'];
	}
	
	function Unzip($filename, $outpath, $destiny="")
	{
		//global $rlog;
		//global $dbfile;
		global $sitefolder;
		$outpath .= DIRECTORY_SEPARATOR;
		$path_file = $filename;
		
		$finalpath = str_replace("\\","/",$path_file);
		
		$dir = $outpath;
		
		$ln = strlen($outpath);
		
		$zip = new ZipArchive();
		//$za = $zip->open($finalpath,ZipArchive::CHECKCONS);
		$za = $zip->open($finalpath);
		if ($za !== TRUE)
		{
			echo 'Failed to Open ZIP File '.$finalpath;
			if ($za == ZipArchive::ER_INCONS) 
				echo 'ZIP Archive is Inconsistent';
			else
				echo 'Could Not Open ZIP Archive - Error Code '.$za;
			return false;
		}
		
		for ($i = 0; $i < $zip->numFiles; $i++) {
			 $name = $zip->getNameIndex($i);
			 if ($name === FALSE) continue;
			 
		     $path_file = str_replace('/',DIRECTORY_SEPARATOR,$name);			 
			 
			 $info = pathinfo($path_file);			
			 $fname = $info['basename'];
			 $new_dir = $info['dirname'];
			
			//echo 'Directory: '.$new_dir.'<br/>';

			$bits = explode(DIRECTORY_SEPARATOR,$new_dir);
			
			$dest = $sitefolder.'/restore/';
			
			//echo 'Copying To: '.$dest.'<br/>';
			
			if ($dest == "") continue;
			$new_dir = $dest;
			
			//echo 'Extracting '.$name.' to '.$dest.'<br/>';
			$zip->extractTo($dest,$name);
 		}
		
		$zip->close();		
		return true;
	}
	
	$error = "";
		
	if (($_SERVER['REQUEST_METHOD'] == 'POST') && (isset($_REQUEST['name'])))
	{
		if (isset($_FILES['file']))
		{
			echo 'File Located - Bundle Restore Begun!';
			
			//Find a nice place to extract the ZIP archive...
			
			$pth = $sitefolder.'/restore';
			if (!file_exists($pth))
			{
				mkdir($pth);
			}
			
			if (file_exists($pth.'/restore.zip'))
			{
				unlink($pth.'/restore.zip');
			}	
			
			$restorepath = $pth.'/restore.zip';
			
			move_uploaded_file($_FILES['file']['tmp_name'],$restorepath);
			
			//Unzip the archive file
			
			if (Unzip($restorepath,$installfolder) == false)
			{
				exit;
			}
			
			//Check the archive file for unbound items
			
			//readfile($sitefolder.'/restore/content.txt');
			
			$disconnected = array();
			
			$file = fopen($sitefolder.'/restore/content.txt',"r");
			$lastpos = array();
			$changed = array();
			
			$lineno = 0;
			while(!feof($file))
			{

				$lines = fgetcsv($file,0,"\t");
				$lineno++;
				$validchanges = false;
				
				if (count($lines) < 3) continue;
				
				for($x=0;$x<count($lines);$x++)
				{
					$changed[$x] = false;
				}
				
				//Find if particular columns have changed...
				for($x=0;$x<count($lines);$x++)
				{
					if (trim($lines[$x]) != "")
					{
						$lastpos[$x] = $lines[$x];
						$changed[$x] = true;
						$validchanges = true;
					}
					else
					{
						if (isset($lastpos[$x]))
						{
							if ($validchanges == false)
							{
								$changed[$x] = false;
								$lines[$x] = $lastpos[$x];
							}
						}
					}
				}
				
				if ($lines[2] == "*")
				{
					//Open Connection
					$m = array();
					$m['type'] = 'Relationship';
					$m['name'] = $lines[1];
					$m['asset'] = $lines[0];
					$m['line'] = $lineno;
					$disconnected[] = $m;
				}
				
				if (count($lines) >= 4)
				{
					if ($lines[3][0] == '>')
					{
						$bits = explode('>',$lines[3]);
						//Is this internal, or external?
						$m['type'] = 'Binding';
						$m['name'] = $lines[1].' '.$lines[2];
						$m['asset'] = $lines[0];
						$m['profile'] = 'Actual';
						$m['mode'] = 'Live';
						$m['source'] = $bits[3];
						$m['addr'] = $bits[4];
						$m['line'] = $lineno;
						
						if ($bits[3] != '*') continue;
						if ($bits[1] != 'Actual') continue;
						if ($bits[2] == 'hist') $m['mode'] = 'Hist.';
						$disconnected[] = $m;
					}
				}
			}
			
			//Take a look at the TXT file - find disconnected items...
			
			if (count($disconnected) > 0)
			{
				//Stop here and ask questions.
				
	$title = 'Connect To Your System';

	include($installfolder.'/include/tmpl.php'); 

	ST('section','class=content');
		ST('row');
			echo '<form method="POST" enctype="multipart/form-data">';
			ST('half'); ?>
				<form method="POST"><?php
				ST('box','title=Connections');?>
					<input type="submit" value="Connect Asset(s)" class="btn btn-success"/><?php
					SS('footer');
					ST('ftable');
						foreach($disconnected as $disc)
						{
							if ($disc['type'] != 'Relationship') continue;
							echo '<tr><td>'.$disc['asset'].' '.$disc['name'].'</td><td><input type="text" id="" class="location" name="ovr_'.$disc['line'].'"/></td></tr>';
						}
					ET();
				ET();
			ET();
			ST('half'); 
			
			$sourcelist = array();
			
			$query = $db->query('SELECT assetid,assets.name,profile,mode FROM datasources JOIN assets ON (assets.id = datasources.assetid) ORDER BY assets.name');

			while($row = $query->fetch(PDO::FETCH_ASSOC))
			{
				$sourcelist[] = $row;
			}	
			?>
				<?php
				ST('box','title=Data');
					ST('ftable');
						foreach($disconnected as $disc)
						{
							if ($disc['type'] != 'Binding') continue;
							echo '<tr><td>'.$disc['asset'].' '.$disc['profile'].' '.$disc['mode'].' '.$disc['name'].'</td>';
							echo '<td><select name="ovr_'.$disc['line'].'"><option value="0">No Connection</option>';
							foreach($sourcelist as $src)
							{
								$pro = 1;
								if ($src['profile'] != $pro) continue;
								$md = 0;
								if ($disc['mode'] == 'Hist.') $md = 1;
								if ($src['mode'] != $md) continue;
								
								echo '<option value="'.$src['assetid'].'">'.$src['name'].'</option>';
							}
							echo '</select></td></tr>';
						}
					ET();
				ET();
			ET();
			echo '</form>';
		ET();
	ET();

				exit;
			}
			
			//Import the TXT file with the given overrides
			
			//Restore the data files (given the ID remapping)
			
			//Update caches on the new items
			
			exit;
		}
	}
		
	$atype = "Asset";
		
	$title = 'Add Bundled Asset(s)';

	include($installfolder.'/include/tmpl.php'); 

	ST('section','class=content');
		ST('row');
		echo '<form method="POST" enctype="multipart/form-data">';
			ST('half'); ?>
				<form method="POST"><?php
				ST('box','title=Select Bundle File');
					if ($childid != 0)
					{ ?>
			<input type="submit" value="Create Asset From Bundle" class="btn btn-success"/><input type="hidden" name="child" value="<?php echo $childid; ?>"/><input type="hidden" name="rel" value="<?php echo $rel; ?>"/><?php
					}
					else
					{?>
			<input type="submit" value="Create Asset From Bundle" class="btn btn-success"/><?php
					};
					
					SS('footer');
					ST('ftable');?>
	<tr><td><label>Name:</label></td><td><input type="text" value="<?php
	if (isset($_REQUEST['name']))
	{
		echo $_REQUEST['name'];
	}
	?>" id="name" name="name"/>
	</td></tr>
    <tr><td><label>Bundle File:</label></td><td><input type="file" name="file"></td></tr>
	       
    <?php
					ET();
	
	
	//if ((isset($rel)) && ($rel != 0)) echo '<input type="hidden" name="relationship" value="'.$rel.'"/>';
			
				ET();
			ET();
		echo '</form>';
		ET();
	ET();
?>