<?php

//$editable = true;

$itemid = filter_var($_REQUEST['assetid'],FILTER_VALIDATE_INT);
if ($itemid === FALSE) exit;

include($installfolder.'/model/asset.php');

$thisasset = new Asset($itemid);
$thisasset->Load();

if ($editable == false)
{
	header('Location: '.$siteroot.'/dashboard/'.$itemid);
	exit;
}

$title = 'Edit '.$thisasset->name;

global $installfolder;

//Create a label control that includes a link button
function Label($name,$itemid,$property,$editable = false, $present = true)
{
	if ($editable == true)
		echo '<a class="linkbutton" href="#" onclick="PropertyMenu('.$property.',event,this); return false;"><i class="fa fa-caret-down linkbutton"/></a></td><td>';
	echo '<label';
	if ($present == false) echo ' style="font-weight: normal;"';
	echo '>'.$name.'</label></td><td data-property="'.$property.'">';
	
}

include('include/tmpl.php');

?>
	var assetlist = new Bloodhound({
	  datumTokenizer: Bloodhound.tokenizers.obj.whitespace('text'),
	  queryTokenizer: Bloodhound.tokenizers.whitespace,
	  remote: '<?php echo $siteroot;?>/ajax/assetnamesearch?q=%QUERY',  
	});
	 
	// kicks off the loading/processing of `local` and `prefetch`
	assetlist.initialize();
	
	$('.lookupfield').typeahead({
    	hint: true,
        highlight: true,
        minLength: 2
    },{
	    name: 'assets',
        displayKey: 'text',
        source: assetlist.ttAdapter(),
        templates: {
            empty: [
              '<div class="tt-suggestions" style="font-size: small;"><div class="tt-suggestion">No Matching Asset Found</div>'
            ].join('\n'),
			suggestion: function(data){
				return '<p class="searchresult">' + data.text + '<span>' + data.path + '</span></p>';
			}            
        }        
    });
	
	$(".lookupfield").on('typeahead:selected',function (evt,item) {    	
        SaveRelationship(item.id,evt.target.name.substr(4));//alert('Saving Relationship - ' + evt.target.name + " / " + item.id)
    });
	
	$('a.popup-editor').attr('href','javascript://');

	$('a.popup-editor').popover({
		"html": true,
		"content": function(){
			var div_id =  "tmp-id-" + $.now();
			return PopupEditor($(this).attr('data-url') + "&inplace=true", $(this).attr('data-name'), div_id);
		}
	});

	$('#properties').on('click','.popupedit',function( event ) {
		event.preventDefault();
		ReplaceWithEditor(this);
		return false;
	});
<?php
            
    SS('onload');  ?>
	<script src="/plugins/typeahead/typeahead.bundle.min.js"></script>
<?php SS('addscripts');

?>
	<li class="active treeview">
	  <a href="/">
		<i class="fa fa-photo"></i> <span>Current Asset</span>
	  </a>
	  <ul class="treeview-menu">
		<li>
			<a href="<?php echo $siteroot;?>/diagram/<?php echo $itemid;?>/2"><i class="fa fa-circle-o"></i> Diagram</a>
			<a href="<?php echo $siteroot;?>/dashboard/<?php echo $itemid;?>"><i class="fa fa-circle-o"></i> Dashboard</a>
			<a href="<?php echo $siteroot;?>/detail/<?php echo $itemid;?>"><i class="fa fa-circle"></i> Detail</a>
			<a href="<?php echo $siteroot;?>/chart/<?php echo $itemid;?>"><i class="fa fa-circle-o"></i> Charts</a>
		</li>
	  </ul>
    </li>

<?php SS('sidebar');  

T('header-basic','title='.$title);

?>
<script>
function PopupEditor(link,name, div_id){
    $.ajax({
        url: link,
        success: function(response){
            $('#'+div_id).html('<form method="POST" onsubmit="$(\'#squiggle\').click(); return false;" action="<?php echo $siteroot;?>/save/<?php echo $itemid; ?>/' + name + '" id="frm_' + div_id + '">' + response + '</form>');
        }
    });
    return '<div id="'+ div_id +'">Loading...</div>';
}

function ClosePopover(ob)
{
	var od = $(ob);
	var obx = od.closest('.popover');
	obx.popover('hide');
}

function SubmitPopover(ob)
{
	var od = $(ob);
	var frm = od.closest('form');
	var obx = od.closest('.popover');
	var nm = obx.attr('id');
	var link = frm.attr('action');
	//alert(frm.attr('method') + " / " + frm.serialize() + " / " + link);
	$.post(link,frm.serialize(),function(response){
			location.reload();
    }).error(function() { 
		alert("Error in AJAX Call"); 
	});
}

var CurrentBackup = "";
var CurrentObject = null;

function SelectedAsset()
{
	var value = $('#lookitup').val();
	var id = $('#refid').val();
	
	//OK, update the list...
	$.post('<?php echo $siteroot; ?>/asset/propertylist',{ id: id },function(data) {
		$('#refprop').html(data);
	}).error(function () {
		$('#refprop').html('<option>Error Loading Properties</option>');
	});
}

function CloseExistingEditor()
{
	if (CurrentObject != null)
	{
		CurrentObject.html(CurrentBackup);
	}
	CurrentObject = null;
}

function ReplaceWithEditor(ob)
{
	var toreplace = $(ob).closest('td');
	CloseExistingEditor();
	CurrentBackup = toreplace.html();
	toreplace.html('<div class="editor" id="currenteditor">Loading...</div>');
	var link = '<?php echo $siteroot; ?>/edit/<?php echo $itemid; ?>/' + toreplace.attr('data-property');
	$.ajax({
        url: link,
        success: function(response){
            toreplace.html('<form method="POST" action="<?php echo $siteroot; ?>/save/<?php echo $itemid; ?>/' + toreplace.attr('data-property') + '" id="activepoppit">' + response + '</form>');
			
			$("#activepoppit").submit(function (e) {
				e.preventDefault();
				SubmitPoppit();
			});
        }
    });
	CurrentObject = toreplace;
}

function SubmitPoppit()
{
	var frm = $('#activepoppit');
	var link = frm.attr('action');
	$.post(link,frm.serialize(),function(response){
			CurrentBackup = response;
			CloseExistingEditor();
			location.reload();
    }).error(function(request, status, error) { 
		alert(status); 
	});
	
}

function AddReference(ths)
{
	if ($('#referenceform').css('display') == 'none')
	{
		$('#referenceform').fadeIn(500);
	}
	else
	{
		var ob = $(ths);
		//alert('Trying To Submit On ' + ob.closest('form').length);
		
		ob.closest('form').submit();
	}
}

function ReloadTagValues()
{
	//alert('Saving Tags: ' + $('#tags').val());
	$.post('<?php echo $siteroot;?>/asset/tag',{id: <?php echo $itemid; ?>, tags: $('#tags').val()},function(response){
		//alert(response);	
    }).error(function() { 
		alert("Error Saving Tag Details"); 
	});
}

function SaveRelationship(to,rel)
{
	//alert('Saving Relationship Between <?php echo $itemid; ?> and ' + to + " via " + rel);
	$.post('<?php echo $siteroot; ?>/asset/link',{origin: to, newreltarget: <?php echo $itemid; ?>, relationship: rel, returnto: 'silent' },function(response){
		if (response != "OK") alert("Error Saving Relationship: " + response);	
		location.reload();
    }).error(function() { 
		alert("Error Saving Relationship"); 
	});
}

function RemoveReference(ass,prp)
{
	$('#refaction').val('delete');
	$('#refprop').val(prp);
	$('#refid').val(prp);
	$('#lookitup').val(ass);
	$('#refform').submit();
}
</script><?php

	ST('section','class=content');
		ST('row');
		 
			ST('half');
				ST('box','title=Properties|action='.$siteroot.'/asset/link');?>
					<input type="hidden" value="<?php echo $itemid; ?>" name="origin"/>
					<a href="<?php echo $siteroot; ?>/diagram/<?php echo $itemid; ?>/2" class="btn btn-default">Diagram</a>
					<a href="<?php echo $siteroot; ?>/dashboard/<?php echo $itemid; ?>" class="btn btn-default">Dashboard</a>
					<?php
					SS('footer');
					?><div id="properties"><?php 
					ST('ftable');
					
	include($installfolder.'/model/property.php');
	
	$dta = $thisasset->GetProperties();
	$thisasset->GetValues($dta);
	$tags = $thisasset->GetDirectTagIDs();
	$prps = Properties::GetAllProperties();
	
	foreach($prps as $p)
	{
		if ($p->type == "LOCATION") continue;
		if ($p->type == "APPEARANCE") continue;
		if ($p->type == "MODEL") continue;
		if ($p->type == "ISOPOINT") continue;
		if ($p->type == "LAYOUT") continue;
		
		$found = false;
		if (is_array($dta)) {
			foreach($dta as $d)
			{
				if ($d->id == $p->id) {
					if (($d->origintype != "local") && ($d->origintype != "template")) continue;?>
				<tr><td><?php
						$name = $d->name;
						$propid = $d->id;
						$value = $d->value;
						$cnt = "";
						
						Label($name,$itemid,$propid,$editable,true);

						include($installfolder.'/modules/'.strtolower($d->type).'.php');
						
				?></td></tr><?php
					$found = true;
					break;
				};
			};
		};
		if ($found == false)
		{
			echo '<tr><td>';
			if ($editable == true)
			{
				echo '&nbsp;</td><td>';
			}
			echo $p->name.'</td><td data-property="'.$p->id.'"><a href="javascript://" class="popupedit">Not Set</a></td></tr>';
		};
	};		
					ET();
	?> </div> <?php
				ET();
			ET();
			ST('half');
			
				include($installfolder.'/model/relationship.php');
				$rellist = Relationships::GetAll();
				$active = $thisasset->GetRelationships();
				
				foreach($rellist as $rl)
				{
					if ($rl->type == 'heirachial')
					{
						//Does one exist already?
						if (isset($active[$rl->id]))
						{
							$found = false;
							foreach($active[$rl->id] as $r)
							{
								if ($r['upstream'] == true)
								{
									$found = true;
									break;
								}
							}
							if ($found == true) continue;
						}
						ST('box','title='.$rl->name.'|action='.$siteroot.'/asset/link');?>
				<?php
							//echo '<form method="POST" action="">';
							ST('ftable');?>
				<tr><td><label>This Is <?php echo $rl->upname;?></label></td><td><input type="text" name="rel-<?php echo $rl->id; ?>" class="lookupfield" style="border: 1px solid black; border-radius: 3px; padding: 3px; position: relative; left: -3px;"/><input type="hidden" name="newreltarget" id="looktarg"/></td></tr>
				</td></tr>
<?php						ET();
					//echo '</form>';
						ET();
					}
				}
						ST('box','title=Physical Relationships|action='.$siteroot.'/asset/link');?>
				<?php
							echo '<form method="POST" action="">';
							ST('ftable');
							
				foreach($rellist as $rl)
				{
					if ($rl->type == 'physical')
					{
						
						?>
				<tr><td><label><?php echo $rl->name; ?> - <?php echo $rl->upname;?></label></td><td><input type="text" name="rel-<?php echo $rl->id; ?>" class="lookupfield" style="border: 1px solid black; border-radius: 3px; padding: 3px; position: relative; left: -3px;"/><input type="hidden" name="newreltarget" id="looktarg"/></td></tr>
				</td></tr>
<?php						
					//Show pre-existing relationships...
							if (isset($active[$rl->id]))
							{
								foreach($active[$rl->id] as $r)
								{
									if ($r['upstream'] != true)
									{
										continue;
									}	
								}
								echo '<tr><td>&nbsp;</td><td>';
								$other = new Asset($r['target']);
								
								echo $other->name;
								echo '<a href="'.$siteroot.'/asset/unlink?asset='.$itemid.'&other='.$r['target'].'&rel='.$rl->id.'&editing='.$itemid.'&returnto=editor"><i class="fa fa-minus-circle" style="margin-left: 0.4em;"></i></a>';
								echo '</td></tr>';
							}
							
					}
				}
							ET();
					echo '</form>';
						ET();
						
				ST('box','title=Logical Relationships|action='.$siteroot.'/asset/link');?>
				<?php
							echo '<form method="POST" action="">';
							ST('ftable');
							
				foreach($rellist as $rl)
				{
					if ($rl->type == 'logical')
					{
						
						?>
				<tr><td><label><?php echo $rl->name; ?> - <?php echo $rl->upname;?></label></td><td><input type="text" name="rel-<?php echo $rl->id; ?>" class="lookupfield" style="border: 1px solid black; border-radius: 3px; padding: 3px; position: relative; left: -3px;"/><input type="hidden" name="newreltarget" id="looktarg"/></td></tr>
				</td></tr>
<?php						
					//Show pre-existing relationships...
							if (isset($active[$rl->id]))
							{
								foreach($active[$rl->id] as $r)
								{
									if ($r['upstream'] != true)
									{
										continue;
									}	
								}
								echo '<tr><td>&nbsp;</td><td>';
								$other = new Asset($r['target']);
								
								echo $other->name;
								echo '<a href="'.$siteroot.'/asset/unlink?asset='.$r['target'].'&other='.$itemid.'&rel='.$rl->id.'&editing='.$itemid.'&returnto=editor"><i class="fa fa-minus-circle" style="margin-left: 0.4em;"></i></a>';
								echo '</td></tr>';
							}
							
					}
				}
							ET();
					echo '</form>';
						ET();
			
				
			ET();
			
		ET();
	ET(); ?>
<script>
var selectedproperty;
	
function LinkToSource()
{
	window.location = "<?php echo $siteroot;?>/data/connect?asset=<?php echo $itemid; ?>&property=" + selectedproperty;
}

function RemoveProperty()
{
	//alert('Removing Property!');
	
	$.post('<?php echo $siteroot;?>/asset/removeprop',{asset:<?php echo $itemid; ?>, property: selectedproperty}, function(data) { 
		if (data != "") alert(data);
		location.reload();
	});
}
	
function PropertyMenu(propid,e,o)
{
	selectedproperty = propid;
	
	var ob = $('#propmenu');	
	var off = $(o).offset();
	off.top += $(o).height();
	ob.css('left',off.left + "px");
	ob.css('top',off.top + "px");
	ob.fadeIn(500);
}

</script>

<div id="propmenu" style="display: none;">
	<a href="#" onclick="LinkToSource(); return false;" class="btn btn-primary">Link To...</a><br/>
    <a href="#" onclick="RemoveProperty(); return false;" class="btn btn-default">Remove...</a><br/><hr style="margin: 0px; padding: 0px;"/>
        <a href="#" onclick="$('#propmenu').fadeOut(500); return false;" class="btn btn-success">Cancel</a>
</div>