<?php
$fromid = filter_var($_REQUEST['from'],FILTER_VALIDATE_INT);
if ($fromid === FALSE) exit;

$toid = filter_var($_REQUEST['to'],FILTER_VALIDATE_INT);
if ($toid === FALSE) exit;

include($installfolder.'/model/asset.php');

$fromasset = new Asset($fromid);
$fromasset->Load();

$toasset = new Asset($toid);
$toasset->Load();

$title = 'Route From '.$fromasset->name.' to '.$toasset->name;

global $installfolder;

include($installfolder.'/include/tmpl.php');
	
function stripit($n)
{
	//return str_replace(" ","_",$n);
	return preg_replace("/[^a-zA-Z]/", "", $n);
}
	ST('section','class=content');
		ST('row');
			ST('full');
				ST('box','title=Physical Path');
	
	$startpoint = 50;
	$endpoint = 12;
	
	if (isset($_REQUEST['from']))
	{
		$startpoint = filter_var($_REQUEST['from'],FILTER_VALIDATE_INT);
		if ($startpoint === FALSE) exit;
	}
	
	if (isset($_REQUEST['to']))
	{
		$endpoint = filter_var($_REQUEST['to'],FILTER_VALIDATE_INT);
		if ($endpoint === FALSE) exit;
	}
	
	$scanset = array();
	global $scanset;
	
	$results = array();
	global $results;
	
	$touched = array();
	global $touched;
	
	if (!isset($relationships))
	{
		require($sitefolder.'/cache/relationships/all.inc');
	}
	global $relationships;
	
	$arr = StartRoute($startpoint,$endpoint);
	
	if ($arr !== FALSE)
	{

		$whole = count($arr) * 150;
		$half = ($whole/2) - 150;

		$svg = "<svg version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\" xmlns:xlink=\"http://www.w3.org/1999/xlink\" x=\"0px\" y=\"0px\"\n\t width=\"800px\" height=\"200px\" viewBox=\"-".$half." 0 ".$half." 200\" enable-background=\"new 0 0 800 150\" xml:space=\"preserve\">";
		
		$base = ((-((count($arr)-1) / 2) * 150)) + 40;
	
		$x = $base;
		$y = 50;
		
		$first = true;
		$x = $base;
		for($vx = 0; $vx< count($arr);$vx++)
		{			
			$itm = $arr[$vx];
			
			if ($itm == 0) continue;
			
			if (!isset($asset[$itm]))
			{
				require($sitefolder.'/cache/relationships/'.$itm.'.inc');
			}
			
			if ($vx == 0) continue;
			
			$relid = 0;
			$reldir = 0;
			//Get relationship between these items....
			foreach($asset[$itm]['relationships'] as $k => $v)
			{
				foreach($v as $rel)
				{
					if($rel['target'] == $arr[$vx-1])
					{
						$relid = $k;
						$reldir = $rel['upstream'];
						break;
					}
				}
			}
			
			if($relid == 0) continue;
			
			//$x = (-(count($arr) / 2 * 150)) + (($vx-1) * 150);
			
			//Draw Line In Relationship Colour
			$svg .= '<line x1="'.($x).'" y1="'.$y.'" x2="'.($x + 150).'" y2="'.$y.'" stroke-width="2" stroke="'.$relationships[$relid]['colour'].'"/>';
			
			$y = 40;
			$x += 75;
			
			$svg .= '<text x="'.$x.'" y="'.$y.'" stroke-width="1" text-anchor="middle" font-size="10" font-family="Arial" opacity="0.75" fill="'.$relationships[$relid]['colour'].'">'.$relationships[$relid]['name'].'</text>';
			
			$y = 66;
			
			if ($reldir == true)
			{				
				$nm = 'Is '.$relationships[$relid]['upname'];
			}
			else
				$nm = $relationships[$relid]['downname'];
			
			$svg .= '<text x="'.$x.'" y="'.$y.'" stroke-width="1" text-anchor="middle" opacity="0.75" font-size="10" font-family="Arial" fill="'.$relationships[$relid]['colour'].'">'.$nm.'</text>';
			
			$y  = 50;
			$x += 75;
		}
		
		$x = $base;
		
		//print_r($arr);
		if ($arr[1] == $arr[count($arr)-1])
		{
			$arr[count($arr)-1] = $toasset->id;
		}
		
		foreach($arr as $itm)
		{						
			if ($itm == 0) continue;
			$nm = $asset[$itm]['name'];
						
			$svg .= '<circle cx="'.$x.'" cy="'.$y.'" r="28" stroke="black" stroke-width="1" fill="white"/>';
			
			$svg .= '<text x="'.$x.'" y="'.($y + 40).'" stroke-width="1" fill="black" text-anchor="middle" font-size="10" font-family="Arial">'.SVGBreak($nm,25,$x,$y+40).'</text>';
			
			$x+= 150;
		}
		
		$svg .= "</svg>";	
		
	    echo $svg;
	}
	else
	{
		echo 'Unable to find Route<br/>';
	}
	
	
	function SVGBreak($str, $ln, $x, $y)
	{
		$newstr = "";
		if (strlen($str)< $ln) return trim($str);
				
		$lines = 0;
		$diff = "0em";
		
		$str = trim($str);
		while ($str != "")
		{
			//echo 'Splitting String &quot;'.$str.'&quot;';
			
			if (strlen($str)< $ln)
			{
				$newstr .= '<tspan x="'.($x).'" dy="'.$diff.'">'.trim($str).'</tspan>';
				$diff = "1.4em";
				break;
			}
			
			$ps = strpos($str," ");
			if ($ps === FALSE)
			{
				//echo 'Committing Residual...'.$str;
				$newstr .= '<tspan x="'.($x).'" dy="'.$diff.'">'.trim($str).'</tspan>';
				$diff = "1.4em";
				break;
			}
			$psn = $ps;
			while(($psn < $ln) && ($psn !== FALSE))
			{
				$ps = $psn;
				$psn = strpos($str," ",$ps+1);
			}
			
			//echo 'Located Chunk Between 0 and '.$ps;
			
			//$newstr .= '<tspan x="'.($x * 80).'" y="'.(($y + $lines) * 80).'">';
			$newstr .= '<tspan x="'.($x).'" dy="'.$diff.'">';
			$newstr .= trim(substr($str,0,$ps));
			$newstr .= '</tspan>';
			$str = trim(substr($str,$ps+1));
			$lines++;
			$diff = "1.4em";
		}
		return $newstr;
	}
	
	function StartScan($point)
	{
		global $scanset;
		$pnt = array();
		$pnt['id'] = $point;
		$pnt['dir'] = -1;
		$pnt['depth'] = 0;
		$pnt['priority'] = 0;
		$pnt['rel'] = 0;
		$scanset[] = $pnt;
		
		ScanLayers(0);
	}
	
	function StartRoute($pointa,$pointb)
	{
		global $scanset;
		$pnt = array();
		$pnt['id'] = $pointa;
		$pnt['dir'] = -1;
		$pnt['depth'] = 0;
		$pnt['priority'] = 0;
		$pnt['rel'] = 0;
		$pnt['set'] = 0;
		$scanset[] = $pnt;
		
		$pnt = array();
		$pnt['id'] = $pointb;
		$pnt['dir'] = -1;
		$pnt['depth'] = 0;
		$pnt['priority'] = 0;
		$pnt['rel'] = 0;
		$pnt['set'] = 1;		
		$scanset[] = $pnt;
		
		//echo 'Starting Scan...';
		
		return RouteLayers(0);		
	}
	
	function TraceFrom($arset)
	{
		//print_r($arset);
	
		global $touched;
		//global $asset;
		//global $relationships;
		
		$a = $arset['up'];
		$b = $arset['down'];
		$m = $arset['at'];
		
		//echo 'Starting From '.$m;
		
		//print_r($touched);
		
		$ara = TraceArray($a);
		$arb = TraceArray($b);
		
		echo '<br/>';
		//print_r($ara);
		//print_r($arb);
		
		//Strip items out of ARA that appear in ARB...
		for($x=0;$x<count($arb);$x++)
		{
			if (in_array($arb[$x],$ara))
			{
				array_splice($arb,$x,1);
			}
		}
				
		if ((!in_array($m,$ara)) && (!in_array($m,$arb)))
		{					
			$arr = array_merge(array_reverse($ara),array($m),$arb);
		}
		else
		{
			$arr = array_merge(array_reverse($ara),$arb);
		}
						
		//print_r($ara);
		//print_r($arb);
		
		//print_r($arr);
				
		return $arr;
	}
	
	function TraceArray($indx)
	{
		global $touched;
		$ar = array();
		while (isset($touched[$indx]['from']))
		{
			$ar[] = $indx;
			$indx = $touched[$indx]['from'];			
		}
		$ar[] = $indx;
		return $ar;
	}
	
	function RouteLayers($priority)
	{
		//echo 'Scanning Layer '.$priority.'<br/>';
				
		$lowestpri = $priority;
																
		global $scanset;
		while ($lowestpri != 999999)
		{		
			$setlen = count($scanset);
			$offset = 0;
			$sets = array();
			for($x=0;$x<$setlen;$x++)
			{
				if ($scanset[$offset]['priority'] <= $lowestpri)
				{
					//Begin Scan On This Item...
					$r = RouteItem($scanset[$offset]); 
					if ($r !== false)
					{
						//Bingo - found a route!						
						return TraceFrom($r);
					}
					array_splice($scanset,$offset,1);
					if (count($scanset) == 0) return false;
					if (!isset($sets[$scanset[$offset]['set']]))
					{
						$sets[$scanset[$offset]['set']] = 1;
					}
				}
				else
				{
					$offset++;
				}
			}	
			
			$lastlowest = $lowestpri;
			
			//OK - check for any more layers...
			$lowestpri = 999999;
			foreach($scanset as $scan)
			{
				if ($scan['priority'] < $lowestpri)
				{
					$lowestpri = $scan['priority'];
					if ($lowestpri == $lastlowest + 1) break;
				}
			}
			
			if (count(array_keys($sets)) < 2)
			{
				//We've run out of relationships for one of these items - traversal failed!
				return FALSE;
			}
		}
		return FALSE;
	}
	
	function RouteItem($item)
	{
		global $asset;
		global $scanset;
		global $results;
		global $touched;
		global $db;
		global $relationships;
		global $sitefolder;
		
		$itemid = $item['id'];
		
		if (isset($touched[$itemid]))
		{								
			if ($touched[$itemid]['set'] != $item['set'])
			{
				//echo "Bingo! We've hit a match!<br/>";
				$strike = array();
				$strike['at'] = $itemid;
				if ($item['set'] == 0) 
				{
					$strike['up'] = $item['from'];
					$strike['down'] = $touched[$itemid]['from'];																							
				}
				else
				{
					$strike['down'] = $item['from'];
					$strike['up'] = $touched[$itemid]['from'];									
				}
				return $strike;
			}
			return false;
		}			
														
		$touched[$itemid] = array();
		$touched[$itemid]['depth'] = $item['depth'];				
		$touched[$itemid]['set'] = $item['set'];
		$touched[$itemid]['from'] = 0;
		if (isset($item['from'])) $touched[$itemid]['from'] = $item['from'];
		
		if (!isset($asset[$itemid]))
		{
			require($sitefolder.'/cache/relationships/'.$item['id'].'.inc');
		}
		
		//echo 'Scanning '.$asset[$item['id']]['name'].' ( '.$item['id'] .' ) '.$item['set'].'<br/>';
		
//		print_r($touched);
					
		//Check For Blockages...
		$blocked = false;
		
		foreach($asset[$itemid]['values'] as $k => $val)
		{
			if ($val['type'] == "ISOPOINT")
			{
				//Get Value...
				$query = $db->query("SELECT assetvalues.value as fixedvalue, datalinks.lastvalue as dynamicvalue FROM assetvalues LEFT OUTER JOIN datalinks ON (datalinks.assetid = assetvalues.assetid AND datalinks.propertyid=assetvalues.propertyid AND node='status') WHERE assetvalues.assetid=".$itemid." AND assetvalues.propertyid=".$k);
				
				if($row = $query->fetch(PDO::FETCH_ASSOC)) 
				{
					$parts = explode('|',$row['fixedvalue']);
					
					if(isset($row['dynamicvalue']))
					{
						$v = $row['dynamicvalue'];
					}
					else
					{
						$v = $parts[1];
					}
					$r = $parts[0];
					
					if ($r == $item['rel'])
					{						
						if ($v == 0) $blocked = true;
					}
										
				}					
			}
		}
		
		if ($blocked == true) 
		{
			//echo 'Blocked!<br/>';
			unset($asset[$itemid]);
			return false;
		}
		
		//echo 'Run Relationships...<br/>';
		
		foreach($asset[$itemid]['relationships'] as $k => $v)
		{
			//if (($k == $item['rel']) || ($item['rel'] == 0))
			//{
				//OK - isolation is based on physical relationships only...
				//echo 'Checking Relationship<br/>';
				if ($relationships[$k]['type'] != 'physical') continue;
				
				foreach($v as $res)
				{
					$pass = false;
															
					$pass = true;	
									
					if ($pass == true)
					{
						//echo 'Checking For Target Hit...';
						if (isset($touched[$res['target']]))
						{							
							//echo 'Not Moving To '.$res['target'].' - Already Set<br/>';
							if ($touched[$res['target']]['set'] != $item['set'])
							{
								//echo "Bingo! We've hit a match!<br/>";
								$strike = array();
								$strike['at'] = $res['target'];
								if ($item['set'] == 0) 
								{
									$strike['up'] = $item['id'];
									$strike['down'] = $touched[$itemid]['from'];									
																		
								}
								else
								{
									$strike['down'] = $item['id'];
									$strike['up'] = $touched[$itemid]['from'];									
								}
								return $strike;
							}
							continue;
						}	
						//echo 'Moving To '.$res['target'].'<br/>';	
												
						$pnt = array();
						$pnt['id'] = $res['target'];
						$pnt['dir'] = $res['upstream'];
						$pnt['depth'] = $item['depth'] + 1;
						$pnt['priority'] = $item['depth'] + 1;
						$pnt['rel'] = $k;
						$pnt['set'] = $item['set'];
						$pnt['from'] = $item['id'];
						$scanset[] = $pnt;
						
						//echo 'Added Item To Processing list';
					}
				//}
			}
		}	
		unset($asset[$itemid]);
		return false;					
	}
			ET();
		ET();
	ET();
ET();
?>