<?php
/**
 * Creates a relationship between two items
 *
 * Note that this is not a user page but is instead used internally and
 * linked to.
 *
 * Parameters:
 *		Origin - The first asset
 * 		NewRelTarget - The second asset
 *		Relatonship - The ID of the relationship, followed by a dash (-) 
 *			and then the direction of the relationship (U = Up, D = Down)
 *
 * Note that this operation is NOT trivial. Where possible, create
 * new relationships in their natural order to avoid excessive
 * rebuilding of the closure table.
 *
 * @author Steven Harding
 */
 
	

	$asset = 0;
	$other = 0;
	$rel = 0;
	$editing = 0;
	
	if (isset($_REQUEST['asset']))
	{
		$asset = $_REQUEST['asset'];
		$editing = $asset;
	}
	
	if (isset($_REQUEST['editing']))
	{
		$editing = $_REQUEST['editing'];
	}
	
	if (isset($_REQUEST['other']))
	{
		$other = $_REQUEST['other'];
	}
	
	if (isset($_REQUEST['rel']))
	{
		$relationship = $_REQUEST['rel'];
	}
	
	$returnpoint = $siteroot.'/relationships/'.$editing;
	
	if (isset($_REQUEST['returnto']))
	{
		if ($_REQUEST['returnto'] == 'diagram')
		{
			$returnpoint = $siteroot.'/diagram/'.$editing."/".$relationship;
			//header('Location: '.$siteroot.'/diagram/'.$editing."/".$relationship);
			
		}
		if ($_REQUEST['returnto'] == 'editor')
		{
			//header('Location: '.$siteroot.'/editor/'.$asset);
			$returnpoint = $siteroot.'/editor/'.$asset;
		}
	}
	header('Location: '.$returnpoint);
	
	//require_once($_SERVER['DOCUMENT_ROOT'].'/include/linker.php');
	
	//echo 'Removing Link Between Assets - '.$asset.' / '.$other.' via '.$relationship;
	
	require_once($installfolder.'/model/relationship.php');
	
	//echo 'Hello?';
	
	//ob_start();
	ob_start();
	Relationships::Remove($asset, $other, $relationship);
	$msg = ob_get_clean();
	//echo $msg;
	//ob_clean();
	//LinkAssets($origin, $destination, $relationship);
	
	//echo 'WTF?';
	
	if (isset($_REQUEST['returnto']))
	{
		if ($_REQUEST['returnto'] == 'diagram')
		{
			//header('Location: '.$siteroot.'/diagram/'.$editing."/".$relationship);
			exit;
		}
		if ($_REQUEST['returnto'] == 'editor')
		{
			//header('Location: '.$siteroot.'/editor/'.$asset);
			exit;
		}
	}
	
	exit;
	
?>
