<?php
/**
 * Creates a new asset based on an existing Bundle file
 *
 * @author Steven Harding
 */
						
	$childid = 0;
	
	$rel = 0;
	if (isset($_REQUEST['rel']))
	{
		$rel = $_REQUEST['rel'];
	}
	
	if (isset($_REQUEST['child']))
	{
		$child = $_REQUEST['child'];
	}
	
	function Unzip($filename, $outpath, $destiny="")
	{
		//global $rlog;
		//global $dbfile;
		global $sitefolder;
		$outpath .= DIRECTORY_SEPARATOR;
		$path_file = $filename;
		
		$finalpath = str_replace("\\","/",$path_file);
		
		$dir = $outpath;
		
		$ln = strlen($outpath);
		
		$zip = new ZipArchive();
		//$za = $zip->open($finalpath,ZipArchive::CHECKCONS);
		$za = $zip->open($finalpath);
		if ($za !== TRUE)
		{
			echo 'Failed to Open ZIP File '.$finalpath;
			if ($za == ZipArchive::ER_INCONS) 
				echo 'ZIP Archive is Inconsistent';
			else
				echo 'Could Not Open ZIP Archive - Error Code '.$za;
			return false;
		}
		
		for ($i = 0; $i < $zip->numFiles; $i++) {
			 $name = $zip->getNameIndex($i);
			 if ($name === FALSE) continue;
			 
		     $path_file = str_replace('/',DIRECTORY_SEPARATOR,$name);			 
			 
			 $info = pathinfo($path_file);			
			 $fname = $info['basename'];
			 $new_dir = $info['dirname'];
			
			//echo 'Directory: '.$new_dir.'<br/>';

			$bits = explode(DIRECTORY_SEPARATOR,$new_dir);
			
			$dest = $sitefolder.'/restore/';
			
			//echo 'Copying To: '.$dest.'<br/>';
			
			if ($dest == "") continue;
			$new_dir = $dest;
			
			//echo 'Extracting '.$name.' to '.$dest.'<br/>';
			$zip->extractTo($dest,$name);
 		}
		
		$zip->close();		
		return true;
	}
	
	$error = "";
		
	if (($_SERVER['REQUEST_METHOD'] == 'POST') && (isset($_REQUEST['name'])))
	{
		if (isset($_FILES['file']))
		{
			echo 'File Located - Bundle Restore Begun!';
			
			//Find a nice place to extract the ZIP archive...
			
			$pth = $sitefolder.'/restore';
			if (!file_exists($pth))
			{
				mkdir($pth);
			}
			
			if (file_exists($pth.'/restore.zip'))
			{
				unlink($pth.'/restore.zip');
			}	
			
			$restorepath = $pth.'/restore.zip';
			
			move_uploaded_file($_FILES['file']['tmp_name'],$restorepath);
			
			//Unzip the archive file
			
			if (Unzip($restorepath,$installfolder) == false)
			{
				exit;
			}
			
			//Check the archive file for unbound items
			
			//readfile($sitefolder.'/restore/content.txt');
			
			$disconnected = array();
			
			$file = fopen($sitefolder.'/restore/content.txt',"r");
			$lastpos = array();
			$changed = array();
			$baseline = 0;
			
			$lineno = 0;
			while(!feof($file))
			{

				$lines = fgetcsv($file,0,"\t");
				$lineno++;
				$validchanges = false;
				
				if (count($lines) < 3) continue;
				
				for($x=0;$x<count($lines);$x++)
				{
					$changed[$x] = false;
				}
				
				//Find if particular columns have changed...
				for($x=0;$x<count($lines);$x++)
				{
					if (trim($lines[$x]) != "")
					{
						$lastpos[$x] = $lines[$x];
						$changed[$x] = true;
						$validchanges = true;
					}
					else
					{
						if (isset($lastpos[$x]))
						{
							if ($validchanges == false)
							{
								$changed[$x] = false;
								$lines[$x] = $lastpos[$x];
							}
						}
					}
				}
				if (($changed[0] == true) && ($baseline == 0))
				{
					$baseline = $lineno;
				}
				
				if ($lines[2] == "*")
				{
					//Open Connection
					$m = array();
					$m['type'] = 'Relationship';
					$m['name'] = $lines[1];
					$m['asset'] = $lines[0];
					$m['line'] = $lineno;
					$m['dir'] = 'incoming';
					$disconnected[] = $m;
				}
				
				if ($lines[2] == "+")
				{
					//Open Connection
					$m = array();
					$m['type'] = 'Relationship';
					$m['name'] = $lines[1];
					$m['asset'] = $lines[0];
					$m['line'] = $lineno;
					$m['dir'] = 'outgoing';
					$disconnected[] = $m;
				}
				
				if (count($lines) >= 4)
				{
					if ($lines[3] == '') continue;
					if ($lines[3][0] == '>')
					{
						$bits = explode('>',$lines[3]);
						//Is this internal, or external?
						$m['type'] = 'Binding';
						$m['name'] = $lines[1].' '.$lines[2];
						$m['asset'] = $lines[0];
						$m['profile'] = 'Actual';
						$m['mode'] = 'Live';
						$m['source'] = $bits[3];
						$m['addr'] = $bits[4];
						$m['line'] = $lineno;
						
						if ($bits[3][0] != '*') continue;
						if ($bits[1] != 'Actual') continue;
						if ($bits[2] == 'hist') $m['mode'] = 'Hist.';
						
						$final = explode(':',$bits[3]);
						$m['driver'] = $final[1];
						
						$disconnected[] = $m;
					}
				}
			}
			
			fclose($file);
			
			//Take a look at the TXT file - find disconnected items...
			
			if (count($disconnected) > 0)
			{
				//Stop here and ask questions.
				
	$title = 'Connect To Your System';

	include($installfolder.'/include/tmpl.php'); ?>

	var assetlist = new Bloodhound({
	  datumTokenizer: Bloodhound.tokenizers.obj.whitespace('text'),
	  queryTokenizer: Bloodhound.tokenizers.whitespace,
	  remote: '<?php echo $siteroot;?>/ajax/assetnamesearch?q=%QUERY',  
	  //local: $.map(assets, function(state) { return { value: state }; })
	});
	 
	// kicks off the loading/processing of `local` and `prefetch`
	assetlist.initialize();
	
	$('.location').typeahead({
    	hint: true,
        highlight: true,
        minLength: 2
    },{
	    name: 'assets',
        displayKey: 'text',
        source: assetlist.ttAdapter(),
        templates: {
            empty: [
              '<div class="tt-suggestions" style="font-size: small;"><div class="tt-suggestion">No Matching Asset Found</div>'
            ].join('\n'),
			suggestion: function(data){
				return '<p class="searchresult">' + data.text + '<span>' + data.path + '</span></p>';
			}            
        }        
    });
	
	$('.location').on('typeahead:selected',function (evt,item) {    	
        $('#'+$(evt.target).attr('id')+"_in").val(item.id);
		$('#'+$(evt.target).attr('id')+"_out").val(item.id);
    });<?php
            
    SS('onload');  ?>
	<script src="/plugins/typeahead/typeahead.bundle.min.js"></script>
<?php SS('addscripts'); ?>
	
<script>
function LoadLinkOptions(nm, lin, val)
{
	if (val == undefined)
	{
		val = $('#ovr_' + nm + "_source").val();
		//alert('Reading ' + '#ovr_' + nm + '_source');
	}
	
	//alert('<?php echo $siteroot; ?>/bundle/link?source=' + val + '&property=' + nm);
	
	$.post('<?php echo $siteroot; ?>/bundle/link',{ source: val, property: nm },function(data) {
		//alert(data);
		sourcename = val;
		$('#content' + nm).html(data);
		if (data != "")
		{
			$('#content' + nm).fadeIn(500);
			$('#content' + nm + ':input:enabled:visible:not([readonly]):first').focus();
		}
		else
		{
			$('#content' + nm).fadeOut(500);
		}
	});
}
</script>
	<?php

	ST('section','class=content');
		ST('row');
			echo '<form method="POST" enctype="multipart/form-data">';
			ST('half'); ?>
				<form method="POST"><?php
				ST('box','title=Connections');?>
					<input type="submit" value="Connect Asset(s)" class="btn btn-success"/>
					<input type="hidden" value="<?php echo $_REQUEST['name'];?>" name="name"/> <?php
					SS('footer');
					ST('ftable');
					
						include($installfolder.'/model/relationship.php');
						$relset = Relationships::GetAll();
						//print_r($relset);
						foreach($disconnected as $disc)
						{
							if ($disc['type'] != 'Relationship') continue;
							$dir = "_in";
							
							$knownid = 0;
							$knownname = "";
							
							if ($disc['dir'] == 'outgoing') 
								$dir = "_out";
							else
							{
								//Check to see if this is specified in the parameters...
								if (isset($_REQUEST['rel']))
								{
									foreach($relset as $rel)
									{
										if ($rel->id == $_REQUEST['rel'])
										{
											if ($rel->name == $disc['name'])
											{
												$knownid = $rel->id;
												$adr = new Asset($_REQUEST['parent']);
												$knownname = $adr->name;
												break;
											}
										}
									}
								}
							}
							echo '<tr><td>'.$disc['asset'].' '.$disc['name'].' ( '.$disc['dir'].' )</td><td><input type="text" id="ovr_'.$disc['line'].'" value="'.$knownname.'" class="location" style="border: 1px solid black; border-radius: 2px;"/><input type="hidden" value="'.$_REQUEST['parent'].'" id="ovr_'.$disc['line'].$dir.'" name="ovr_'.$disc['line'].$dir.'"/></td></tr>';
						}
					ET();
				ET();
			ET();
			ST('half'); 
			
			$sourcelist = array();
			
			//print_r($disconnected);
			
			$query = $db->query('SELECT assetid,assets.name,profile,mode,driver FROM datasources JOIN assets ON (assets.id = datasources.assetid) ORDER BY assets.name');

			while($row = $query->fetch(PDO::FETCH_ASSOC))
			{
				$sourcelist[] = $row;
			}	
			?>
				<?php
				ST('box','title=Data');
					ST('ftable');
					
						foreach($disconnected as $disc)
						{
							if ($disc['type'] != 'Binding') continue;
						
							$pro = 1;
							$md = 0;
							if ($disc['mode'] == 'Hist.') $md = 1;
							
							echo '<tr><td>'.$disc['asset'].' '.$disc['profile'].' '.$disc['mode'].' '.$disc['name'].'</td>';
							echo '<td><select onchange="LoadLinkOptions('.$disc['line'].');" id="ovr_'.$disc['line'].'_source" name="ovr_'.$disc['line'].'"><option value="0">No Connection</option>';
							$madeselection = false;
							foreach($sourcelist as $src)
							{
								if ($src['profile'] != $pro) continue;
								if ($src['mode'] != $md) continue;
								
								echo '<option value="'.$src['assetid'].'"';
								if ($src['driver'] == $disc['driver'])
								{
									echo ' selected';
									$madeselection = true;
								}
								echo '>'.$src['name'].'</option>';
							}
							echo '</select>';
							echo '<div class="bundlelink" style="';
							if ($madeselection == false) echo 'display: none;';
							echo '"><table style="width: 100%;" id="content'.$disc['line'].'">';
							if ($madeselection == true)
							{
								$fldr = "live";
								if ($md == 1) $fldr = "historical";
								if ($md == 10) $fldr = "asset";
								
								ob_start();
								$address = $disc['addr'];
								include($installfolder.'/data/'.$fldr.'/'.$disc['driver'].'/link.php');
								$vv = ob_get_clean();
								$vv = str_replace("name=\"","name=\"ovr_".$disc['line'].'_',$vv);
								$vv = str_replace("&nbsp;","",$vv);
								echo $vv;
							}
							echo '</table></td></tr>';
						}
					ET();
				ET();
			ET();
			echo '</form>';
		ET();
	ET();

				exit;
			}
		}
		else
		{
			$pth = $sitefolder.'/restore';
			if (!file_exists($pth))
			{
				mkdir($pth);
			}
			
			if (file_exists($pth.'/restore.zip'))
			{
				unlink($pth.'/restore.zip');
			}	
		}
		
		if (!file_exists($sitefolder.'/restore/content.txt'))
		{
			exit;
		}
		//Import the TXT file with the given overrides
		
		$background = true;
		$_REQUEST['commit'] = true;
		//unset($_REQUEST['commit']);
		$exportlocation = $sitefolder.'/restore/content.txt';
		
		//print_r($_REQUEST);
		
		include($installfolder.'/pages/tools/import/form/run.php');
			
		//Restore the data files (given the ID remapping)
		foreach($idmapping as $k => $v)
		{
			$fl = $sitefolder.'/restore/media/'.$k;
			if(file_exists($fl))
			{
				$newfl = $sitefolder.'/media/'.$v;
				rename($fl,$newfl);
			}
			
			$fl = $sitefolder.'/restore/cache/bindings/'.$k.'.binding';
			if(file_exists($fl))
			{
				$newfl = $sitefolder.'/cache/bindings/'.$v.'.binding';
				rename($fl,$newfl);
			}
			
			$fl = $sitefolder.'/restore/layouts/'.$k;
			if(file_exists($fl))
			{
				$newfl = $sitefolder.'/layouts/'.$v;
				rename($fl,$newfl);
			}
			
			$thisasset = new Asset($v);
			$thisasset->UpdateCache();
		}
			
		header("Location: ".$siteroot.'/diagram/1/2');	
		exit;
	}
		
	$atype = "Asset";
		
	$title = 'Add Bundled Asset(s)';

	include($installfolder.'/include/tmpl.php'); 

	ST('section','class=content');
		ST('row');
		echo '<form method="POST" enctype="multipart/form-data">';
			ST('half'); ?>
				<form method="POST"><?php
				ST('box','title=Select Bundle File');
					if ($childid != 0)
					{ ?>
			<input type="submit" value="Create Asset From Bundle" class="btn btn-success"/><input type="hidden" name="child" value="<?php echo $childid; ?>"/><input type="hidden" name="rel" value="<?php echo $rel; ?>"/><?php
					}
					else
					{?>
			<input type="submit" value="Create Asset From Bundle" class="btn btn-success"/><?php
					};
					
					SS('footer');
					ST('ftable');?>
	<tr><td><label>Name:</label></td><td><input type="text" value="<?php
	if (isset($_REQUEST['name']))
	{
		echo $_REQUEST['name'];
	}
	?>" id="name" name="name"/>
	</td></tr>
    <tr><td><label>Bundle File:</label></td><td><input type="file" name="file"></td></tr>
	       
    <?php
					ET();
	
	
	//if ((isset($rel)) && ($rel != 0)) echo '<input type="hidden" name="relationship" value="'.$rel.'"/>';
			
				ET();
			ET();
		echo '</form>';
		ET();
	ET();
?>