<?php
	
$forimport = false;
$forscreen = false;

if (isset($_REQUEST['forimport']))
{
	if ($_REQUEST['forimport'] == 1) $forimport = true;
}

if (isset($_REQUEST['form']))
{
	if ($_REQUEST['form'] == "screen") $forscreen = true;
}

if ($forscreen == true) { ?>

<html>
	<head>
		<title>Spreadsheet Export</title>
	</head>
	<body>
		<table>
<?php
	$header = '<tr><td style="vertical-align: top;">';
	$footer = '</td></tr>'."\r\n";
	$joiner = '</td><td style="vertical-align: top;">';
}
else
{
	header('Content-Type: text/csv');
	header('Content-Disposition: attachment; filename="export.csv"');
	$header = '"';
	$footer = '"'."\r\n";
	$joiner = '","';
}

	//First, get the base details down...
	
	echo $header.'_id'.$joiner.'name';
	if ($forimport == true)
	{
		echo $joiner.'_prefix';
	}
	
	//Now properties...
	include($installfolder.'/model/property.php');
	$prp = Properties::GetAllProperties();
	foreach($prp as $p)
	{
		if ($p->type == "LAYOUT") continue;
		echo $joiner.$p->name;
	}
	
	//And relationships...
	include($installfolder.'/model/relationship.php');
	$rls = Relationships::GetAllRelationships();
	foreach($rls as $p)
	{
		echo $joiner.$p->name;
	}
	
	echo $footer;

	//Now, get them for each asset...
	
	$qry = 'SELECT id,name,propertyid,value FROM assets LEFT OUTER JOIN assetvalues ON (assetvalues.assetid = assets.id) ORDER BY id';
	$query = $db->query($qry);
	
	$oldid = 0;
	$oldrow = array();
	$props = array();
	$links = array();
		
	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		if ($row['id'] != $oldid)
		{
			if ($oldid != 0)
			{
				//Header columns...
				echo $header;
				echo $oldrow['id'];
				echo $joiner;
				echo $oldrow['name'];
				if ($forimport == true)
				{
					echo $joiner;
				}
				
				//Now work through properties...
				foreach($prp as $p)
				{
					if ($p->type == "LAYOUT") continue;
					echo $joiner;
					if (isset($props[$p->id]))
					{
						echo $props[$p->id];
					}
				}
				
				//Now work through relationships...
				include($sitefolder.'/cache/relationships/'.$oldid.'.inc');
				foreach($rls as $p)
				{
					$any = false;
					echo $joiner;
					if (isset($asset[$oldid]['relationships'][$p->id]))
					{
						foreach($asset[$oldid]['relationships'][$p->id] as $r)
						{
							if ($r['upstream'] == false) continue;
							include($sitefolder.'/cache/relationships/'.$r['target'].'.inc');
							if ($any == true) echo ',';
							$any = true;
							echo $asset[$r['target']]['name']; 
						}
					}
				}
				$relationships = array();
				
				echo $footer;
			}
			$oldid = $row['id'];
			$oldrow = $row;
			$props = array();
		}
		$props[$row['propertyid']] = $row['value'];
	}
	if ($oldid != 0)
	{
	//Header columns...
				echo $header;
				echo $oldrow['id'];
				echo $joiner;
				echo $oldrow['name'];
				if ($forimport == true)
				{
					echo $joiner;
				}
				
				//Now work through properties...
				foreach($prp as $p)
				{
					echo $joiner;
					if (isset($props[$p->id]))
					{
						echo $props[$p->id];
					}
				}
				
				//Now work through relationships...
				include($sitefolder.'/cache/relationships/'.$oldid.'.inc');
				foreach($rls as $p)
				{
					$any = false;
					echo $joiner;
					if (isset($asset[$oldid]['relationships'][$p->id]))
					{
						foreach($asset[$oldid]['relationships'][$p->id] as $r)
						{
							if ($r['upstream'] == false) continue;
							include($sitefolder.'/cache/relationships/'.$r['target'].'.inc');
							if ($any == true) echo ',';
							$any = true;
							echo $asset[$r['target']]['name']; 
						}
					}
				}
				$relationships = array();
				
				echo $footer;
	}

if ($forscreen == true)
{
?>
		</table>
	</body>
</html>
<?php }; ?>