<!DOCTYPE html>
<html>
    <head>
        <meta charset="utf-8">

        <title>Spectral Response</title>

        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">

        <meta name="description" content="CSS gradient generator with the best browser support. Three different layouts to meet Your requirement (from simple linear to complex radial gradients).">

        <link rel="shortcut icon" href="../favicon.ico">

        <link href="/plugins/bootstrap/css/bootstrap.min.css" rel="stylesheet" type="text/css" media="all">
        <link href="site.css" rel="stylesheet" type="text/css" media="all">
        <link href="css-gradient-generator.css" rel="stylesheet" type="text/css" media="all">
        <link href="/plugins/icomoon/sprites.css" rel="stylesheet" type="text/css">

        <link href="/plugins/bootstrap-colorpickersliders/bootstrap.colorpickersliders.css" rel="stylesheet" type="text/css" media="all">
        <link href="/plugins/syntaxhighlighter/3.0.83/shCore.css" rel="stylesheet" type="text/css">
        <link href="/plugins/syntaxhighlighter/3.0.83/shThemeDefault.css" rel="stylesheet" type="text/css">

    </head>

    <body>
    
    <script>
var queryprefix = "id=<?php echo $_REQUEST['id'];?>";
	</script>

        <div class="container">

            <div class="row header text-center">
                <h1>Spectral Response Editor</h1>
                This editor allows you to create your own unique gradients to display data in your virtual environment.
            </div>

            <div class="css-gradient-editor-container layout-init clearfix">

                <div class="row toolbar">

                    <div class="col-md-12 text-right">

                        <div class="btn-group btn-group-sm">
                            <!--<a href="#" class="btn btn-default css-gradient-editor-configuration" data-toggle="modal" data-target="#configmodal"><span class="pngicon-wrench"></span> Config</a>
                            <a href="" class="btn btn-default css-gradient-editor-permalink"><span class="pngicon-share"></span> Share permalink</a>
                            <a href="#" class="btn btn-default css-gradient-editor-qrcode" title="Gradient permalink QR code" data-toggle="modal" data-target="#qrmodal"><span class="pngicon-qrcode"></span> QR Code</a>
                            <a target="_blank" href="gradient.php" class="btn btn-default css-gradient-editor-imagegradient" style="margin-right:10px"><span class="pngicon-picture"></span> Get PNG</a>
                            <button type="button" class="btn btn-primary css-gradient-editor-copycss"><span class="pngicon-copy"></span> Copy CSS</button>
                            <button type="button" class="btn btn-primary css-gradient-editor-getcss" data-toggle="modal" data-target="#cssoutmodal" style="margin-right:10px"><span class="pngicon-file-css"></span> Get CSS</button>
                            <button type="button" class="btn css-gradient-editor-undo"><span class="pngicon-undo"></span> Undo</button>
                            <button type="button" class="btn css-gradient-editor-redo"><span class="pngicon-redo"></span> Redo</button>-->
                        </div>

                    </div>

                </div>

                <div class="row">
                                                        

                <div class="panel gradient-properties col-md-6">
                    <div class="panel-heading"><h2 class="panel-title pull-left">Gradient properties</h2>
                        <div class="clearfix">
                            <div class="pull-right btn-group">
                                <!--<a href="" class="btn btn-hover btn-primary btn-sm css-gradient-editor-layout-easy" title="<b>IE6+, Android 2.3+, iOS 3.2+</b><br>CSS, filter, old webkit<br><i>linear gradients</i>">Simple</a>-->
                                <!--<a href="" class="btn btn-hover btn-primary btn-sm css-gradient-editor-layout-advanced" title="<b>IE9+, Android 3.0+, iOS 3.2+, WP7.5+</b><br>CSS, SVG<br><i>dynamic radial gradients</i>">Advanced</a>
                                <!--<a href="" class="btn btn-hover btn-primary btn-sm css-gradient-editor-layout-expert" title="<b>IE10+, Android 4.0+, iOS 5.0+</b><br>Only for browsers with CSS3 support<br><i>experimental</i>">Expert</a>-->
                            </div>
                        </div>
                    </div>
                    <div class="panel-body nopadding"                        
                       

                        <div class="gradient-preferences-advanced">
                            

                            <div>

                                <div class="css-gradient-editor-colorstops-easy">
                                    <div class="css-gradient-editor-stopeditor"><span></span><div class="css-gradient-editor-stoppointmarkers"></div></div>
                                </div>

                                <div class="css-gradient-editor-colorstops-advanced clearfix">
                                    <div class="css-gradient-editor-stoppointlist"></div>
                                    <button type="button" class="col-md-4 btn btn-sm btn-default css-gradient-editor-reorder-stoppoints"><span class="pngicon-random"></span> Update order</button>
                                    <button type="button" class="col-md-offset-4 col-md-4 btn btn-sm btn-primary css-gradient-editor-add-stoppoint"><span class="pngicon-plus"></span> Add stop point</button>
                                </div>

                            </div>
                        </div>
                    </div>
               
                
                <div class="col-md-6">

                        <div class="css-gradient-editor panel css-gradient-editor-preview-panel">
                            <div class="panel-heading"><h2 class="panel-title pull-left">Preview</h2>
                                <div class="clearfix">
                                    <div class="pull-right btn-group">                                        <!--<button type="button" class="btn btn-primary btn-sm css-gradient-editor-adjustcolor"><span class="pngicon-settings"></span> Adjust color</button>                                        -->
                                    <form method="POST" action="<?php echo $siteroot; ?>/admin/properties/mdisplay">
                                    <button type="submit" class="btn btn-primary btn-success btn-sm" style="color: white;">Save Changes</a>
                                    	<input name="id" type="hidden" value="<?php echo $_REQUEST['id']; ?>"/>
                                        <input name="finalstops" type="hidden" id="finalstops" value="<?php echo $_REQUEST['sp']; ?>"/>
                                    </form>
                                    </div>
                                </div>
                            </div>
                            <div class="panel-body">

                                <div class="css-gradient-editor-preview-container">
                                    <div class="css-gradient-editor-preview">
                                        <div class="ajax-loader"><span class="css-gradient-editor-preview-resize-handler"></span></div>
                                        <span class="css-gradient-controls">
                                            <button type="button" class="btn btn-primary btn-sm css-gradient-editor-previewpopout"><span class="pngicon-collapse"></span></button>
                                        </span>
                                    </div>
                                </div>
                            </div>
                        </div>

                    </div>
                    
                    <div class="col-md-12">

                        <div class="panel css-gradient-editor-swatches-wrapper">
                            <div class="panel-heading"><h2 class="panel-title pull-left">Styles</h2>
                                <div class="clearfix">
                                    <div class="pull-right btn-group">
                                        <!--<button type="button" class="btn btn-default btn-sm css-gradient-editor-export" title="Add gradient to swatches" data-toggle="modal" data-target="#exportallmodal"><span class="pngicon-arrow-up2"></span> Export all</button>
                                        <button type="button" class="btn btn-default btn-sm css-gradient-editor-import" title="Add gradient to swatches" data-toggle="modal" data-target="#importmodal"><span class="pngicon-arrow-down2"></span> Import</button>-->
                                        <div class="css-gradient-editor-preset current btn pull-left"><span></span></div>
                                        <button type="button" class="btn btn-primary btn-sm css-gradient-editor-save" title="Add gradient to swatches"><span class="pngicon-disk"></span> Save</button>
                                        <button type="button" class="btn btn-primary btn-sm css-gradient-editor-delete" title="Remove gradient from swatches"><span class="pngicon-remove"></span> Delete</button>
                                    </div>
                                </div>
                            </div>
                            <div class="panel-body">
                                <div class="content css-gradient-editor-swatches">
                                    <ul class="clearfix"></ul>
                                </div>
                            </div>
                        </div>

                    </div>
                     </div>
                    
                </div>

                <!-- Modal -->
                <div class="modal bs-modal-lg" id="cssoutmodal" tabindex="-1" role="dialog" aria-labelledby="cssModalLabel" aria-hidden="true">
                    <div class="modal-dialog modal-lg">
                        <div class="modal-content">
                            <div class="modal-header">
                                <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
                                <h4 class="modal-title">Generated CSS</h4>
                            </div>
                            <div class="modal-body">
                                <div class="css-gradient-editor-cssoutput-container">
                                    <pre class="css-gradient-editor-cssoutput"></pre>
                                </div>
                            </div>
                            <div class="modal-footer">
                                <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
                            </div>
                        </div>
                    </div>
                </div>

                <div class="modal bs-modal-lg" id="qrmodal" tabindex="-1" role="dialog" aria-labelledby="permalinkModalLabel" aria-hidden="true">
                    <div class="modal-dialog modal-lg">
                        <div class="modal-content">
                            <div class="modal-header">
                                <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
                                <h4 class="modal-title">Gradient permalink <small>Test the current gradient in your mobile browser</small></h4>
                            </div>
                            <div class="modal-body">
                                <div id="permalinkqr" class="text-center"></div>
                            </div>
                            <div class="modal-footer">
                                <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
                            </div>
                        </div>
                    </div>
                </div>

                <div class="modal bs-modal-lg" id="exportallmodal" tabindex="-1" role="dialog" aria-labelledby="permalinkModalLabel" aria-hidden="true">
                    <div class="modal-dialog modal-lg">
                        <div class="modal-content">
                            <div class="modal-header">
                                <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
                                <h4 class="modal-title">Export presets <small>save the content to a file</small></h4>
                            </div>
                            <div class="modal-body">
                                <textarea class="css-gradient-editor-textarea-exportall" readonly></textarea>
                            </div>
                            <div class="modal-footer">
                                <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
                            </div>
                        </div>
                    </div>
                </div>

                <div class="modal bs-modal-lg" id="importmodal" tabindex="-1" role="dialog" aria-labelledby="permalinkModalLabel" aria-hidden="true">
                    <div class="modal-dialog modal-lg">
                        <div class="modal-content">
                            <div class="modal-header">
                                <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
                                <h4 class="modal-title">Import presets <small>paste the previously saved data into the textarea</small></h4>
                            </div>
                            <div class="modal-body">
                                <textarea class="css-gradient-editor-textarea-import"></textarea>
                            </div>
                            <div class="modal-footer">
                                <button type="button" class="btn btn-link loaddefaults">Load defaults</button>
                                <button type="button" class="btn btn-default" data-dismiss="modal">Import</button>
                            </div>
                        </div>
                    </div>
                </div>

                <!--<div class="modal bs-modal-lg" id="configmodal" tabindex="-1" role="dialog" aria-labelledby="permalinkModalLabel" aria-hidden="true">
                    <div class="modal-dialog modal-lg">
                        <div class="modal-content">
                            <div class="modal-header">
                                <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
                                <h4 class="modal-title">Configuration</h4>
                            </div>
                            <div class="modal-body">

                                <form class="form-horizontal" role="form">

                                    <div class="form-group">
                                        <label class="col-xs-3 text-right">CSS selector:</label>
                                        <div class="col-xs-2">
                                            <input type="text" class="form-control" data-name="config_cssselector" name="config-cssselector" placeholder=".gradient">
                                        </div>
                                    </div>

                                    <div class="form-group">
                                        <label class="col-xs-3 text-right">Color format: </label>
                                        <div class="col-xs-9 btn-group">
                                            <button class="btn btn-default btn-sm css-gradient-editor-controller" data-control-group="config_colorformat" data-name="config_colorformat" data-value="rgb">rgb</button>
                                            <button class="btn btn-default btn-sm css-gradient-editor-controller" data-control-group="config_colorformat" data-name="config_colorformat" data-value="hsl">hsl</button>
                                            <button class="btn btn-default btn-sm css-gradient-editor-controller" data-control-group="config_colorformat" data-name="config_colorformat" data-value="hex">hex</button>
                                        </div>
                                    </div>

                                    <div class="form-group">
                                        <label class="col-xs-3 text-right">Color picker visible sliders: </label>
                                        <div class="col-xs-9 btn-group">
                                            <button class="btn btn-default btn-sm css-gradient-editor-controller" data-name="config_colorpicker_hsl">hsl</button>
                                            <button class="btn btn-default btn-sm css-gradient-editor-controller" data-name="config_colorpicker_rgb">rgb</button>
                                            <button class="btn btn-default btn-sm css-gradient-editor-controller" data-name="config_colorpicker_cie">cie</button>
                                            <button class="btn btn-default btn-sm css-gradient-editor-controller" data-name="config_colorpicker_opacity">opacity</button>
                                            <button class="btn btn-default btn-sm css-gradient-editor-controller" data-name="config_colorpicker_swatches">color swatches</button>
                                        </div>
                                    </div>

                                    <div class="form-group">
                                        <label class="col-xs-3 text-right">Mixed stop point units: </label>
                                        <div class="col-xs-9 btn-group">
                                            <button class="btn btn-default btn-sm css-gradient-editor-controller" data-control-group="config_mixedstoppointunits" data-name="config_mixedstoppointunits" data-value="enabled">enabled</button>
                                            <button class="btn btn-default btn-sm css-gradient-editor-controller" data-control-group="config_mixedstoppointunits" data-name="config_mixedstoppointunits" data-value="disabled">disabled</button>
                                        </div>
                                    </div>

                                    <div class="form-group">
                                        <label class="col-xs-3 text-right">Code generation: </label>
                                        <div class="col-xs-9 btn-group">
                                            <button class="btn btn-default btn-sm css-gradient-editor-controller" data-name="config_generation_bgcolor" title="Weighted average background color fallback">bg color</button>
                                            <button class="btn btn-default btn-sm css-gradient-editor-controller" data-name="config_generation_iefilter" title="IE 6-8">IE filter</button>
                                            <button class="btn btn-default btn-sm css-gradient-editor-controller" data-name="config_generation_svg" title="IE 9, iOS 3.2-4.3, WP 7.5">SVG</button>
                                            <button class="btn btn-default btn-sm css-gradient-editor-controller" data-name="config_generation_oldwebkit" title="SVG and SVG with old-webkit if justified (radial gradients only, and only needed for Android 2.3 and older where SVG is not supported but the SVG definition deletes the old webkit syntax if placed after that, which is needed for radial gradients because the `-webkit-gradient` syntax with radial shape lacks support for percentage-defined size)">old webkit</button>
                                            <button class="btn btn-default btn-sm css-gradient-editor-controller" data-name="config_generation_webkit" title="Android 3.0+, iOS 5.0+ - but they supports SVG as well">newer webkit</button>
                                            <button class="btn btn-default btn-sm css-gradient-editor-controller" data-name="config_generation_ms" title="IE10 consumer preview - there is really no need to use it">-ms</button>
                                        </div>
                                    </div>

                                    <div class="form-group">
                                        <label class="col-xs-3 text-right">Fallback width:</label>
                                        <div class="col-xs-2">
                                            <div class="input-group">
                                                <input type="text" class="form-control" data-name="config_fallbackwidth" name="config-fallbackwidth">
                                                <span class="input-group-addon">px</span>
                                            </div>
                                        </div>
                                        <p class="help-block">Used in some circumstances with old webkit and SVG generation. Using preview size if not specified.</p>
                                    </div>

                                    <div class="form-group">
                                        <label class="col-xs-3 text-right">Fallback height:</label>
                                        <div class="col-xs-2">
                                            <div class="input-group">
                                                <input type="text" class="form-control" data-name="config_fallbackheight" name="config-fallbackheight">
                                                <span class="input-group-addon">px</span>
                                            </div>
                                        </div>
                                        <p class="help-block">Used in some circumstances with old webkit and SVG generation. Using preview size if not specified.</p>
                                    </div>

                                </form>

                            </div>
                            <div class="modal-footer">
                                <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
                            </div>
                        </div>
                    </div>
                </div>-->

            </div>

        </div>
        <br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br>
        <div id="coloroffsethtml" style="display:none;">
            <div class="coloroffset-container">
                <div class="offset-hue slider-container">
                    <div class="slider-inner">
                        <span class="slider-controller"></span>
                    </div>
                </div>
                <div class="offset-chroma slider-container">
                    <div class="slider-inner">
                        <span class="slider-controller"></span>
                    </div>
                </div>
                <div class="offset-lightness slider-container">
                    <div class="slider-inner">
                        <span class="slider-controller"></span>
                    </div>
                </div>
            </div>
        </div>

        <script src="/plugins/jquery/jquery.min.js"></script>
        <script src="/plugins/bootstrap/js/bootstrap.min.js"></script>

        <script src="/plugins/bootstrap-touchspin/bootstrap.touchspin.js"></script>
        <script src="/plugins/tinycolor/tinycolor.js"></script>
        <script src="/plugins/bootstrap-colorpickersliders/bootstrap.colorpickersliders.js"></script>
        <script src="css-gradient-generator.js"></script>

        <script src="/plugins/jquery.base64/jquery.base64.min.js"></script>
        <script src="/plugins/qrcode/qrcode.min.js"></script>
        <script src="/plugins/zeroclipboard/ZeroClipboard.js"></script>

        <script src="/plugins/syntaxhighlighter/3.0.83/shCore.js"></script>
        <script src="/plugins/syntaxhighlighter/3.0.83/shBrushCss.js"></script>

        <script>
            var ge = new CSSGradientEditor($('.css-gradient-editor-container'),{
				gradient_minimum_scale: 0,
				gradient_maximum_scale: <?php if (isset($_REQUEST['max'])) { echo $_REQUEST['max']; } else { echo '0'; }; ?>
			});
            ZeroClipboard.setDefaults({
                moviePath: '../zeroclipboard/ZeroClipboard.swf',
                trustedDomains: [window.location.host]
            });
            var clip = new ZeroClipboard($(".css-gradient-editor-copycss"));
            clip.on('dataRequested', function(client, args) {
                client.setText($("#cssoutput").data("output"));
            });
            clip.on('noflash wrongflash', function(client, args) {
                $(".css-gradient-editor-copycss").hide();
                ZeroClipboard.destroy();
            });
        </script>
	</body>
</html>
