<?php
$title = "Spreadsheet Guide: Data Links";

include('include/tmpl.php');

T('header-basic','title='.$title);

ST('section','class=content');
	ST('row');
		ST('half');
			ST('box','title=Data Links');
?> 	
            <p>When creating data links, you will need to use a very specific format.</p>
            <p>The guides below will give you the expected format for your installed data sources.</p>
			<p>You can also see your <a href="properties">Properties</a> and <a href="relationships" >Relationships</a></p>
	<?php
			ET();
			ST('box','title=Live Data'); ?>
            <p><ul style="font-size: small;">
            <?php
			include ($installfolder.'/data/live/list.php');
			foreach($sources as $src)
			{
				echo '<li>'.$src['name'].'<br/>';
				echo 'Data Source : <span style="font-family: \'Courier New\', Courier, monospace; font-weight: bold;">';
				echo str_replace('|',':',$src['sourceformat']);
				echo '</span><br/>';
				
				echo 'Data Link : <span style="font-family: \'Courier New\', Courier, monospace; font-weight: bold;">';
				echo str_replace('|',':',$src['linkformat']);
				//echo '|[< transform(s) >]';
				echo '</span><br/><br/>';
				echo '</li>';
			}
					
			?></ul>
            </p>    

<?php
			ET();
		ET();
		ST('half');
			ST('box','title=Historical Data'); ?>
            <p><ul style="font-size: small;">
            <?php
			include ($installfolder.'/data/historical/list.php');
			foreach($sources as $src)
			{
				echo '<li>'.$src['name'].'<br/>';
				echo 'Data Source : <span style="font-family: \'Courier New\', Courier, monospace; font-weight: bold;">';
				echo str_replace('|',':',$src['sourceformat']);
				echo '</span><br/>';
				
				echo 'Data Link : <span style="font-family: \'Courier New\', Courier, monospace; font-weight: bold;">';
				echo str_replace('|',':',$src['linkformat']);
				//echo '|[< transform(s) >]';
				echo '</span><br/><br/>';
				echo '</li>';
			}
					
			?></ul>
            </p>  			