<?php
	
	if (isset($_REQUEST['parent']))
	{
		$parent = filter_var($_REQUEST['parent'],FILTER_VALIDATE_INT);
		if ($parent === FALSE) exit;
	}
	
	if (isset($_REQUEST['rel']))
	{		
		$rel = filter_var($_REQUEST['rel'],FILTER_VALIDATE_INT);
		if ($rel === FALSE) exit;
		$relationship = $rel;
	}
	
	if (!isset($parent)) exit;
	
$title = $companyname." Import From Spreadsheet";

include('include/tmpl.php');

T('header-basic','title='.$title);

ST('section','class=content');
	ST('row');
		ST('half');
			ST('boxform','title=Select Spreadsheet');
?>	
            <p>Upload a Spreadsheet To Begin<hr/></p>
    
<?php			ST('ftable'); ?>
	
                <input type="file" name="content"/>
                <input type="submit" value="Upload"/>
                <?php if (isset($parent)) { ?>
                <input type="hidden" name="parentrelationship" value="<?php echo $rel;?>"/>
		        <input type="hidden" name="parentbase" value="<?php echo $parent;?>"/> 
				<?php }; ?>
			
<?php			ET();?>
			<br/>
            <p>For details on building your spreadsheet, please see the <a href="ssproperties.php" target="_blank">Properties</a>, <a href="ssrelationships.php" target="_blank">Relationships</a> and <a href="sslinks.php" target="_blank">Data Links</a> overview for your ARDI installation.</p>
            <p style="font-size: small">For detailed information on making spreadsheets to improve asset creation time, please see the <a href="/docs/spreadsheet.html">Spreadsheet Import Module Documentation</a></p>
<?php
			ET();
		ET();
	ET();
ET();

?>