<?php
	require_once($_SERVER['DOCUMENT_ROOT'].'/include/templateengine.php');
	require_once($_SERVER['DOCUMENT_ROOT'].'/config/settings.php');
	require_once($_SERVER['DOCUMENT_ROOT'].'/include/db.php');
	
	if (!isset($_REQUEST['resetcode']))
	{
		exit();
	}
	
	if ($_SERVER['REQUEST_METHOD'] == 'POST')
	{
		if (!isset($_REQUEST['password'])) exit;
		if (!isset($_REQUEST['confirm'])) exit;	
		
		$code = $_REQUEST['resetcode'];
		$pass = $_REQUEST['password'];
		$conf = $_REQUEST['confirm'];
		
		if ($pass != $conf)
		{
			$errormsg = "Passwords Do Not Match";
		}
		else
		{		
			require_once($_SERVER['DOCUMENT_ROOT'].'/include/login.php');
			
			$Auth = new AuthSystem();		
			$resp = $Auth->PasswordReset($code, $pass);
			if ($resp == "OK")
			{
				header("Location: /index.php");
				exit();
			}
			else
				$errormsg = "This Code Has Expired";			
		}
		
	}
	
	$code = $_REQUEST['resetcode'];
						
	$template = new Template('ARDI',$templatename);
	$template->Set('description','Email Action');			
	$template->Set('heading',$companyname);		
	$template->PublicPage();
	
	$template->AddStyleSheet('/css/linker.css');	
	$template->AddStyleSheet('/css/viewlist.css');		
	$template->AddStyleSheet('/css/alerts.css');		
	$template->AddStyleSheet('/css/err.css');				
	
function stripit($n)
{
	//return str_replace(" ","_",$n);
	return preg_replace("/[^a-zA-Z]/", "", $n);
}
	
	$template->Set('params','');

	if (isset($errormsg)) {
	$template->StartSection('onload');  ?>
	$('.errormessage').fadeIn(1000);
<?php	
	};
	
	$template->StartSection('content'); 
?>	

<div class="12u" >	
	<br/>
    <h3>Reset Password</h3>   
    
</div>

<div class="12u" >		      
    <?php
	if (isset($errormsg))
	{?>
		<div class="errormessage" style="display: none;"><?php echo $errormsg; ?></div><?php
	}
	?>
    <p>
    You can use the form below to update your ARDI access password
    </p>
   <form method="POST">	
    <table style="width: 50%;margin-left: auto; margin-right: auto;"><tr><td style="text-align: right; margin-right: 10px; width: 50%;"><label style="text-align: right;">Password:</label></td><td style="text-align: left; padding-left: 10px;"><input type="password" name="password"/></td> </tr>
       	<tr><td><label style="text-align: right;">Password (Again):</label></td><td style="text-align: left; padding-left: 10px;"><input type="password" name="confirm"/></td></tr>  </table>
        <input type="submit" value="Update Password"/>
        <?php
		echo '<input type="hidden" name="resetcode" value="'.$code.'"/>';
		?>
    </form>
</div>

    <?php
		
	$template->Write();
?>