<?php

    //echo 'Boo!';
    //exit;
    
    global $themefolder;
					
	$joinquery = "";
	$conditions = "";
	$q = $_REQUEST['text'];
	
	include($installfolder.'/model/asset.php');
	
	global $db;
	
	if ($q == "")
	{
		ob_start();
		
		echo '<h3>No Search Query</h3>';
		echo '<p>To search for assets, you must include some text to search for.</p><br/>';
		
		$c = ob_get_clean();
		if ($c != "")
		{
			$content['title'] = 'Invalid Query';
			$content[''] = '<ul class="assetlist">'.$c.'</ul>';
			include($installfolder.$themefolder.'/struct/box-collapsible.php');
		}
		exit;
	}
	
	ob_start();
	
	$hit = array();
	
	$query = $db->query("SELECT id,name,type FROM assets ".$joinquery."WHERE (name LIKE '%".$q."%')".$conditions." ORDER BY type,name");
							
    while($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$ast = new Asset($row['id']);
		$fn = $ast->GetFullName();
		$nl = strlen($fn) - strlen($ast->name);
		
		echo '<li class="searchlist"><span class="searchresult"><i class="fa fa-info"></i>&nbsp;&nbsp;<a href="'.$siteroot.'/dashboard/'.$row['id'].'">'.$row['name'];
		if ($row['type'] == 2) echo ' (Tag)';
		echo '</a><span class="searchdetail">in '.substr($fn,0,$nl).'</span></span></li>';
		$hit[] = $row['id'];
	}
	
	global $themefolder;
	$c = ob_get_clean();
	if ($c != "")
	{
		$content['title'] = 'Name Matches';
		$content[''] = '<ul class="assetlist">'.$c.'</ul>';
		include($installfolder.$themefolder.'/struct/box-collapsible.php');
	}

	ob_start();
	
	$query = $db->query("SELECT assets.id,assets.name,assets.type FROM assetvalues JOIN assets ON (assets.id = assetvalues.assetid)".$joinquery."WHERE (value LIKE '%".$q."%')".$conditions." ORDER BY assets.type,assets.name");
							
    while($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		if (in_array($row['id'],$hit)) continue;
		echo '<li><i class="fa fa-plus"></i>&nbsp;&nbsp;<a href="'.$siteroot.'/dashboard/'.$row['id'].'">'.$row['name'];
		if ($row['type'] == 2) echo ' (Tag)';
		echo '</a></li>';
		$hit[] = $row['id'];
	}
	
	$c = ob_get_clean();
	if ($c != "")
	{
		$content['title'] = 'Content Matches';
		$content[''] = '<ul class="assetlist">'.$c.'</ul>';
		include($installfolder.$themefolder.'/struct/box-collapsible.php');
	}
	
	//echo "SELECT id,name,type FROM assets ".$joinquery."WHERE (name LIKE '%".$q."%')".$conditions;
	
	//echo "SELECT id,name FROM assets ".$joinquery."WHERE (name LIKE '%".$q."%')".$conditions;
	
	ob_start();
	
	$query = $db->query("SELECT id,name,type FROM assets ".$joinquery."WHERE (descript LIKE '%".$q."%')".$conditions." ORDER BY type,name");
							
    while($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		if (in_array($row['id'],$hit)) continue;
		echo '<li><i class="fa fa-lightbulb-o"></i>&nbsp;&nbsp;<a href="'.$siteroot.'/dashboard/'.$row['id'].'">'.$row['name'];
		if ($row['type'] == 2) echo ' (Tag)';
		echo '</a></li>';
		$hit[] = $row['id'];
	}
	
	
	$c = ob_get_clean();
	if ($c != "")
	{
		$content['title'] = 'Description Matches';
		$content[''] = '<ul class="assetlist">'.$c.'</ul>';
		include($installfolder.$themefolder.'/struct/box-collapsible.php');
	}
	
	

?>
