<?php
  $format = "xml";
  if (isset($_REQUEST['format']))
  {
	$format = $_REQUEST['format'];
  }
  
  function APIError($errorcode, $errormessage)
  {
		global $format;
		$content = "<error><code>".$errorcode."</code><message>".$errormessage."</message></error>";
		if ($format != "xml")
		{
			if ($format == 'json')
			{
				header('Content-type: application/json');
				$xml = simplexml_load_string($content);
				$json = json_encode($xml);
				echo $json;
				exit;
			}
		}
		
		header('Content-type: text/xml');
		echo '<?xml version="1.0" encoding="UTF-8" standalone="no"?>';
		echo $content;
		exit;
  }
  
  function APISuccess($message)
  {
		global $format;
		$content = "<success><message>".$message."</message></success>";
		if ($format != "xml")
		{
			if ($format == 'json')
			{
				header('Content-type: application/json');
				$xml = simplexml_load_string($content);
				$json = json_encode($xml);
				echo $json;
				exit;
			}
		}
		header('Content-type: text/xml');
		echo '<?xml version="1.0" encoding="UTF-8" standalone="no"?>';
		echo $content;
		exit;
}
  
if ($_SERVER['PHP_SELF'] != '/api/auth.php')
{
	$guestmode = false;
	$apicode = "";
	if (!isset($_REQUEST['apicode']))
	{
		$settings = parse_ini_file($sitefolder.'/config/settings.ini');
		if ((!isset($userrequired)) || ($settings['guestmode'] == 'yes'))
		{
			$guestmode = true;
		}
		else
		{
			$errorcode = 301;
			$errormessage = "No Authentication Code Provided";
		}
	}
	else
		$apicode = $_REQUEST['apicode'];
	  
	if ($guestmode == false)
	{
		if (!class_exists("AuthSystem"))
		{
			include($installfolder.'/include/login.php');
		}
		
		$auth = new AuthSystem();
		$dbx = $auth->GetDatabase();
	
		$first = true;
		$query = $dbx->query("SELECT userid FROM userapi WHERE apicode=".$dbx->quote($apicode));
		if ($query !== FALSE)
		{
			  while($row = $query->fetch(PDO::FETCH_ASSOC)) 
			  {
				if ($first == true)
				{
					$userid = $row['userid'];
					$dbx->query("UPDATE userapi SET lastaccessed=NOW() WHERE apicode=".$dbx->quote($apicode));
					$first = false;
				}
				else
				{
					$errorcode = 305;
					$errormessage = "Duplicate Authentication Code Error";
				}
			}
		}
		else
		{
				$errorcode = 302;
				$errormessage = "Invalid Authentication Code";
		}
		if ($first == true)
		{
				$errorcode = 302;
				$errormessage = "Invalid Authentication Code";
		}
	}
	  
	if (isset($errorcode))
	{
			APIError($errorcode, $errormessage);
	}
}
?>