<?php
/**
 * Driver Function - Get driver details
 * 
 * During initialisation, this function is called to determine what
 *    sources need to be launched by each driver.
 *
 * Individual sources then get their own information from 'sourcedata'
 *
 * @author Steven Harding
 */	
 
	//require_once('../assets/ui/displayfunctions.php');
		
	header('Content-type: text/xml');
	echo '<?xml version="1.0" encoding="UTF-8" standalone="no"?>';
	
	echo '<driverinfo>';	
	
	//OK - fetch the data we need...
	$query = $db->query('SELECT * FROM datadriver WHERE port='.$_REQUEST['driver']);
	
	if($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{	
		echo '  <name>'.$row['name'].'</name>';
		echo '  <driver>'.$row['driver'].'</driver>';
		echo '  <address>'.$row['address'].'</address>';
		if ($row['mode'] == 0)
			echo '   <mode>Live</mode>';
		else
			echo '   <mode>Historian</mode>';
			
		//echo '     <driver port="'.$row['port'].'" driver="'.$row['driver'].'" address="'.$row['address'].'"/>';
	}	
	
	//echo '  </sources>';
	
	echo '</driverinfo>';
?>