<?php
/**
 * Gets a list of the different AR zones
 *
 * @author Steven Harding
 */	
 
		require_once($_SERVER['DOCUMENT_ROOT'].'/config/settings.php');
		require_once($_SERVER['DOCUMENT_ROOT'].'/include/db.php');

		include('apiauth.inc');
		
		ob_start();
	
		echo '<arzones>';
		
		$query = $db->query("SELECT id FROM properties WHERE typename='ARTAG'");
		if($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$pid = $row['id'];
		}
					      
		$query = $db->query("SELECT DISTINCT SUBSTRING(value,INSTR(value,'|')+1) as val FROM assetvalues WHERE propertyid=".$pid." ORDER BY val");
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			if ($row['val'] == "") continue;
			echo '  <zone>'.$row['val'].'</zone>';
		}
		
		echo '</arzones>';
	
		include('apioutput.inc');
	
?>