<?php
/**
 * Gets a list of objects and their relationships inside an environment
 *
 * Creates a list of objects within a given environment. 
 *
 * The 'id' parameters is the ID of the environment object.
 *
 * @author Steven Harding
 */	
		
	
		$itemid = $_REQUEST['id'];
	
		header("Content-type: text/xml");
		echo '<contents>';
		

		$query = $db->query("SELECT DISTINCT id FROM assets JOIN assetrelclosures ON (assetrelclosures.childasset=assets.id)");
		
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{			
			$any = false;
			
			include($sitefolder.'/cache/relationships/'.$row['id'].'.inc');
			
			
			if (isset($asset[$row['id']]))
			{				
				foreach($asset[$row['id']]['relationships'] as $k => $v)
				{
					//if ($k <= 3) continue;
					
					if ($any == false) 
					{
						echo '  <asset id="'.$row['id'].'">';
						$any = true;
						
						foreach($asset[$row['id']]['values'] as $k2 => $v2)
						{
							if ($v2['type'] == "ISOPOINT")
							{
								echo '<isolationpoint>';
								foreach($v2['rels'] as $r)
								{
									echo '  <rel>'.$r.'</rel>'; 
								}
								echo '</isolationpoint>';
							}
						}
					}
				
					foreach($v as $itm)
					{
						if ($itm['upstream'] == true)
						{
							echo '  <relationship rel="'.$k.'" to="'.$itm['target'].'">';
						}
						else
						{
							echo '  <relationship rel="'.$k.'" from="'.$itm['target'].'">';
						}
						
						echo '</relationship>';
					}				 
				}
			}
		    												
	    	if ($any == true) echo '</asset>';
		}
	
	echo '</contents>';
?>