<?php
/**
 * Performs an isolation check on the object. 
 * 
 * Note that this file is an include file designed to be called by other
 *    API functions and not to be called directly by clients
 *
 * @author Steven Harding
 */	
	$content = "";
	
	include($installfolder.'/include/isocheck.php');
	
	if (GetActiveSources($itemid) !== FALSE)
	{	
		$state = "Not Isolated";
		if (count($results) == 0)
		{
			$state = 'Isolated';
		}
		else
		{
			foreach($results as $res) 
			{
				if ($res['id'] == $itemid)
				{
					$state = 'Unknown';
					$content .= '<isopoint failedat="self"/>';
				}
			}
			
			foreach($results as $res)
			{
				$content .= '<isopoint failedat="'.$res['name'].'"/>';
			}
		}
		
		echo $content.'<status>'.$state.'</status>';
	}
	
	//Explore cache to locate upstream sources of other relevant data...
	
	/*$isocycle = array();
	global $isocycle;
	
	$contributors = array();
	global $contributors;	
	global $asset;
	global $itemid;
	
	//Now - search for secondaries!
	FindIsoPoints($itemid,0);
	
	if (count($contributors) != 0)
	{				
		$state = "Isolated";
		$content = "";
		foreach($contributors as $c)
		{
			//print_r($c);
			
			$indstate = "Yes";
			if ($c['value'] == "1")
			{
				if ($state != "Unknown") $state = "Not Isolated";
				$indstate = "No";
			}
			if ($c['value'] < "0")
			{
				$state = "Unknown";
				$indstate = "Unknown";
			}
			$content .= '<isopoint id="'.$c['id'].'" name="'.$c['name'].'" isolated="'.$indstate.'"/>';
		}
		
		echo $content.'<status>'.$state.'</status>';
	
	}
			
	function FindIsoPoints($id,$rels)
	{
		global $db;
		global $asset;
		global $contributors;
		global $itemid;
		global $isocycle;
		
		if (!isset($asset[$id]))
		{		
			require_once($sitefolder.'/cache/relationships/'.$id.'.inc');
		}
				
		if (!isset($asset[$id]))
		{		
			return;
		}
		
		if (in_array($id,$isocycle))
		{
			//echo 'Cyclic Dependency Detected - '.$id.' Links Back To '.$id;
			return;
		}	
		
		foreach($asset[$id]["values"] as $k => $v)
		{
			
			if ($rels != 0)
			{
				if ($v['type'] == "ISOPOINT") 
				{
					//Get Current Value...
					$query = $db->query("SELECT value FROM assetvalues WHERE propertyid=".$k." AND assetid=".$id);

					$typ = "";
					$stat = -1;
					if($row = $query->fetch(PDO::FETCH_ASSOC)) 
					{
						$bits = explode('|',$row['value']);
						if (count($bits) > 1)
						{
							$typ = $bits[0];
							$stat = $bits[1];
							
							if ($typ == $rels)
							{
								$nw = array();								
								$nw["name"] = $asset[$id]["name"];
								$nw["id"] = $id;
								$nw["value"] = LinkedData($id,$k,'state',$stat);
								//print_r($nw);
								$contributors[] = $nw;
								global $contributors;
								return;								
							}
						}
					}	
					
				}
			}
		}				
		
		if ($rels == 0)
		{			
			foreach($asset[$id]["relationships"] as $k => $v)
			{
				foreach($v as $rl)
				{
					if ($rl["upstream"] == true) FindIsoPoints($rl["target"],$k);
				}
			}
		}
		else
		{
			if (isset($asset[$id]["relationships"][$rels]))
			{
				foreach($asset[$id]["relationships"][$rels] as $rl)
				{
					if ($rl["upstream"] == true)
					{
						//echo 'Moving To '.$rl["target"];
						FindIsoPoints($rl["target"],$rels);
					}
				}
			}
		}				
	}	*/
    ?>