<?php
/**
 * Get a list of an objects relationships
 * 
 * Most of this information is available through 'getall'
 *
 * @author Steven Harding
 */	

$format = "xml";

if (isset($_REQUEST['format']))
{
	if ($_REQUEST['format'] == 'json')
	{
		$format = 'json';
	}
}

if ($format != "xml")
{
	ob_start();
}

if (!isset($_REQUEST['id']))
{
	exit;
}

$id = filter_var($_REQUEST['id'],FILTER_VALIDATE_INT);
if ($id === FALSE) exit;

//Content Here...

include($_SERVER['DOCUMENT_ROOT'].'/cache/relationships/all.inc');
include($_SERVER['DOCUMENT_ROOT'].'/cache/relationships/'.$id.'.inc');

echo '<relationships>';
foreach($asset[$id]['relationships'] as $k => $v)
{
	//print_r($v);
	foreach($v as $a=>$b)
	{
		$us = 0;
		if ($b['upstream'] == 1) $us = 1;
			
		echo '   <relationship id="'.$k.'" target="'.$b['target'].'" direction="'.$us.'"/>';
	}
}
echo '</relationships>';

if ($format != "xml")
{
	$content = ob_get_clean();
	if ($format == 'json')
	{
		$xml = simplexml_load_string($content);
		$json = json_encode($xml);
		echo $json;
		exit;
	}
}

?>