<?php
/**
 * Gets fundamental ARDI metadata
 *
 * This function returns the names of all relationships and properties.
 *
 * It is used to initialise all of the basic metadata of an external
 *   application (such as ARDI AR)
 *
 * @author Steven Harding
 */	
require_once($_SERVER['DOCUMENT_ROOT'].'/config/settings.php');
require_once($_SERVER['DOCUMENT_ROOT'].'/include/db.php');

$assets = $_REQUEST['for'];
$value = $_REQUEST['val'];
$format = "xml";
$assets = explode('|',$assets);

echo '<results>';
	
$query = $db->query("SELECT assetid,value FROM assetvalues WHERE (propertyid=".$value." AND assetid IN (".implode(',',$assets).") )");
		
while($row = $query->fetch(PDO::FETCH_ASSOC)) 
{
	echo '<result id="'.$row['assetid'].'" value="'.$row['value'].'"/>';
}	
		
echo '</results>';

if ($format != "xml")
{
	$content = ob_get_clean();
	if ($format == 'json')
	{
		$xml = simplexml_load_string($content);
		$json = json_encode($xml);
		echo $json;
		exit;
	}
}

?>