<?php
/**
 * Show An Asset Page
 * 
 * This page has no UI of its own - instead it redirects the user to
 *    a suitable URL given the search terms and view requested.
 *
 * @author Steven Harding
 */	
	require_once($_SERVER['DOCUMENT_ROOT'].'/config/settings.php');
	require_once($_SERVER['DOCUMENT_ROOT'].'/include/db.php');
	
	$apicode = "";
	if (isset($_REQUEST['apicode']))
	{
		$apicode = $_REQUEST['apicode'];
		$db->query("SELECT userid FROM users WHERE apicode='".$apicode."'");
		if($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$_SESSION['userid'] = $row['userid'];
		}
	}
	
	$attrtype = "";
	if (!isset($_REQUEST['attrtype']))
	{
		exit;
	}
	
	$attrtype = $_REQUEST['attrtype'];
	
	$query = $db->query('SELECT id FROM properties WHERE typename='.$db->quote($attrtype));
	
	$propid = 0;
	if($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$propid = $row['id'];
	}
	
	if ($propid == 0) exit;

	//Search for a hit by attribute...
	$query = $db->query('SELECT assetid FROM assetvalues WHERE propertyid='.$propid." AND value=".$db->quote($_REQUEST['search']));
		
	$foundid = 0;
	if($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$foundid = $row['assetid'];
	}
	
	if ($foundid == 0)
	{
		$query = $db->query('SELECT assetid FROM assetvalues WHERE propertyid='.$propid." AND value LIKE ".$db->quote('%'.$_REQUEST['search'].'%'));
		
		$foundid = 0;
		if($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$foundid = $row['assetid'];
		}
	}
	
	if ($foundid == 0)
	{
		echo 'Could Not Found Item With Matching Information';
		exit;
	}
	
	$method = 'ddashboard.php?id=';
	if (isset($_REQUEST['view']))
	{
		switch ($_REQUEST['view'])
		{
		case 'diagram':
			$method = 'dpid.php?id=';
			break;
		case 'hmi':
			$method = 'dhmi.php?id=';
			break;
		case 'view':
			$method = 'view.php?id=';
			break;						
		case 'locate':
			$method = 'find.php?id=';
			break;						
		case 'media':
			$method = 'media.php?id=';
			break;						
		}
	}
	
	header("Location: /assets/".$method.$foundid);
?>