<?php
/**
 * Driver Function - Update data
 * 
 * Used by ARDI drivers to push new information to ARDI (when they don't
 *    already have direct access to the ARDI database already)
 *
 * @author Steven Harding
 */	

	$values = "";
	foreach($_REQUEST as $k => $v)
	{
		$bits = explode(':',$k);
		if (count($bits) > 2)
		{
			$asset = $bits[0];
			$property = $bits[1];
			$node = $bits[2];
			
			if ($property == 'X') 
			{
				$db->query("UPDATE datasources SET lastwd = UTC_TIMESTAMP(), gatewayport=".$_REQUEST['port']." WHERE assetid=".$_REQUEST['asset']);
				continue;
			}
									
			$db->query("UPDATE datalinks SET lastvalue='".$v."', lastupdate=UTC_TIMESTAMP(), updaterequired=1 WHERE assetid=".$asset." AND propertyid=".$property." AND node='".$node."'");
		}		
	}
	
	//Include GENERAL data-gathering plugins
	$base = $installfolder.'/modules/daq';
	if (file_exists($base))
	{
		$files = scandir($base);
		foreach($files as $f)
		{
			if ($f[0] == ".") continue;
			include ($installfolder.'/modules/daq/'.$f);
		}
	}
	
	//Include SITE-SPECIFIC data-gathering plugins
	$base = $sitefolder.'/daq';
	if (file_exists($base))
	{
		$files = scandir($base);
		foreach($files as $f)
		{
			if ($f[0] == ".") continue;
			include ($sitefolder.'/daq/'.$f);
		}
	}
	
	
?>