<?php
	
	$asset = filter_var($_REQUEST['asset'],FILTER_VALIDATE_INT);
	if ($asset === FALSE) exit;

	$targetmode = 0;
	$targetprofile = 1;
	
	if (isset($_REQUEST['profile']))
	{
		$bits = explode('-',$_REQUEST['profile']);
		if (count($bits) == 2)
		{
			$targetprofile = $bits[0];
			if ($bits[1] == 'H') $targetmode = 1;
		}
	}
	
	$title = "Bind To Data Source";

	require_once($basefolder.'/include/tmpl.php');
			
	$property = filter_var($_REQUEST['property'],FILTER_VALIDATE_INT);
	if ($property === FALSE) exit;
	
	$itemdata = array();		
	$query = $db->query('SELECT * FROM assets WHERE id='.$_REQUEST['asset']);
	if($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$itemdata = $row;
	}	
	
	$mode = 'live';
	$modeid = 0;
	if (isset($_REQUEST['mode']))
	{
		$mode = $_REQUEST['mode'];
		if ($mode == 'hist') $modeid = 1;		
		if ($mode == 'sim') $modeid = 2;
		
		if ($modeid == 0) 
		{
			$mode = 'live';
		}
	}
	
	$sources = array();	
	$query = $db->query('SELECT * FROM datasources JOIN assets ON (assets.id = datasources.assetid) WHERE datasources.profile='.$targetprofile.' AND datasources.mode = '.$modeid.' ORDER BY name');
	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$sources[] = $row;
	}	
	
	if ($property > 0)
	{
		//echo 'Positive Property ('.$property.')';
		
		$query = $db->query('SELECT name,typename FROM properties WHERE id='.$property);
		if($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$propname = $row['name'];
			$proptype = $row['typename'];
		}	
	
		if (!file_exists($installfolder.'/modules/inputs/'.strtolower($proptype).'.php'))
		{
			//$template->StartSection('content'); 
			//echo '<h2>This module does not support external content.</h2>';
			//$template->Write();
			exit();
		}
		
		include($_SERVER['DOCUMENT_ROOT'].'/modules/inputs/'.strtolower($proptype).'.php');
	}
	else
	{
		$inputs = array();
		
		if ($property == -1)
		{							
			$node = filter_var($_REQUEST['node'],FILTER_VALIDATE_INT);
			if ($node === FALSE) exit;
				
			$inputs[] = array();
			$indx = count($inputs) - 1;
			$inputs[$indx]['name'] = 'alert_'.$node;
			$inputs[$indx]['displayname'] = 'Status';
			$inputs[$indx]['desc'] = 'The current status (1 or 0) of the alert';				
		}
	}
	
	//Get Existing Connections...
			
	$querystring = 'SELECT node,datalinks.address as dataaddress,datalinks.transform as transform,driver,sourceid,assets.name FROM datalinks JOIN datasources ON (datalinks.sourceid = datasources.assetid) JOIN assets ON (assets.id = datasources.assetid) WHERE datalinks.assetid='.$asset.' AND propertyid='.$property;
	
	$querystring .= " AND datalinks.mode=".$targetmode." AND datalinks.profile=".$targetprofile." AND datasources.mode=".$targetmode." AND datasources.profile=".$targetprofile;
	
	if ($property == -1)
	{
		$querystring .= " AND node='".$node."'";
		//echo $querystring;
	}
	
	echo 'Querying: '.$querystring;
			
	$query = $db->query($querystring);
	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		if ($property == -1)
		{
			$row['node'] = 'alert_'.$row['node'];
		}
		for($x=0;$x<count($inputs);$x++)
		{
			if ($inputs[$x]['name'] == $row['node'])
			{
				$inputs[$x]['source'] = $row['name'];
				$inputs[$x]['driver'] = $row['driver'];
				$inputs[$x]['address'] = $row['dataaddress'];
				$inputs[$x]['sourceid'] = $row['sourceid'];
				$inputs[$x]['tx'] = $row['transform'];
			}
		}
	}	
	
	for($x=0;$x<count($inputs);$x++)
	{
		if (!isset($inputs[$x]['source']))
		{
			$inputs[$x]['source'] = 'Not Connected';
		}
	}

	/*foreach($inputs as $inp)
	{?>
	$('#<?php echo $inp['name'];?>source').editable({
			type: 'select',  
            value: '<?php echo $inp['source'];?>', 
            source: [ {value: 'Not Connected', text: 'Not Connected'},<?php	
	for($x=0;$x<count($sources);$x++)
	{
		echo '{ value: "'.$sources[$x]['name'].'", text: "Linked To '.$sources[$x]['name'].'" }';
		if ($x < (count($sources)-1)) echo ',';
	}
?> ], 
			success: function(resp, nv) {
            	$('#<?php echo $inp['name'];?>sourcename').val(nv);
            	LoadLinkOptions('<?php echo $inp['name'];?>',nv);
            }
		});
    
<?php	
	}*/
	
	SS('onload'); 
//echo 'SELECT * FROM datalinks WHERE assetid='.$_REQUEST['asset'].' AND propertyid='.$_REQUEST['property'];	
	?>	

<script>
var sourcename = "";

function LoadLinkOptions(nm, val)
{
	if (val == 0)
	{
		//alert('Getting Value From <?php echo $siteroot; ?>/data/options');
		val = $('#' + nm + 'source').val();
	}
	//alert('Calling with Source: ' + val + " and Property " + nm);
	$.post('<?php echo $siteroot; ?>/data/options',{ source: val, property: nm },function(data) {
		//alert(data);
		sourcename = val;
		$('#' + nm + '_transform').remove();
		$('#' + nm + '_txdetail').remove();
		$('#' + nm + '_options').html(data);
		if (data != "")
		{
			$('#' + nm + '_options').fadeIn(500);
			$('#' + nm + '_save').fadeIn(500);
			//OptionsLoaded();
		}
		else
		{
			$('#' + nm + '_options').fadeOut(500);
			$('#' + nm + '_save').fadeOut(500);
		}
	});
	
	UpdateTransformOptions();
}

function TransformOptionSelected(fmt,nm)
{	
	$('#' + nm + '_txdetail').fadeOut(250);
	$.post('/datalink/transformoptions.php',{ transform: fmt, property: nm },function(data) {
		$('#' + nm + '_txdetail').html(data);
		if (data != "")
		{
			$('#' + nm + '_txdetail').fadeIn(250);
		}
		else
		{
			$('#' + nm + '_txdetail').fadeOut(250);
		}
	});
	window.setTimeout("TransformDetailsLoaded();",250);
	TransformDetailsLoaded();
}

function SetOutputFormat(fmt,nm)
{
	$.post('/datalink/txoptions.php',{ format: fmt, property: nm, source: sourcename },function(data) {
		$('#' + nm + '_transform').remove();
		$('#' + nm + '_txdetail').remove();
		$('#' + nm + '_options').after( data);
		$('#' + nm + '_transform').fadeIn(500);
		TransformOptionsLoaded();
		TransformDetailsLoaded();
	});
}
</script>

<?php SS('addscripts'); 

T('header-basic','title='.$title.'|backtrace=<li><a href="'.$siteroot.'/properties/'.$asset.'">'.$itemdata['name'].'</a></li>');

ST('section','class=content');
	ST('row');
		ST('half');
			ST('box','title=Profile');
				ST('buttonmenu');

	$nodes = "";
	if (isset($_REQUEST['node']))
	{
		$nodes = "&node=".$_REQUEST['node'];
	}
				
	$dflt = 1;
	$query = $db->query('SELECT * FROM profiles ORDER BY name');
	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$sel = 'default';
		if (($row['id'] == $targetprofile) && ($targetmode == 0)) $sel = 'success';
		echo '<li><a class="btn btn-'.$sel.'" href="'.$siteroot.'/data/connect?asset='.$asset.'&property='.$property.'&profile='.$row['id'].'-L'.$nodes.'"/>'.$row['name'].' - Live</a></li>';
		$sel = 'default';
		if (($row['id'] == $targetprofile) && ($targetmode == 1)) $sel = 'success';
		echo '<li><a class="btn btn-'.$sel.'" href="'.$siteroot.'/data/connect?asset='.$asset.'&property='.$property.'&profile='.$row['id'].'-H'.$nodes.'"/>'.$row['name'].' - Historical</a></li>';
	}
	
				ET();
			ET();
		ET();
		ST('half');
			ST('box','title=Data Bindings');?>
				<!--<input type="submit" value="Save And Continue" class="btn btn-success"/>&nbsp;&nbsp;<input type="submit" value="Save And Close" class="btn btn-success"/>-->
<?php
			SS('footer');
			
			if ($property == -1)
			{
				$ip = array();
				$ip['name'] = $node;
				$ip['displayname'] = 'Alert Status';
			}
?>
	<table class="joiner">
<?php

	//print_r($inputs);

	foreach($inputs as $inp)
	{
		$nm = $inp['name'];
		if (isset($inp['displayname']))
		{
			$nm = $inp['displayname'];
		}?>
		<tr><td style="width: 35%;text-align: right; padding-right: 10px; vertical-align: top;"><strong><?php echo ucwords(str_replace("_"," ",$nm)); ?></strong><br/><span style="font-size: smaller;"><?php echo $inp['desc']; ?></span></td><td style="padding-left: 10px;width: 65%;text-align: left; vertical-align: top;"><form action="savelink" method="POST" id="<?php echo $inp['name']; ?>_form"><input type="hidden" name="asset" value="<?php echo $_REQUEST['asset']; ?>"/><input type="hidden" name="property" value="<?php echo $_REQUEST['property']; ?>"/><input type="hidden" name="node" value="<?php echo $inp['name']; ?>"/><input type="hidden" name="sourceid" id="<?php echo $inp['name'];?>sourcename" value="<?php echo $inp['source'];?>"/>
        <input type="hidden" name="mode" id="<?php echo $inp['name'];?>sourcemode" value="<?php echo $targetmode;?>"/>
		<input type="hidden" name="profile" id="<?php echo $inp['name'];?>sourceprofile" value="<?php echo $targetprofile;?>"/>
		<?php
		if (!isset($inp['sourceid'])) { ?>
        <select id="<?php echo $inp['name']; ?>source" name="<?php echo $inp['name'];?>source" onchange="LoadLinkOptions('<?php echo $inp['name']; ?>',0);">
			<option value="">[ Not Connected ]</option><?php
	$query = $db->query('SELECT assetid,assets.name FROM datasources JOIN assets ON (datasources.assetid = assets.id) WHERE profile='.$targetprofile.' AND mode='.$targetmode.' ORDER BY assets.name');
	//echo 'SELECT assetid,assets.name FROM datasources JOIN assets ON (datasources.assetid = assets.id) WHERE profile='.$targetprofile.' AND mode='.$targetmode.' ORDER BY assets.name';
	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		echo '<option value="'.$row['assetid'].'"';
		if (isset($inp['sourceid'])) 
		{
			if ($row['assetid'] == $inp['sourceid']) echo ' selected';
		}
		echo '>'.$row['name'].'</option>';		
	}
			
	};?>	
		</select>        
    
     
     <?php
	 if ($inp['source'] != "Not Connected")
	 {
		$fldr = 'live';
		if ($targetmode == 1) $fldr = 'historical';
		if ($targetmode == 10) $fldr = 'asset';
	 
		$address = $inp['address'];
		//$driverfolder = str_replace("//","/",$_SERVER['DOCUMENT_ROOT'].'/datalink/');
		//echo 'Including - '.$installfolder.'/data/'.$fldr.'/'.$inp['driver'].'/decode.php';
		include($installfolder.'/data/'.$fldr.'/'.$inp['driver'].'/decode.php');
		echo '<span>';
		echo $results;
		
	    $results = "";
		$transform = $inp['tx']; 
		$pieces = explode('|',$transform);
	    $decoder = $installfolder.'/data/transforms/'.strtolower($pieces[0]).'/decode.php';
		if (file_exists($decoder)) 
			include($decoder);		
		
		if ($results != "")
		{
			echo '<br/><i>'.strtoupper(substr($results,0,1)).substr($results,1).'</i>';
		}
		echo '<br/>';		
		echo '<a class="btn btn-default" style="font-size: smaller; margin-bottom: 10px; margin-top: 10px;" href="'.$siteroot.'/data/deletelink?asset='.$_REQUEST['asset'].'&property='.$_REQUEST['property'].'&node='.$inp['name'].'&profile='.$targetprofile.'&mode='.$targetmode.'">Unlink</a>';
		echo '&nbsp;&nbsp;<a class="btn btn-default" style="font-size: smaller; margin-bottom: 10px; margin-top: 10px;" href="'.$siteroot.'/data/transform?asset='.$_REQUEST['asset'].'&property='.$_REQUEST['property'].'&node='.$inp['name'].'&profile='.$targetprofile.'&mode='.$targetmode.'">Edit Transform</a>';
		echo '</span>';
	 }?> 
            
  <div class="link" id="<?php echo $inp['name'];?>_options" style="margin-top: 10px;margin-bottom: 10px;"></div><a href="#" id="<?php echo $inp['name'];?>_save" style="display: none; margin-bottom: 15px;" onclick="$('#<?php echo $inp['name']; ?>_form').submit(); return false;" class="btn btn-success">Save Link</a></form></td></tr> <!-- $('#<?php echo $inp['name']; ?>_form').submit(); -->
<?php
	}
?>    
	</table>
    
    <?php	
				ET();
			ET();
		ET();
	ET();

?>