<?php
	
	if (isset($_REQUEST['driver']))
	{
		//echo 'Submitting...';
		if (strpos($_REQUEST['driver'],".") !== FALSE) exit;
		if (strpos($_REQUEST['driver'],"/") !== FALSE) exit;
		
		//print_r($_REQUEST);
		//exit;
		
		$profile = $_REQUEST['profile'];
		$mode = $_REQUEST['mode'];
		/*$profiledata = $_REQUEST['profile'];*/

		$fldr = 'live';
		
		if ($mode == 10)
		{
			$fldr = 'asset';
		}
		else
		{
			if ($mode == 1)
			{
				$fldr = 'historical';
			}
		}
		
		$urate = 30;
		if (isset($_REQUEST['urate']))
		{
			$urate = filter_var($_REQUEST['urate'],FILTER_VALIDATE_INT);
			if ($urate === FALSE)
			{
				$urate = 30;
			}
		}
		
		ob_start();
		
		$asset = filter_var($_REQUEST['assetid'],FILTER_VALIDATE_INT);
		if ($asset === FALSE) exit;
		
		//print_r($_REQUEST);
		//exit;
		
		$drvid = $_REQUEST['driver'];
		if ($drvid != "")
		{
			if ($drvid[0] == 'D')
			{
				//Driverless...
				$driver = substr($drvid,2);
				$port = 0;
			}
			else
			{		
				//Get driver name for port number...
				$drvid = filter_var($_REQUEST['driver'],FILTER_VALIDATE_INT);
				if ($drvid === FALSE) exit;
				
				$port = $drvid;
				
				$drivers = array();
				$query = $db->query("SELECT * FROM datadriver WHERE port=".$drvid);	
				if ($query !== FALSE)
				{
					if($row = $query->fetch(PDO::FETCH_ASSOC)) 
					{
						$driver = $row['driver'];
					}
				}				
			}
			//require($installfolder.'/data/'.$fldr.'/'.$driver.'/configure-source.php');
			include($installfolder.'/data/'.$fldr.'/'.$driver.'/saveconfig-source.php');
		}

		$profile = 1;
		
		$drv = $_REQUEST['drivername'];
		
		$mode = 0;
		if ($fldr == "asset")
		{
			$mode = 10;
		}
		if ($fldr == "historical")
		{
			$mode = 1;
		}
		
						
		$db->query("DELETE FROM datasources WHERE assetid=".$_REQUEST['assetid'].' AND profile='.$profile.' AND mode='.$mode);	
		
		if ($port != 0)
		{
			$db->query("INSERT INTO datasources (assetid,driver,address,mode, profile,gatewayport,samplerate) VALUES (".$asset.",".$db->quote($driver).",".$db->quote($savestring).",".$mode.",".$profile.",".$port.",".$urate.")");
		}
		
		//echo "INSERT INTO datasources (assetid,driver,address,mode, profile,gatewayport) VALUES (".$asset.",".$db->quote($driver).",".$db->quote($savestring).",".$mode.",".$profile.",".$port.")";
		
		//exit;
		
		require($installfolder.'/include/dynamicdata.php');
		SpinupDataSource($asset);
		
		ob_get_clean();
		
		header('Location: '.$siteroot.'/sources/'.$_REQUEST['assetid']);
				
		exit;
	}
	
	
	if (isset($_REQUEST['id']))
	{
		$itemid = $_REQUEST['id'];
	}
			
	if ($itemid != 0)
	{
		$itemdata = array();		
		$query = $db->query('SELECT * FROM assets WHERE id='.$itemid);

		if($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$itemdata = $row;
		}	
	}
	
	$title = "Select Data Source";
	
	function GetDriverList($f)
	{
		$sources = array();

		global $installfolder;
		$fn = $installfolder.'/data/'.$f;

		$dirs = glob( $fn.DIRECTORY_SEPARATOR.'*',GLOB_ONLYDIR);
		$ln = strlen($fn)+1;

		//print_r( $fn.'/*');

		//print_r($dirs);

		foreach($dirs as $d)
		{
			$file = $d.DIRECTORY_SEPARATOR.'info.inc';
			
			$src = array();
			
			if (file_exists($file))
			{
				include($file);
				if (count($src) == 0) continue;
				$src['code'] = substr($d,$ln);
				$sources[] = $src;
			}
		}
		
		return $sources;
	}

	require_once($basefolder.'/include/tmpl.php');	
	
	$locationparents = array();		
	$query = $db->query('SELECT name,id FROM assetrelclosures JOIN assets ON (assetrelclosures.parentasset = assets.id) WHERE childasset='.$itemid.' AND depth > 0 ORDER BY depth ASC');
	
	$str = "";
	$candidates = array();
	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		if ($str != "") $str .= ' | ';
		$str .= '<a href="view.php?id='.$row['id'].'">'.$row['name'].'</a>';		
		$candidates[] = $row;
	}			
	
	$query = $db->query("SELECT properties.name,assetvalues.value FROM properties JOIN assetvalues ON (properties.id = assetvalues.propertyid) WHERE typename='LOCATION' AND assetvalues.assetid=".$itemid);						
	
	if($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$position = $row['value'];
	}	
	
	$sourcedetails = array();
	
	if (!isset($_REQUEST['profile'])) exit;
	$profile = filter_var($_REQUEST['profile'],FILTER_VALIDATE_INT);
	if ($profile === FALSE) exit;
	
	if (!isset($_REQUEST['mode'])) exit;
	$mode = filter_var($_REQUEST['mode'],FILTER_VALIDATE_INT);
	if ($mode === FALSE) exit;
	
	$query = $db->query("SELECT * FROM datasources WHERE assetid=".$itemid.' AND profile='.$profile.' AND mode='.$mode);						
	
	$currentdriver = "";	
	$currentdrivername = "";
	$currentaddress = "";
	$currentmode = $mode;
	$currentprofile = $profile;
	$currentgateway = 0;
	$currenturate = 30;
	if ($query !== FALSE)
	{
		if($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$sourcedetails = $row;
			$currentdriver = $sourcedetails['driver'];
			$currentaddress = $sourcedetails['address'];
			$currentprofile = $sourcedetails['profile'];
			$currentmode = $sourcedetails['mode'];
			$currentgateway = $sourcedetails['gatewayport'];
			$currenturate = $sourcedetails['samplerate'];
			//echo 'Found Existing: '.$currentprofile;
		}			
	}

	if (count($sourcedetails) == 0)
	{
		$sourcedetails['gatewayport'] = -1;
	}
	
	
	$drivers = array();
	$query = $db->query("SELECT * FROM datadriver");							
	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$drivers[] = $row;
	}	
	
	$currentmode = $_REQUEST['mode'];
	$currentprofile = $_REQUEST['profile'];
	
	//include($installfolder.'/data/sourcelist.php');    
    
T('header-basic','title='.$title);

?>
<script>
	function FetchDriverList()
	{
		//alert('Fetching...' + $('#profile').val());
		$.post('<?php echo $siteroot; ?>/data/getvaliddrivers',{ profile: $('#profile').val() },function (data) {
			//alert('Got ' + data);
			$('#drivername').html('<option value="">[Select Data Driver]</option>' + data);
		});
	}
	
	function FetchDriverOptions()
	{
		var dname = $('#drivername').val();
		if (dname == "")
		{
			$('#modulea').html("Please select a profile and driver to continue.");
			return;
		}
		
		//alert('Requesting Profile ' + $('#profile').val() + " / For Driver " + dname);
		$.post('<?php echo $siteroot; ?>/data/getdriveroptions',{ profile: "<?php echo $profile; if ($mode == 0) echo '-L'; else echo '-H'; ?>", driver: dname },function (data) {
			if (data == "")
				$('#modulea').html('This driver does not require any configuration');
			else
				$('#modulea').html('<table class="table table-bordered table-form">' + data + "<input type=\"hidden\" name=\"profile\" value=\"<?php echo $profile; ?>\"/><input type=\"hidden\" name=\"mode\" value=\"<?php echo $mode; ?>\"/></table>");
				
			$('#savebutton').fadeIn(500);
		});
	}
</script>
<form method="POST">
<?php

ST('section','class=content');
	ST('row');
		ST('half');
			ST('box','title=Data Source Details');		
?>	
	    <input type="hidden" id="drivername" name="drivername" value="<?php echo $sourcedetails['gatewayport']; ?>"/>        <input type="hidden" id="assetid" name="assetid" value="<?php echo $itemid; ?>"/>
		<input type="hidden" id="urate" name="urate" value="<?php echo $currenturate; ?>"/>
		<?php
			SS('footer');
				ST('ftable');
		?>
		<!--<tr><td><label>Profile : </label></td><td><select id="profile" name="profile" onchange="FetchDriverList();"><option value="">[ Select A Profile ]</option><?php
		$query = $db->query('SELECT * FROM profiles ORDER BY name');

		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			echo '<option value="'.$row['id'].'-L"';
			if (($currentprofile == $row['id']) && ($currentmode == 0)) echo ' selected';
			echo '>'.$row['name'].' - Live</option><option value="'.$row['id'].'-H"';
			if (($currentprofile == $row['id']) && ($currentmode == 1)) echo ' selected';
			echo '>'.$row['name'].' - Historical</option>';
		}	
		
		?><option value="0"<?php if ($currentmode == 10) echo ' selected';?>>Asset Information</option></select></td></tr>-->
		<tr id="drivertyperow"><td><label>Driver : </label></td><td><select id="drivername" name="driver" onchange="FetchDriverOptions();"><option value="">[ No Driver ]</option><?php
			
				//Figure out the name of the current driver...
				
				$query = $db->query('SELECT driver,name,port FROM datadriver');
				$existing = array();
				while($row = $query->fetch(PDO::FETCH_ASSOC)) 
				{
					$existing[] = $row;
				}	
				
				if ($currentmode != 10)
				{
					if ($currentmode == 0)
					{
						$sources = GetDriverList('live');
						//include($installfolder.'/data/live/list.php');
					}
					else
					{
						$sources = GetDriverList('historical');
						//include($installfolder.'/data/historical/list.php');
					}
				}
				else
				{
					$sources = GetDriverList('asset');
					//include($installfolder.'/data/asset/list.php');
				}
				
				foreach($sources as $src)
				{
					$found = 0;
					foreach($existing as $e)
					{
						if ($e['driver'] == $src['code'])
						{
							$found = $e['port'];
							break;
						}
					}
					if ($found != 0)
					{
						echo '<option value="'.$found.'"';
						if ($found == $currentgateway) echo ' selected';
						echo '>'.$src['name'].'</option>';
					}
				}
				
			
		?></select><!--<?php echo $currentdrivername;?>--></td></tr>
        <?php
				ET();
			ET();
		ET();
		ST('half'); 
			ST('box','title=Driver Settings');?>
			<input type="submit" value="Save Data Source Settings" id="savebutton" class="btn btn-success"<?php if (trim($currentdriver) == "") echo ' style="display: none;"';?>/>
			<?php SS('footer'); ?>
			
		<div id="modulea">    
        <?php
		$fldr = 'live';
		
		if ($currentmode == 10)
		{
			$fldr = 'asset';
		}
		else
		{
			if ($currentmode == 1)
			{
				$fldr = 'historical';
			}
		}
		
		if ($currentdriver != "")
		{
			
			echo '<table class="table table-bordered table-form">';
			include($installfolder.'/data/'.$fldr.'/'.$currentdriver.'/configure-source.php');
			echo '</table>';
		}
		else
		{
			echo 'Please select a driver to continue.';
		}
		?>    
        </div>
<?php
			ET();
		ET();
	ET();
ET();
?>
</form>