<?php
	require_once($_SERVER['DOCUMENT_ROOT'].'/include/templateengine.php');
	require_once($_SERVER['DOCUMENT_ROOT'].'/config/settings.php');
	require_once($_SERVER['DOCUMENT_ROOT'].'/include/db.php');

	//print_r($_REQUEST);

	if (!isset($_REQUEST['id']))
	{
		exit;
	}
	
	$itemid = $_REQUEST['id'];
	
	$itemdata = array();		
	$query = $db->query('SELECT * FROM datasources WHERE id='.$itemid);
	
	if($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$itemdata = $row;
	}	
	
	$drivername = $itemdata['driver'];
	if (isset($_REQUEST['driver']))	$drivername = $_REQUEST['driver'];

	if (isset($_REQUEST['name']))
	{
		include($drivername.'/saveconfig-source.php');	
		
		$db->query("UPDATE datasources SET name='".$_REQUEST['name']."', driver='".$drivername."',address='".$savestring."' WHERE id=".$itemid);
		
		header('Location: /datalink/sources.php');
				
		exit;
	}
		
	$template = new Template('ARDI',$templatename);
	$template->Set('description','Sources');			
	$template->Set('heading','Configure Sources');	
	
	$template->AddStyleSheet('/css/jquery-editable.css');
	$template->AddStyleSheet('/css/tip-yellowsimple/tip-yellowsimple.css');
	$template->AddStyleSheet('/css/tip-skyblue/tip-skyblue.css');								
	
	$template->StartSection('onload'); 
	
	include('sourcelist.php');

	$template->StartSection('content'); 
?>

    <script src="/js/jquery.poshytip.min.js"></script>
    <script src="/js/jquery-editable-poshytip.js"></script>
    
<script>
    $(document).ready(function() {		
		$('#srcname').editable({
			 url: function(params) {
					$('#drivername').val(params.value);
					$.post('/datalink/getmodule.php', {id : $('#srcname').val() }, function (data) {
							$('#modulea').html(data);
							LoadA();
					});
					var d = new $.Deferred;	
					return d.resolve();
			  },
			type: 'select',
			pk: 1,			
			title: 'Change Source Type',
			source: [
<?php
	$drivertitle = "";
	foreach($sources as $src)
	{
		if ($src['code'] == $drivername)
		{
			$drivertitle = $src['name'];
			break;
		}
	}
?> ]
		});
    });
</script>

<div class="12u" >	
	<br/>	
	<form style="margin-left: auto; margin-right: auto;" method="POST" action="source.php">
    	<input type="hidden" id="id" name="id" value="<?php echo $itemid; ?>"/>
	    <input type="hidden" id="drivername" name="drivername" value="<?php echo $drivername; ?>"/>
    	<label style="display: inline;">Name : </label>
        <input type="text" name="name" id="name" value="<?php echo $itemdata['name'];?>"/><br/><br/>
        
		<label style="display: inline;">Driver : </label><a id="srcname" href="#" data-type="select" data-pk="drvname" data-placeholder="Choose Source Type" data-emptytext="Choose Source Type" data-value="<?php echo $drivername; ?>" data-title="Choose Source Type" class="popupedit"><?php echo $drivertitle; ?></a>
        		
		<div id="modulea">
        <?php
			$data = $itemdata['address'];
			include($drivername.'/configure-source.php');
		?>
        </div>
	</form>
    </div>
<?php
	$template->Write();
?>
