<?php
 /**
 * Creates an object cache
 *
 * Provides functions to rebuild/update the object cache.
 */	
			
	function RebuildObjectCacheByID($assetid)
	{
		global $db;
		$query = $db->query('SELECT id,name FROM assets WHERE id='.$assetid);
	
		if($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$values = $row;
		}	
		
		if (isset($values))	RebuildObjectCache($row['id'],$row['name']);
	}

	function RebuildObjectCache($assetid,$assetname)
	{
		global $db;

		//echo 'Caching relationships and properties for asset '.$asset;
				
		$content = "<?php \r\n";
		
		$content .= '$asset['.$assetid.'] = array();';

		$content .= '$asset['.$assetid.']["name"] = "'.$assetname.'";';
		
		$query = $db->query("SELECT parentasset, assets.name, relationships.upstreamname, relationship FROM assetrelationships JOIN relationships ON (relationships.id = assetrelationships.relationship) JOIN assets ON (assets.id = parentasset) WHERE childasset=".$assetid);
		
		$content .= '$asset['.$assetid.']["relationships"] = array();';

		$relsdone = array();

		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			if (!in_array($row['relationship'],$relsdone)) 
			{
				$content .= '$asset['.$assetid.']["relationships"]['.$row['relationship'].'] = array();';
				$relsdone[] = $row['relationship'];
			}

			$content .= '$bf = array(); $bf["target"]= '.$row['parentasset'].'; $bf["upstream"] = true;';
			$content .= '$asset['.$assetid.']["relationships"]['.$row['relationship'].'][] = $bf;';
		}			
		
		$query = $db->query("SELECT childasset, assets.name, relationships.upstreamname, relationship FROM assetrelationships JOIN relationships ON (relationships.id = assetrelationships.relationship) JOIN assets ON (assets.id = childasset) WHERE parentasset=".$assetid);
				
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			if (!in_array($row['relationship'],$relsdone)) 
			{
				$content .= '$asset['.$assetid.']["relationships"]['.$row['relationship'].'] = array();';
				$relsdone[] = $row['relationship'];
			}

			$content .= '$bf = array(); $bf["target"]= '.$row['childasset'].'; $bf["upstream"] = false;';
			$content .= '$asset['.$assetid.']["relationships"]['.$row['relationship'].'][] = $bf;';
		}	
		
		$cachedvalues = "'MEASUREMENT','STATUS','ISOPOINT','NRPOINT'";
		
		$content .= '$asset['.$assetid.']["values"] = array();';
		
		$done = array();
				
		$query = $db->query("SELECT assetvalues.propertyid, properties.name, properties.typename,node FROM assetvalues JOIN properties ON (properties.id = assetvalues.propertyid) LEFT OUTER JOIN datalinks ON (datalinks.propertyid=assetvalues.propertyid AND datalinks.assetid=assetvalues.assetid) WHERE assetvalues.assetid=".$assetid." AND (properties.typename IN (".$cachedvalues."))");
		
		//echo "SELECT assetvalues.propertyid, properties.name, properties.typename,node FROM assetvalues JOIN properties ON (properties.id = assetvalues.propertyid) LEFT OUTER JOIN datalinks ON (datalinks.propertyid=assetvalues.propertyid AND datalinks.assetid=assetvalues.assetid) WHERE assetvalues.assetid=".$asset." AND (properties.typename IN (".$cachedvalues."))";
			
		$lastpropid = 0;
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$done[] = $row['propertyid'];
			if ($lastpropid != $row['propertyid'])
			{
				$content .= '$asset['.$assetid.']["values"]['.$row['propertyid'].'] = array();';
				$content .= '$asset['.$assetid.']["values"]['.$row['propertyid'].']["name"] = "'.$row['name'].'";';
				$content .= '$asset['.$assetid.']["values"]['.$row['propertyid'].']["type"] = "'.$row['typename'].'";';				
				if ((isset($row['node'])) && ($row['node'] != ""))
				{
					$content .= '$asset['.$assetid.']["values"]['.$row['propertyid'].']["links"] = array();';
				}				
				$lastpropid = $row['propertyid'];
			}
			if ((isset($row['node'])) && ($row['node'] != ""))
			{
				$content .= '$asset['.$assetid.']["values"]['.$row['propertyid'].']["links"]["'.$row['node'].'"] = "'.$assetid.':'.$row['propertyid'].':'.$row['node'].'";';
			}	
		}	
		
		$query = $db->query('SELECT properties.id as propertyid,name,typename,value,depth FROM assetrelclosures JOIN assetvalues ON (assetvalues.assetid = assetrelclosures.parentasset) JOIN properties ON (properties.id = assetvalues.propertyid) WHERE assetrelclosures.childasset='.$assetid.' AND assetrelclosures.relationship = 3 AND (properties.typename IN ('.$cachedvalues.')) ORDER BY depth DESC, name ASC');
														
		if ($query !== FALSE)
		{														
			while($row = $query->fetch(PDO::FETCH_ASSOC)) 
			{
				if (in_array($row['propertyid'],$done)) continue;
				
				$done[] = $row['propertyid'];
				
				if ($row['value'] == '@') continue;
				
				//$propcount++;
				$content .= '$asset['.$assetid.']["values"]['.$row['propertyid'].'] = array();';
				$content .= '$asset['.$assetid.']["values"]['.$row['propertyid'].']["name"] = "'.$row['name'].'";';
				$content .= '$asset['.$assetid.']["values"]['.$row['propertyid'].']["type"] = "'.$row['typename'].'";';
			}	
		}			

		//References
		$any = false;
		
		$query = $db->query('SELECT childasset,childproperty FROM assetreferences WHERE parentasset='.$assetid);
														
		if ($query !== FALSE)
		{														
			while($row = $query->fetch(PDO::FETCH_ASSOC)) 
			{
				if ($any == false)
				{
					$content .= '$asset['.$assetid.']["ref"] = array();';
				}
				
				$content .= '$asset['.$assetid.']["ref"][] = "'.$row['childasset'].'-'.$row['childproperty'].'";';
			}	
		}
		
		$content .= "?>";
		
		global $sitefolder;
		
		file_put_contents($sitefolder.'/cache/relationships/'.$assetid.'.inc',$content);

		//$assetid = $asset;
		
		global $asset;
		//echo 'Rewrote Cache File!';
		if (isset($asset[$assetid])) unset($asset[$assetid]);
		
		
		//include($sitefolder.'/cache/relationships/'.$asset.'.inc');
		//print_r($relproperties);
	}	
?>