<?php
 /**
 * LDAP / AD Auth
 *
 * TODO: This function is extremely incomplete
 */	

function GUIDToString($ADguid)
{
   $guidinhex = str_split(bin2hex($ADguid), 2);
   $guid = "";
   //Take the first 4 octets and reverse their order
   $first = array_reverse(array_slice($guidinhex, 0, 4));
   foreach($first as $value)
   {
      $guid .= $value;
   }
   $guid .= "-";
   // Take the next two octets and reverse their order
   $second = array_reverse(array_slice($guidinhex, 4, 2, true), true);
   foreach($second as $value)
   {
      $guid .= $value;
   }
   $guid .= "-";
   // Repeat for the next two
   $third = array_reverse(array_slice($guidinhex, 6, 2, true), true);
   foreach($third as $value)
   {
      $guid .= $value;
   }
   $guid .= "-";
   // Take the next two but do not reverse
   $fourth = array_slice($guidinhex, 8, 2, true);
   foreach($fourth as $value)
   {
      $guid .= $value;
   }
   $guid .= "-";
   //Take the last part
   $last = array_slice($guidinhex, 10, 16, true);
   foreach($last as $value)
   {
      $guid .= $value;
   }
   return $guid;
}

function ADAuth($username, $password, $server, $domain,$addomain, $userbasedn)
{
	$response = array();
	$ldap = ldap_connect($server);
	//echo 'Connecting '.$domain.$username.'<br/>';
	if ($bind = ldap_bind($ldap, $domain.$username, $password)) 
	{		
			//OK - let's get some user details...
			$filter="userprincipalname=".$username."@".$addomain;
			$entries= array("ou", "sn", "givenname", "mail", "userprincipalname", "objectguid", "dn");
	   
			$result = ldap_search($ldap, $userbasedn, "(&(objectClass=user)($filter))", $entries);
			if ($result === FALSE) 
			{
				ldap_unbind($ldap);
				return FALSE;
			}
			
			$info = ldap_get_entries($ldap, $result);
			if ($info === FALSE)
			{
				ldap_unbind($ldap);
				return FALSE;
			}
				
			/*echo "Info: ";
			print_r($info);
			echo "<br/><br/>";
			echo "Result: ";
			print_r($result);
			echo "<br/><br/>";*/
				
			$response['username'] = $info[0]['givenname'][0]." ".$info[0]['sn'][0];
			
			$response['guid'] = GUIDToString($info[0]['objectguid'][0]);
			
			$response['email'] = $info[0]['mail'][0];
			$response['valid'] = true;	
			
			//Request Group Membership Details...
			$dn = $info[0]['dn'];
						
			$response['groups'] = array();
			$attributes = array('memberof');
		    $result = ldap_read($ldap, $dn, '(objectclass=*)', $attributes);
		    if ($result !== FALSE) 
			{ 				
			    $entries = ldap_get_entries($ldap, $result);
			    if ($entries['count'] > 0) 
				{				
					foreach($entries[0]['memberof'] as $k => $entry)
					{
						if ($k == 'count') continue;
						$txt = $entry;
						$ps = strpos($txt,",",0);
						if ($ps !== FALSE)
						{
							$txt = substr($entry,3,$ps-3);
						}
						$response['groups'][] = $txt;
					}
				}							
			}
			
			//print_r($response['groups']);
			
			ldap_unbind($ldap);
			return $response;					
	}
	return FALSE;
}

?>