<?php

/**
 * Driver Function - Update alert information
 * 
 * Performs the logic on alerts to trigger them when incoming data
 *   to 'sourcepush' includes alert information.
 *
 * @author Steven Harding
 */	

	$query = $db->query("SELECT alerts.id,datalinks.assetid, lastvalue, state FROM datalinks JOIN alerts ON (alerts.assetid=datalinks.assetid) AND (alerts.id = datalinks.node) WHERE propertyid=-1");

	$alertstatus = array();	
	$assetsforupdate = array();
	
	//echo 'Updating Alerts...';
	
	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$ar = array();
		$ar['value'] = $row['state'];
		$ar['asset'] = $row['assetid'];
		$ar['node'] = $row['id'];
		
		$alertstatus[$row['id']] = $ar;
		$assetsforupdate[] = $row['assetid'];		
	}
	
	//print_r($_REQUEST);
	
	foreach($alertstatus as $k => $v)
	{
		if ($v['value'] == '^') $v['value'] = 1;
		
		$code = $v['asset'].':-1:'.$v['node'];
		if (isset($_REQUEST[$code]))
		{
			$n = $_REQUEST[$code];
			if ($n > 1)
			{
				if ($n > 50) 
					$n = 1;
				else
					$n = 0;
			}
			
			if ($n != $v['value'])
			{
				//echo "UPDATE alerts SET state=".$n." WHERE id=".$v['node'];
				$db->query("UPDATE alerts SET state=".$n." WHERE id=".$v['node']);	
				//echo 'Saving Alert State - '.$v['value'].' != '.$n;
			}
		}
	}
			
	$processed = array();
	
?>