<?php

	OnlyShowIf(CheckAdmin());
	
	$asset = filter_var($_REQUEST['src'],FILTER_VALIDATE_INT);
	$port = filter_var($_REQUEST['id'],FILTER_VALIDATE_INT);
	
	if ($asset === FALSE) exit;
	if ($port === FALSE) exit;
	$mode = 0;
	if (isset($_REQUEST['enable']))
	{
		if ($_REQUEST['enable'] == 1) $mode = 1;
	}

	//Determine the IP and port number of the ARDI driver...
	global $db;
	$query = $db->query('SELECT * FROM datasources LEFT OUTER JOIN datadriver ON (datadriver.port = datasources.gatewayport) WHERE datasources.assetid='.$asset.' AND datadriver.port = '.$port);

	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		if ((!isset($row['port'])) || ($row['port'] == 0))
		{
			$query = $db->query('SELECT * FROM datadriver WHERE driver='.$db->quote($row['driver']));
			if ($query !== FALSE)
			{
				if($rx = $query->fetch(PDO::FETCH_ASSOC)) 
				{
					$row['address'] = $rx['address'];
					$row['port'] = $rx['port'];
					//$db->query('UPDATE datasources SET gatewayport='.$rx['port'].' WHERE assetid='.$srcno);
				}
			}
		}
		$ip = $row['address'];
		if ($ip == "") $ip = "localhost";
		$port = $row['port'];
	}		
	
	//Upgrade to v2 (socket-based IPC, not Web Service)
	if (isset($ip))
	{
		$ip = gethostbyname($ip);
		$client = stream_socket_client("tcp://".$ip.":".$port,$err,$errmsg);
		fwrite($client,"debug|".$asset."|".$mode."\r\n");
		fclose($client);
		
		echo 'Sending &quot;'."debug|".$asset."|".$mode.'&quot; Message To '."tcp://".$ip.":".$port;
		echo $err;
		echo $errmsg;
	}

	header('Location: '.$siteroot.'/admin/drivers/logs');

?>
