<?php
	
	OnlyShowIf(CheckAdmin());
	
	$id = 0;
	if (isset($_REQUEST['id'])) 
	{
		$id = filter_var($_REQUEST['id'],FILTER_VALIDATE_INT);
		if ($id === FALSE) exit;
	}
	
	$propinfo = array();
	if ($id != 0)
	{
		$query = $db->query('SELECT * FROM models WHERE id='.$id);
	
		if($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$propinfo = $row;
		}

		$modename = "Update Model";
		
		if ((isset($_REQUEST['delete'])) || ((isset($_REQUEST['mode'])) && ($_REQUEST['mode'] == 'delete')))
		{
			$modename = "Delete Model";
			
			if (isset($_POST['confirm']))
			{
				//Delete It!
				$db->query("DELETE FROM models WHERE id=".$id);
				//include ('../../include/updaterelcache.php');
				header("Location: ".$sitefolder."/admin/models");
				exit;
			}
		}
		
		if ($_SERVER['REQUEST_METHOD'] == 'POST')
		{
			if (!isset($_REQUEST['name'])) exit;
			if (!isset($_REQUEST['type'])) exit;
			
			if (!isset($_REQUEST['usname'])) exit;
			if (!isset($_REQUEST['dsname'])) exit;
			
			$name = $_REQUEST['name'];
			$usname = $_REQUEST['usname'];			
			$dsname = $_REQUEST['dsname'];			
			$type = filter_var($_REQUEST['type'],FILTER_VALIDATE_INT);
			if ($type === FALSE) exit;
			$options = "";
			$colour = $_REQUEST['colour'];
			
			if (trim($name) == "") 
				$errormsg = "You must specify a valid, unique name for your relationship.";
			else
			{			
				$query = $db->query('SELECT * FROM relationships WHERE name='.$db->quote($name).' AND id <> '.$id);
									
				if($row = $query->fetch(PDO::FETCH_ASSOC)) 
				{
					$errormsg = "Your relationship name is not unique. Please select another name.";
				}
			}
			
			if (!isset($errormsg))
			{
				$db->query("UPDATE relationships SET name=".$db->quote($name).", upstreamname=".$db->quote($usname).", downstreamname=".$db->quote($dsname).",flags=0, style=".$type.', options='.$db->quote($options).',colour='.$db->quote($colour).' WHERE id='.$id);
				include ('../../include/updaterelcache.php');
				header("Location: index.php");
				exit;
			}
		}

	}
	else
	{		
		
		$propinfo['name'] = '';
		$propinfo['flags'] = 0;
		$propinfo['upstreamname'] = '';		
		$propinfo['downstreamname'] = '';	
		$propinfo['colour'] = "";//randomColor();
		$propinfo['style'] = 0;
				
		$modename = "Add Model";
		
		if ($_SERVER['REQUEST_METHOD'] == 'POST')
		{
			//print_r($_FILES);
			if (!isset($_FILES['package']))
			{ 
				$errormessage = "You must include a valid package file";
				echo 'Failed - No Suitable Package';
				exit;
			}
			
			if ((!isset($errormessage)) || ($errormessage == ""))
			{
				include('install.php');
				echo 'Installation Done';
				exit;
				/*$type = filter_var($_REQUEST['type'],FILTER_VALIDATE_INT);
				if ($type === FALSE) exit;
				$options = "";
				
				$db->query("INSERT INTO relationships (name,upstreamname,downstreamname,flags,options,colour,style) VALUES (".$db->quote($name).",".$db->quote($usname).",".$db->quote($dsname).',0,'.$db->quote($options).','.$db->quote($colour).','.$type.')');
				
				include ('../../include/updaterelcache.php');
				header("Location: index.php");
				exit;*/
			}
		}
	}
	
	if ($modename == "Delete Model")
	{
		$title = "Delete ".$propinfo['name'];
	
		include($installfolder.'/include/tmpl.php');
		include($installfolder.'/model/property.php');

		T('header-basic','title='.$title);	
		
		ST('section','class=content');
			ST('row');
				ST('half');?>
				    <form method="POST" action="update.php"><?php
					ST('box','title='.$modename);?>
					<a href="" class="btn btn-success" onclick="history.go(-1); return false;">No - Cancel</a>&nbsp;&nbsp;<input type="submit" value="Yes - Delete It" class="btn btn-warning"/><?php
						SS('footer');
						
?>	
    	Are you sure you want to delete your '<?php echo $propinfo['name']?>' 3D model?<br/>
        <input type="hidden" name="id" value="<?php echo $id;?>"/>
        <input type="hidden" name="delete" value="true"/>
        <input type="hidden" name="confirm" value="true"/>        
<?php 				ET();?>
					</form><?php
				ET();
			ET();
		ET();
		exit;
	};
	
	$title = "Add New Model";
	
	include($installfolder.'/include/tmpl.php');


	ST('section','class=content');?>
		<form method="POST" action="update" enctype="multipart/form-data"><?php
		ST('row');
			ST('half');?>
				<?php
				ST('box','title='.$modename);?>
				<input type="hidden" name="id" value="<?php echo $id;?>"/>
        
				<br/><input type="submit" class="btn btn-success" value="<?php echo $modename; ?>"/><?php
					SS('footer');?>
					<p>3D models are distributed via <i>packages</i>, which contain everything needed to add new 3D assets to ARDI.</p>
					<p>Select the package file you'd like to upload...</p><br/><p>
						
    	<label>Model Package :</label><br/>
		<input type="file" name="package" value="<?php echo $propinfo['name']; ?>"/>    
       
        <?php
					ET();
				ET();
			ET();
		ET();
		 ?>
    </form>
 <?php
	ET();?>