<?php
	
	print_r($_SESSION);
	
	OnlyShowIf(CheckAdmin());
	
	$id = 0;
	if (isset($_REQUEST['id'])) 
	{
		$id = filter_var($_REQUEST['id'],FILTER_VALIDATE_INT);
		if ($id === FALSE) exit;
	}
	
	function randomColor() {
		$str = '#';
		for ($i = 0; $i < 6; $i++) {
			$randNum = rand(0, 15);
			switch ($randNum) {
				case 10: $randNum = 'A';
					break;
				case 11: $randNum = 'B';
					break;
				case 12: $randNum = 'C';
					break;
				case 13: $randNum = 'D';
					break;
				case 14: $randNum = 'E';
					break;
				case 15: $randNum = 'F';
					break;
			}
			$str .= $randNum;
		}
		return $str;
	}
	
	$propinfo = array();
	if ($id != 0)
	{
		$query = $db->query('SELECT * FROM relationships WHERE id='.$id.' ORDER BY name');
	
		if($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$propinfo = $row;
			if ($propinfo['colour'] == "") $propinfo['colour'] = randomColor();
		}

		$modename = "Update Relationship";
		
		if ((isset($_REQUEST['delete'])) || ((isset($_REQUEST['mode'])) && ($_REQUEST['mode'] == 'delete')))
		{
			$modename = "Delete Relationship";
			
			if (isset($_POST['confirm']))
			{
				//Delete It!
				$db->query("DELETE FROM relationships WHERE id=".$id);
				include ($installfolder.'/include/updaterelcache.php');
				header("Location: ".$siteroot.'/admin/relationships');
				exit;
			}
		}
		
		if ($_SERVER['REQUEST_METHOD'] == 'POST')
		{
			if (!isset($_REQUEST['name'])) exit;
			if (!isset($_REQUEST['type'])) exit;
			
			if (!isset($_REQUEST['usname'])) exit;
			if (!isset($_REQUEST['dsname'])) exit;
			
			$name = $_REQUEST['name'];
			$usname = $_REQUEST['usname'];			
			$dsname = $_REQUEST['dsname'];			
			$type = filter_var($_REQUEST['type'],FILTER_VALIDATE_INT);
			if ($type === FALSE) exit;
			$options = "";
			$colour = $_REQUEST['colour'];
			
			if (trim($name) == "") 
				$errormsg = "You must specify a valid, unique name for your relationship.";
			else
			{			
				$query = $db->query('SELECT * FROM relationships WHERE name='.$db->quote($name).' AND id <> '.$id);
									
				if($row = $query->fetch(PDO::FETCH_ASSOC)) 
				{
					$errormsg = "Your relationship name is not unique. Please select another name.";
				}
			}
			
			if (!isset($errormsg))
			{
				$db->query("UPDATE relationships SET name=".$db->quote($name).", upstreamname=".$db->quote($usname).", downstreamname=".$db->quote($dsname).",flags=0, style=".$type.', options='.$db->quote($options).',colour='.$db->quote($colour).' WHERE id='.$id);
				include ($installfolder.'/include/updaterelcache.php');
				header("Location: ".$siteroot.'/admin/relationships');
				exit;
			}
		}

	}
	else
	{		
		
		$propinfo['name'] = '';
		$propinfo['flags'] = 0;
		$propinfo['upstreamname'] = '';		
		$propinfo['downstreamname'] = '';	
		$propinfo['colour'] = randomColor();
		$propinfo['style'] = 0;
				
		$modename = "Add Relationship";
		
		if ($_SERVER['REQUEST_METHOD'] == 'POST')
		{
			
			if (!isset($_REQUEST['name'])) exit;
			if (!isset($_REQUEST['type'])) exit;
			
			if (!isset($_REQUEST['usname'])) exit;
			if (!isset($_REQUEST['dsname'])) exit;
			
			$name = $_REQUEST['name'];
			$usname = $_REQUEST['usname'];			
			$dsname = $_REQUEST['dsname'];	
			$colour = $_REQUEST['colour'];
			
			if (trim($name) == "") 
				$errormsg = "You must specify a valid, unique name for your relationship.";
			else
			{			
				$query = $db->query('SELECT * FROM relationships WHERE name='.$db->quote($name));
	
				if($row = $query->fetch(PDO::FETCH_ASSOC)) 
				{
					$errormsg = "Your relationship name is not unique. Please select another name.";
				}
			}
			
			if (!isset($errormsg))
			{
			
				$type = filter_var($_REQUEST['type'],FILTER_VALIDATE_INT);
				if ($type === FALSE) exit;
				$options = "";
				
				$db->query("INSERT INTO relationships (name,upstreamname,downstreamname,flags,options,colour,style) VALUES (".$db->quote($name).",".$db->quote($usname).",".$db->quote($dsname).',0,'.$db->quote($options).','.$db->quote($colour).','.$type.')');
				
				//echo "INSERT INTO relationships (name,upstreamname,downstreamname,flags,options,colour,style) VALUES (".$db->quote($name).",".$db->quote($usname).",".$db->quote($dsname).',0,'.$db->quote($options).','.$db->quote($colour).','.$type.')';
				
				include ($installfolder.'/include/updaterelcache.php');
				header("Location: ".$siteroot.'/admin/relationships');
				exit;
			}
			else
			{
				echo $errormsg;
				exit;
			}
		}
	}
	
	if ($modename == "Delete Relationship")
	{
		$title = "Delete ".$propinfo['name'];
	
		include($installfolder.'/include/tmpl.php');
		include($installfolder.'/model/property.php');

		T('header-basic','title='.$title);	
		
		ST('section','class=content');
			ST('row');
				ST('half');?>
				    <form method="POST" action="update.php"><?php
					ST('box','title='.$modename);?>
					<a href="" class="btn btn-success" onclick="history.go(-1); return false;">No - Cancel</a>&nbsp;&nbsp;<input type="submit" value="Yes - Delete It" class="btn btn-warning"/><?php
						SS('footer');
						
?>	
    	Are you sure you want to delete your '<?php echo $propinfo['name']?>' relationship?<br/>
        <input type="hidden" name="id" value="<?php echo $id;?>"/>
        <input type="hidden" name="delete" value="true"/>
        <input type="hidden" name="confirm" value="true"/>        
<?php 				ET();?>
					</form><?php
				ET();
			ET();
		ET();
		exit;
	};
	
	$title = "Add/Edit ".$propinfo['name'];
	
	if ((isset($_REQUEST['mode'])) && ($_REQUEST['mode'] == 'duplicate'))
	{
		$title = 'Duplicate '.$propinfo['name'];
		$modename = 'Duplicate '.$propinfo['name'];
		
		$ps = strpos($propinfo['name'],'-');
		if ($ps != FALSE)
		{
			$propinfo['name'] = trim(substr($propinfo['name'],0,$ps-1));
		}
		
		$id = 0;
	}
	
	include($installfolder.'/include/tmpl.php');?>
	
	$("#colour").spectrum({
	    color: "<?php echo $propinfo['colour'];?>",
        preferredFormat: "hex"
	});
<?php	
	SS('onload');?>
	<script src="/plugins/spectrum/spectrum.js"></script>
<?php
	SS('addscripts');?>
	<link rel="stylesheet" href="/plugins/spectrum/spectrum.css">
<?php
	SS('head');
?>
<script>
function UpdatePreview()
{
	var d = "<hr/><p>Parent <em>" + $('#dsname').val() + "</em> Child &amp; Child is <em>" + $('#usname').val() + "</em> Parent.</p>";
	
	$('#examples').html(d);
}
</script>
<?php

	T('header-basic','title='.$title.'|backtrace=<li><a href="'.$siteroot.'/admin/relationships">Relationship List</a></li><li><a href="'.$siteroot.'/admin">Administration</a></li>');

	ST('section','class=content');?>
		<form method="POST" action="update"><?php
		ST('row');
			ST('half');?>
				<?php
				ST('box','title='.$modename);?>
				<input type="hidden" name="id" value="<?php echo $id;?>"/>
        
				<br/><input type="submit" class="btn btn-success" value="<?php echo $modename; ?>"/><?php
					SS('footer');
					ST('ftable');?>
						
    	<tr><td><label>Name : </label></td>
		<td><input type="text" name="name" value="<?php echo $propinfo['name']; ?>"/></td></tr>
		
        <tr><td><label>Upstream : </label></td><td><input type="text" name="usname" value="<?php echo $propinfo['upstreamname']; ?>" onChange="UpdatePreview();" onKeyDown="UpdatePreview();" id="usname" /></td></tr>
        <tr><td><label>Downstream : </label></td><td><input type="text" name="dsname" id="dsname" value="<?php echo $propinfo['downstreamname']; ?>" onChange="UpdatePreview();" onKeyDown="UpdatePreview();"/></td></tr>
        <tr><td><label>Type : </label></td>
        <td><select name="type">
        	<option value="0"<?php if ($propinfo['style'] == 0) echo ' selected'; ?>>A Physical Relationship</option>
            <option value="1"<?php if ($propinfo['style'] == 1) echo ' selected'; ?>>A Logical / Control Relationship</option>
            <option value="2"<?php if ($propinfo['style'] == 2) echo ' selected'; ?>>A Hierarchy</option>          
		</select></td></tr>
        <tr><td><label>Colour : </label></td><td><div style="width: 60%; display: inline-block; text-align: left;"><input type="text" id="colour" name="colour" value="#000000" /></div>
</td></tr>        
       
        <?php
					ET();?>
		 <div class="examples" id="examples">
        <hr/>
        <?php if ($propinfo['downstreamname'] != '') { ?><h4>Parent <em><?php echo $propinfo['downstreamname']; ?></em> Child &amp; Child is <em><?php echo $propinfo['upstreamname']; ?></em> Parent.</h4><?php }; ?>
		</div><?php
				ET();
			ET();
		ET();
		 ?>
    </form>
 <?php
	ET();?>