<?php
	
	echo 'Hello?';
	OnlyShowIf(CheckAdmin());
	
function write_php_ini($array, $file)
{
    $res = array();
    foreach($array as $key => $val)
    {
        if(is_array($val))
        {
            $res[] = "[$key]";
            foreach($val as $skey => $sval) $res[] = "$skey = ".(is_numeric($sval) ? $sval : '"'.$sval.'"');
        }
        else $res[] = "$key = ".(is_numeric($val) ? $val : '"'.$val.'"');
    }
	file_put_contents($file,implode("\r\n",$res));
    //safefilerewrite($file, implode("\r\n", $res));
}
	
function recurse_copy($src,$dst) { 
    $dir = opendir($src); 
    @mkdir($dst); 
    while(false !== ( $file = readdir($dir)) ) { 
        if (( $file != '.' ) && ( $file != '..' )) { 
            if ( is_dir($src . '/' . $file) ) { 
                recurse_copy($src . '/' . $file,$dst . '/' . $file); 
            } 
            else { 
                copy($src . '/' . $file,$dst . '/' . $file); 
            } 
        } 
    } 
    closedir($dir); 
} 
	
	$modename = "Add New Site";
	
	if ($_SERVER['REQUEST_METHOD'] == 'POST')
	{
		//echo 'Beginning...';
		
		if (!isset($_REQUEST['name'])) exit;
		if (!isset($_REQUEST['dbname'])) exit;
		
		$dbuser = $_REQUEST['dbuser'];
		$dbhost = $_REQUEST['dbserver'];
		$dbpwd = $_REQUEST['dbpassword'];
		$dbname = $_REQUEST['dbname'];
		
		$name = $_REQUEST['name'];
		
		$addr = "localhost";
		if (isset($_REQUEST['dbserver']))
		{
			if (trim($_REQUEST['dbserver']))
			{
				$addr = $_REQUEST['dbserver'];
			}
		}
		
		$code = substr(strtolower($name),0,5);
		$bits = explode(' ',$name);
		if (count($bits) > 1)
		{
			$code = "";
			for($x=0;$x<count($bits);$x++)
			{
				$code .= $bits[$x][0];
			}
		}
		$adbuser = $dbuser;
		$adbpwd = $dbpass;
		if (isset($_REQUEST['adbuser']))
		{
			$adbuser = $_REQUEST['adbuser'];
		}
		if (isset($_REQUEST['adbpassword']))
		{
			if ($_REQUEST['adbpassword'] != "")
			{
				$adbpwd = $_REQUEST['adbpassword'];
			}
		}
		
		if ($_REQUEST['code'] != '')
		{
			$code = $_REQUEST['code'];
		}
		
		$unique = false;
		$pass = 1;
		while ($unique == false)
		{
			$unique = true;
			foreach($sitelist as $k => $v)
			{
				if (strtolower($k) == strtolower($code))
				{
					$unique = false;
					if ($pass == 1)
						$code .= '2';
					else
						$code = substr($code,0,strlen($code)-1).$pass;
					$pass++;
					break;
				}
			}
		}
		
		if (!isset($errormsg))
		{
			//Begin Duplication...
			
			//Create and Copy Folder...
			echo 'Creating Folder...';
			
			$inport = 0;
			$outport = 0;
			
			$code = strtolower($code);
			
			$targetfolder = $installfolder.'/sites/'.strtolower($code);
			mkdir($targetfolder);
			recurse_copy($installfolder.'/sites/default',$targetfolder);
			
			$redir = '/s/'.$code.'/';
			
			//Change Database (Administrative - Create Database)
			
			$srvr = "localhost";
			if ($dbhost != "") $srvr = $dbhost;
			$dbtype = "mysql";
			
			$dbcommandstring = $dbtype.":host=".$srvr.";charset=utf8";
			
			$dbx = new PDO($dbcommandstring,$dbuser,$dbpwd);
				
			echo 'Connecting To Database: '.$dbcommandstring.' as '.$dbuser;
				
			//echo "CREATE DATABASE ".$dbname;
			$dbx->query("CREATE DATABASE ".$dbname);
			
			if ($dbhost == "localhost")
			{
				//echo "GRANT ALL ON ardi".$code.".* TO '".$adbuser."'@'localhost'";
				$dbx->query("GRANT ALL ON ardi".$code.".* TO '".$adbuser."'@'localhost'");
			}
			
			$dbx->query("USE ".$dbname);
			
			$templine = "";
			$filename = $installfolder.'/sites/blankdb.sql';
			
			$lines = file($filename);
			
			// Loop through each line
			foreach ($lines as $line)
			{
				// Skip it if it's a comment
				if (substr($line, 0, 2) == '--' || $line == '')
					continue;

				// Add this line to the current segment
				$templine .= $line;
				
				// If it has a semicolon at the end, it's the end of the query
				if (substr(trim($line), -1, 1) == ';')
				{
					// Perform the query
					//echo $templine;
					$dbx->query($templine) or print('Error performing query \'<strong>' . $templine . '\': ' . mysql_error() . '<br /><br />');
					// Reset temp variable to empty
					$templine = '';
				}
			}
			
			$sitefolder = $installfolder.'/sites/'.$code;
			
			//Build Asset Cache
			$background = true;
			$db = $dbx;
			global $db;
			include($installfolder.'/pages/admin/tools/cacherebuild.php');
			
			//Generate new DBSettings file....
			$fl = "<?php \r\n";
			$fl .= ' $dbuser = "'.$adbuser.'"'.";\r\n";
			$fl .= ' $dbpass = "'.$adbpwd.'"'.";\r\n";
			$fl .= ' $dbname = "'.$dbname.'"'.";\r\n";
			$fl .= ' $dbserver = "'.$dbhost.'"'.";\r\n";
			$fl .= ' $dbport = ""'."\r\n".'; $dbtype = "mysql";'."\r\n";
			$fl .= "?>";
			
			file_put_contents($installfolder.'/sites/'.$code.'/config/dbsettings.php',$fl);
			
			//Update INI file settings...
			
			$inx = parse_ini_file($installfolder.'/sites/'.$code.'/config/settings.ini',true);
			$inx['server']['company'] = $name;
			write_php_ini($inx,$installfolder.'/sites/'.$code.'/config/settings.ini');
			
			//Update Consolidator Ports
			
			//Linux Install for Consolidator...
			if ((PHP_OS == "Linux") || (PHP_OS == "Unix"))
			{
				//Run the process to install the driver...
				$cmd = "sudo /opt/ardi/srv/consolidator/ardiconsol install ".$inport." ".$outport;
				ob_start();
				system($cmd);
				ob_get_clean();
			}
			
			header("Location: ".$redir);
			exit;
		}
		else
		{
			echo $errormsg;
			exit;
		}
	}
	
	$title = 'Create New Site';
	
	include($installfolder.'/include/tmpl.php');

	T('header-basic','title='.$title.'|backtrace=<li><a href="'.$siteroot.'/admin/sites">Site List</a></li><li><a href="'.$siteroot.'/admin">Administration</a></li>');
?>
	<script>
	
	function UpdateFields()
	{
		var fin = "";
		var vl = $('#newname').val().toLowerCase();
		var bits = vl.split(' ');
		var x=0;
		if (bits.length > 1)
		{
			for(x=0;x<bits.length;x++)
			{
				if ((bits[x].length <= 2) && ((bits[x] != "in") && (bits[x] != "as") && (bits[x] != "of")))
					fin += bits[x];
				else
					fin += bits[x][0];
			}
		}
		else
		{
			fin = vl.substring(0,5);
		}
		fin = fin.toLowerCase();
		$('#newcode').val(fin);
		$('#dbname').val('ardi' + fin);
	}
	</script>
<?php	
	
	ST('section','class=content');?>
		<form method="POST"><?php
		ST('row');
			ST('half');?>
				<?php
				ST('box','title='.$modename);?>
					<input type="submit" class="btn btn-success" value="Create a New Site"/><?php
					SS('footer');
					ST('ftable');?>
		
		<tr><td><label>Name : </label></td><td><input type="text" name="name" id="newname" value="" style="width: 80%" onchange="UpdateFields();"/></td></tr>
		<tr><td><label>Short/Code : </label></td><td><input type="text" name="code" id="newcode" value="" style="width: 80%"/></td></tr>
		<tr><td><label>Database Name : </label></td><td><input id="dbname" type="text" name="dbname" value="ardi<?php echo count($sitelist)+1; ?>"/></td></tr>
		<tr><td><label>Database Server : </label></td><td><input type="text" name="dbserver" value="localhost"/></td></tr>
		<tr><td><label>Database Admin User : </label></td><td><input type="text" name="dbuser" value="root"/></td></tr>
		<tr><td><label>Database Admin Password : </label></td><td><input type="password" name="dbpassword"/></td></tr>
		<!--<tr class="external"><td><label>Database User : </label></td><td><input type="text" name="adbuser" value="ardiuser"/></td></tr>
		<tr class="external"><td><label>Database Password : </label></td><td><input type="password" name="adbpassword"/></td></tr>-->
        
        <?php
					ET();
				ET();
			ET();
		ET();
		 ?>
    </form>
 <?php
	ET();?>