<?php

OnlyShowIf(CheckAdmin());
if ($_SESSION['userid'] != 1)
{
	exit;
}

$multisite = false;

$multisite = true;

function write_php_ini($array, $file)
{
    $res = array();
    foreach($array as $key => $val)
    {
        if(is_array($val))
        {
            $res[] = "[$key]";
            foreach($val as $skey => $sval) $res[] = "$skey = ".(is_numeric($sval) ? $sval : '"'.$sval.'"');
        }
        else $res[] = "$key = ".(is_numeric($val) ? $val : '"'.$val.'"');
    }
	file_put_contents($file,implode("\r\n",$res));
    //safefilerewrite($file, implode("\r\n", $res));
}

//OK - time to save details.
	
	if ($multisite == true)
	{
		if (isset($_REQUEST['mtype']))
		{
			$in = parse_ini_file($installfolder.'/sites/all.ini');
			$md = $_REQUEST['mtype'];
			//echo $md;
			if (($md != "isolated") && ($md != "integrated")) exit;
			
			$in['mode'] = $md;
			$mname = filter_var($_REQUEST['mname'],FILTER_SANITIZE_STRING);
			$mname = str_replace("\n","",$mname);
			$mname = str_replace("\r","",$mname);
			$in['name'] = $_REQUEST['mname'];
			
			//Write out the updated INI file for ALL sites...
			write_php_ini($in,$installfolder.'/sites/all.ini');
			
			header('Location: '.$siteroot.'/admin');
			echo 'Poof!';
			exit;
		}
	}


if ($multisite == true)
{
	$title = "Site Options";

	include($installfolder.'/include/tmpl.php');
	//include($installfolder.'/model/relationship.php');

	T('header-basic','title='.$title);

	ST('section','class=content');
		ST('row');
			
			ST('half');
				ST('boxform','title=Site Settings - Multisite');?>
					<input type="submit" class="btn btn-success" value="Next"/><?php
					SS('footer');
					?>
						<p>Your ARDI license allows for more than a single 'site' (or database) being present.</p>
						<p>Before you continue, you'll need to choose what you'd like to call these 'sites' (other names include 'buildings', 'locations', 'clients' etc.)</p>
						<p>You will also need to choose how these sites should operate. You have two options...<ul><li><strong>Integrated</strong> sites behave as if they are related and are ideal for companies with a number of geographically distinct sites or locations. </li><li><strong>Isolated</strong> sites are completely distinct from one-another and are used for multi-tennant applications, where completely separate and unrelated databases are stored.</li></ul></p><br/><?php 
					
					ST('table');
						?>
						<tr><td><label>Name:</label></td><td><input type="text" value="Site" name="mname"/></td></tr>
						<tr><td><label>Mode:</label></td><td><select name="mtype"><option value="integrated">Integrated</option><option value="isolated">Isolated</option></select></td></tr>
						<?php
					ET();
					
				ET();
			ET();
		ET();	
	ET();
	};
?>
