<?php	
	
	//echo 'Hello?';
	
	$title = "Cache Rebuild";
	
	if (!isset($background))
	{
		require_once($installfolder.'/include/tmpl.php');
		
		OnlyShowIf(CheckAdmin());
		
		T('header-basic','title='.$title);
	}

	$settoupdate = array();
	
	if (!file_exists($sitefolder.'/cache/relationships/'))
	{
		mkdir($sitefolder.'/cache/relationships/');
	}
	
	include($installfolder.'/include/updaterelcache.php');
	
	$content = "";
	
	$query = $db->query('SELECT id,name FROM assets ORDER BY id');
	
	$totalset = array();
	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$totalset[$row['id']] = $row['name'];
	}	
	
	foreach($totalset as $k => $v)
	{
		CalculateTree($k,$v);
	}
	
	global $db;
	function CalculateTree($asset,$assetname)
	{
		global $db;

		//echo 'Caching relationships and properties for asset '.$asset;
				
		$content = "<?php \r\n";
		
		$content .= '$asset['.$asset.'] = array();';

		$content .= '$asset['.$asset.']["name"] = "'.$assetname.'";';
		
		$query = $db->query("SELECT parentasset, assets.name, relationships.upstreamname, relationship FROM assetrelationships JOIN relationships ON (relationships.id = assetrelationships.relationship) JOIN assets ON (assets.id = parentasset) WHERE childasset=".$asset);
		
		$content .= '$asset['.$asset.']["relationships"] = array();';

		$relsdone = array();

		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			if (!in_array($row['relationship'],$relsdone)) 
			{
				$content .= '$asset['.$asset.']["relationships"]['.$row['relationship'].'] = array();';
				$relsdone[] = $row['relationship'];
			}

			$content .= '$bf = array(); $bf["target"]= '.$row['parentasset'].'; $bf["upstream"] = true;';
			$content .= '$asset['.$asset.']["relationships"]['.$row['relationship'].'][] = $bf;';
		}			
		
		$query = $db->query("SELECT childasset, assets.name, relationships.upstreamname, relationship FROM assetrelationships JOIN relationships ON (relationships.id = assetrelationships.relationship) JOIN assets ON (assets.id = childasset) WHERE parentasset=".$asset);
				
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			if (!in_array($row['relationship'],$relsdone)) 
			{
				$content .= '$asset['.$asset.']["relationships"]['.$row['relationship'].'] = array();';
				$relsdone[] = $row['relationship'];
			}

			$content .= '$bf = array(); $bf["target"]= '.$row['childasset'].'; $bf["upstream"] = false;';
			$content .= '$asset['.$asset.']["relationships"]['.$row['relationship'].'][] = $bf;';
		}	
		
		$cachedvalues = "'MEASUREMENT','STATUS','ISOPOINT','NRPOINT'";
		
		$content .= '$asset['.$asset.']["values"] = array();';
		/*$query = $db->query("SELECT propertyid, properties.name, properties.typename FROM assetproperties JOIN properties ON (properties.id = propertyid) WHERE assetid=".$asset." AND (properties.typename IN (".$cachedvalues."))");
		
		$content .= '$asset['.$asset.']["values"] = array();';

		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			if ($row['typename'] != "MODEL")
			{
				$content .= '$asset['.$asset.']["values"]['.$row['propertyid'].'] = array();';
				$content .= '$asset['.$asset.']["values"]['.$row['propertyid'].']["name"] = "'.$row['name'].'";';
				$content .= '$asset['.$asset.']["values"]['.$row['propertyid'].']["type"] = "'.$row['typename'].'";';

			}			
		}	*/
		$query = $db->query("SELECT assetvalues.propertyid, properties.name, properties.typename,node FROM assetvalues JOIN properties ON (properties.id = assetvalues.propertyid) LEFT OUTER JOIN datalinks ON (datalinks.propertyid=assetvalues.propertyid AND datalinks.assetid=assetvalues.assetid) WHERE assetvalues.assetid=".$asset." AND (properties.typename IN (".$cachedvalues."))");
		
		//echo "SELECT assetvalues.propertyid, properties.name, properties.typename,node FROM assetvalues JOIN properties ON (properties.id = assetvalues.propertyid) LEFT OUTER JOIN datalinks ON (datalinks.propertyid=assetvalues.propertyid AND datalinks.assetid=assetvalues.assetid) WHERE assetvalues.assetid=".$asset." AND (properties.typename IN (".$cachedvalues."))";
			
		$lastpropid = 0;
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$done[] = $row['propertyid'];
			if ($lastpropid != $row['propertyid'])
			{
				$content .= '$asset['.$asset.']["values"]['.$row['propertyid'].'] = array();';
				$content .= '$asset['.$asset.']["values"]['.$row['propertyid'].']["name"] = "'.$row['name'].'";';
				$content .= '$asset['.$asset.']["values"]['.$row['propertyid'].']["type"] = "'.$row['typename'].'";';				
				if ((isset($row['node'])) && ($row['node'] != ""))
				{
					$content .= '$asset['.$asset.']["values"]['.$row['propertyid'].']["links"] = array();';
				}				
				$lastpropid = $row['propertyid'];
			}
			if ((isset($row['node'])) && ($row['node'] != ""))
			{
				$content .= '$asset['.$asset.']["values"]['.$row['propertyid'].']["links"]["'.$row['node'].'"] = "'.$asset.':'.$row['propertyid'].':'.$row['node'].'";';
			}	
		}	
		
		//References
		$any = false;
		
		$query = $db->query('SELECT childasset,childproperty FROM assetreferences WHERE parentasset='.$asset);
														
		if ($query !== FALSE)
		{														
			while($row = $query->fetch(PDO::FETCH_ASSOC)) 
			{
				if ($any == false)
				{
					$content .= '$asset['.$asset.']["ref"] = array();';
				}
				
				$content .= '$asset['.$asset.']["ref"][] = "'.$row['childasset'].'-'.$row['childproperty'].'";';
			}	
		}
		
		$content .= "?>";
		
		global $sitefolder;
		file_put_contents($sitefolder.'/cache/relationships/'.$asset.'.inc',$content);
		//print_r($relproperties);
	}
	
	if (!isset($background))
	{
	
	ST('section','class=content');
		ST('row');
			ST('full');
				ST('box','title=Process Complete');
	echo '<p>Your ARDI cache has been rebuilt and your installation is now ready for use - <a href="'.$siteroot.'/">click here to start using your ARDI database</a></p>';
				ET();
			ET();
		ET();
	ET();

	};?>