<?php

if (!isset($_REQUEST['assetid'])) exit;
if (!isset($_REQUEST['rel'])) exit;

$itemid = filter_var($_REQUEST['assetid'],FILTER_VALIDATE_INT);
if ($itemid === FALSE) exit;

$rel = filter_var($_REQUEST['rel'],FILTER_VALIDATE_INT);
if ($rel === FALSE) exit;

include($installfolder.'/model/asset.php');
include($installfolder.'/model/relationship.php');

$thisasset = new Asset($itemid);
$thisasset->Load();

$relinfo = Relationships::GetRelationship($rel);

$title = $thisasset->name.' '.$relinfo->name.' Relationships';

$assetrels = $thisasset->GetRelationships();

include($installfolder.'/include/tmpl.php');
include($installfolder.'/include/dynamicdata.php');?>

	<li class="active treeview">
	  <a href="/">
		<i class="fa fa-photo"></i> <span>Current Asset</span>
	  </a>
	  <ul class="treeview-menu">
		<li>
			<a href="<?php echo $siteroot; ?>/diagram/<?php echo $itemid;?>/2"><i class="fa fa-circle-o"></i> Diagram</a>
			<a href="<?php echo $siteroot; ?>/dashboard/<?php echo $itemid;?>"><i class="fa fa-circle"></i> Dashboard</a>
			<a href="<?php echo $siteroot; ?>/detail/<?php echo $itemid;?>"><i class="fa fa-circle-o"></i> Detail</a>
			<a href="<?php echo $siteroot; ?>/chart/<?php echo $itemid;?>"><i class="fa fa-circle-o"></i> Charts</a>
		</li>
	  </ul>
    </li>

<?php SS('sidebar'); 

T('header-basic','title='.$title);

$supports3d = true;

//Show the description
ST('section','class=content');
	ST('row');
		ST('full');			
			ST('box');
?>
	<h4>Parents</h4>
<?php
			ET();
		ET();
	ET();
ET();

//Load all properties (to be given to the appropriate Dashboard module)
ST('section','class=content');
	ST('row');	
		ST('full');
			foreach($assetrels[$rel] as $v)
			{
				if ($v['upstream'] == false) continue;
				$ass = new Asset($v['target']);
				T('dashboard','style=info|symbol=fa fa-angle-up|link='.$siteroot.'/dashboard/'.$v['target'].'|title='.$ass->name.'|value=');
			}
		ET();	
	ET();
ET();
	
ST('section','class=content');
	ST('row');
		ST('full');
			ST('box');?>
				<h4>Children</h4><?php
			ET();
		ET();
	ET();

	ST('row');
	
		ST('full');
			foreach($assetrels[$rel] as $v)
			{
				if ($v['upstream'] == true) continue;
				$ass = new Asset($v['target']);
				T('dashboard','style=info|symbol=fa fa-angle-down|link='.$siteroot.'/dashboard/'.$v['target'].'|title='.$ass->name.'|value=');		
			}
		ET();
	ET();
ET();
	
?>