<?php

//$editable = true;

$itemid = filter_var($_REQUEST['assetid'],FILTER_VALIDATE_INT);
if ($itemid === FALSE) exit;

include($installfolder.'/model/asset.php');

$thisasset = new Asset($itemid);
$thisasset->Load();

$title = $thisasset->name.' 3D Options';

global $installfolder;

include($installfolder.'/include/tmpl.php');

//$title = 'Asset Detail';

?>

	<li class="active treeview">
	  <a href="/">
		<i class="fa fa-photo"></i> <span>Current Asset</span>
	  </a>
	  <ul class="treeview-menu">
		<li>
			<a href="<?php echo $siteroot;?>/diagram/<?php echo $itemid;?>/2"><i class="fa fa-circle-o"></i> Diagram</a>
			<a href="<?php echo $siteroot;?>/dashboard/<?php echo $itemid;?>"><i class="fa fa-circle-o"></i> Dashboard</a>
			<a href="<?php echo $siteroot;?>/detail/<?php echo $itemid;?>"><i class="fa fa-circle"></i> Detail</a>
			<a href="<?php echo $siteroot;?>/chart/<?php echo $itemid;?>"><i class="fa fa-circle-o"></i> Charts</a>
		</li>
	  </ul>
    </li>

<?php SS('sidebar');  

T('header-basic','title='.$title);

	ST('section','class=content');
		ST('row');
			ST('half');
				ST('row');
					ST('full');
						ST('box','title=Location &amp; Apperance');
						$dta = $thisasset->GetProperties();
						$thisasset->GetValues($dta);
						
						foreach($dta as $prop)
						{
							if ($prop->type == "MODEL")
							{
								$mdl = $prop->value;
								
								//Get the model and skin names for these...
							}
							
							if ($prop->type == "LOCATION")
							{
								$loc = $prop->value;
								
								//Get the model and skin names for these...
							}
						}
							ST('buttonmenu');
					?>
					
					<li><a href="<?php echo $siteroot; ?>/location/<?php echo $itemid; ?>" class="btn btn-<?php if (isset($loc)) echo 'default'; else echo 'warning';?>"><?php if (isset($loc)) echo 'Change Location'; else echo 'Location Not Set';?></a></li>
					<li><a href="<?php echo $siteroot; ?>/model/<?php echo $itemid; ?>" class="btn btn-<?php if (isset($mdl)) echo 'default'; else echo 'warning';?>"><?php if (isset($mdl)) echo 'Change'; else echo 'Set';?> Appearance</a></li>
<?php
							ET();
						ET();
					ET();
					ST('full');
						ST('boxform','title=Data Binding|action='.$siteroot.'/asset/binding');?>
							<input type="submit" value="Save Bindings" class="btn btn-success"/>
							<input type="hidden" value="<?php echo $itemid; ?>" name="assetid"/><?php
							SS('footer');
							include('binding.php');
							//echo 'This asset doesn\'t require data binding';
						ET();
					ET();
				ET();
			ET();
		
			include('detail-navigation.php');
		ET();
	ET(); ?>