<?php

//$editable = true;

$itemid = filter_var($_REQUEST['assetid'],FILTER_VALIDATE_INT);
if ($itemid === FALSE) exit;

include($installfolder.'/model/asset.php');

$thisasset = new Asset($itemid);
$thisasset->Load();

$title = $thisasset->name.' Alerts';

global $installfolder;

include('include/tmpl.php');

//$title = 'Asset Detail';

?>

	<li class="active treeview">
	  <a href="/">
		<i class="fa fa-photo"></i> <span>Current Asset</span>
	  </a>
	  <ul class="treeview-menu">
		<li>
			<a href="<?php echo $siteroot;?>/diagram/<?php echo $itemid;?>/2"><i class="fa fa-circle-o"></i> Diagram</a>
			<a href="<?php echo $siteroot;?>/dashboard/<?php echo $itemid;?>"><i class="fa fa-circle-o"></i> Dashboard</a>
			<a href="<?php echo $siteroot;?>/detail/<?php echo $itemid;?>"><i class="fa fa-circle"></i> Detail</a>
			<a href="<?php echo $siteroot;?>/chart/<?php echo $itemid;?>"><i class="fa fa-circle-o"></i> Charts</a>
		</li>
	  </ul>
    </li>

<?php SS('sidebar');  

T('header-basic','title='.$title);
?>
<script>

var selectedalert = 0;

function PropertyMenu(propid,e,o)
{
	selectedalert = propid;
	
	var ob = $('#propmenu');	
	var off = $(o).offset();
	off.top += $(o).height();
	ob.css('left',off.left + "px");
	ob.css('top',off.top + "px");
	ob.fadeIn(500);
}

function LinkToSource()
{
	window.location = "<?php echo $siteroot;?>/data/connect?asset=<?php echo $itemid; ?>&property=-1&node=" + selectedalert;
}

</script><?php

	ST('section','class=content');
		ST('row');
			ST('half');
				ST('box','title=Alert List');?>
					<a href="<?php echo $siteroot;?>/alerts/update?asset=<?php echo $itemid;?>&mode=add" class="btn btn-success">Add New Alert</a><?php
					SS('footer');
					ST('ftable');?>
						
						<tr><?php if ($editable == true) echo '<th style="width: 30px;"></th>';?><th>Name</th><th>Status</th></tr>
						<?php
						$query = $db->query('SELECT name,id,state FROM alerts WHERE assetid='.$itemid);
									
						while($row = $query->fetch(PDO::FETCH_ASSOC)) 
						{
							$statetext = "OK";
							$statestyle = "success";
							if ($row['state'] == 1)
							{
								$statetext = "ALERT";
								$statestyle = "warning";
							}
							echo '<tr>';
							if ($editable == true) echo '<td><a class="linkbutton" href="#" onclick="PropertyMenu('.$row['id'].',event,this); return false;"><i class="fa fa-caret-down linkbutton"/></a></td>';
							echo '<td>'.$row['name'].'</td><td><span class="label label-'.$statestyle.'">'.$statetext.'</span></td></tr>';
						}
				
					ET();
				ET();
			ET();
		
			include('detail-navigation.php');
		ET();
	ET(); ?>
<div id="propmenu" style="display: none;">
	<a href="#" onclick="LinkToSource(); return false;" class="btn btn-primary">Link To...</a><br/>
    <a href="#" onclick="RemoveAlert(); return false;" class="btn btn-default">Delete...</a><br/><hr style="margin: 0px; padding: 0px;"/>
        <a href="#" onclick="$('#propmenu').fadeOut(500); return false;" class="btn btn-success">Cancel</a>
</div>