<?php
	
	$itemid = filter_var($_REQUEST['assetid'],FILTER_VALIDATE_INT);
	if ($itemid === FALSE) exit;

	include($installfolder.'/model/asset.php');
	include($installfolder.'/model/property.php');

	$thisasset = new Asset($itemid);
	$thisasset->Load();
	$dta = $thisasset->GetProperties();
	$thisasset->GetValues($dta);
	
	//Find if there is a suitable editor for this property type...
	
	$editor = "smalltext";
	
	$pset = Properties::GetAllProperties();
	foreach($pset as $px)
	{
		if ($px->id == $_REQUEST['property'])
		{
			$p = $px;
			break;
		}
	}
	
	$value = array();
	foreach($dta as $obd)
	{
		if ($obd->id == $_REQUEST['property'])
		{
			$value = $obd->value;
		}
	}
	
	$builtin = false;
	if ($_REQUEST['property'] == 'desc')
	{
		//Description!
		include($installfolder.'/modules/ui/smalltext.php');
		$builtin = true;
	}
	
	if ($_REQUEST['property'] == 'name')
	{
		//Renaming!
		include($installfolder.'/modules/ui/smalltext.php');
		$builtin = true;
	}
	
	if ($builtin == false)
	{
	
		$defaults = false;
		if (count($value) == 0)
		{
			//Load the inputs and set all defaults...
			$defaults = true;
			include($installfolder.'/modules/inputs/'.strtolower($p->type).'.php');
			foreach($inputs as $d)
			{
				$value[$d['name']] = "";
				if (isset($d['default']))
				{
					$value[$d['name']] = $d['default'];
				}
			}
		}
		
		echo '<p>';
		$uifile = $installfolder.'/modules/ui/'.strtolower($p->type).'.php';
		if (file_exists($uifile))
		{
			$editor = strtolower($p->type);
		}
		include($installfolder.'/modules/ui/'.$editor.'.php');
	}
?>
	</p>
<?php
	if (isset($_REQUEST['inplace']))
	{?>
	<a href="#" onclick="SubmitPopover(this); return false;" id="squiggle" class="btn btn-success">Save</a> <a href="#" id="hehe" onclick="ClosePopover(this); return false;" class="btn btn-default">Cancel</a><?php
	}
	else
	{?>
	<a href="#" onclick="SubmitPoppit(this); return false;" id="squiggle" class="btn btn-success">Save</a> <a href="#" id="hehe" onclick="CloseExistingEditor(); return false;" class="btn btn-default">Cancel</a><?php
	};
?>