<?php
/**
 * Bulk relationship configuration
 *
 * This allows you to quickly set up relationships on an asset by asking
 *   	you about all possible relationships.
 *
 * @author Steven Harding
 */
	
	
		
	if (!isset($_REQUEST['id'])) exit;
	$itemid = filter_var($_REQUEST['id'],FILTER_VALIDATE_INT);
	if ($itemid === FALSE) exit;
	
	header('Location: '.$siteroot.'/editor/'.$itemid);
	exit;
	
	include($installfolder.'/model/asset.php');

	$thisasset = new Asset($itemid);
	$thisasset->Load();
	
	/*if ($itemid != 0)
	{
		$itemdata = array();		
		$query = $db->query('SELECT * FROM assets WHERE id='.$itemid);

		if($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$itemdata = $row;
		}	
	}*/
	
	$relset = array();
	
	$query = $db->query('SELECT id,name,style,upstreamname, downstreamname,flags FROM relationships WHERE style <> 2 ORDER BY style DESC, name ASC');
	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$relset[] = $row;		
	}	
	
	if ($_SERVER['REQUEST_METHOD'] == 'POST')
	{
		include($installfolder.'/model/relationship.php');
		
		//Begin Assigning Relationships...
		foreach($relset as $row)
		{
			//Wiggles
			if (isset($_REQUEST['parent'.$row['id']]))
			{
				$p = $_REQUEST['parent'.$row['id'].'id'];
				if ($p != "")
				{					
					/*$_REQUEST['origin'] = $p;
					$_REQUEST['newreltarget'] = $itemid;
					$_REQUEST['relationship'] = $row['id']."-D";
					if (($row['flags'] & 4) != 0)
					{
						$_REQUEST['relationship'] = $row['id']."-U";
					}*/
					
					//include('link.php');
					//echo 'Adding Relationship To '.$p;
					Relationships::Add($p,$itemid,$row['id']);
				}
			}
		}
		//echo 'Update Complete!';
		header('Location: '.$siteroot.'/properties/'.$itemid);
		exit;
	}
	
	$existing = $thisasset->GetRelationships();
		
	$title = $thisasset->name.' Bulk Link';

	include($installfolder.'/include/tmpl.php');
	
	//$template->StartSection('onload');
	
	?>
	var assetlist = new Bloodhound({
	  datumTokenizer: Bloodhound.tokenizers.obj.whitespace('text'),
	  queryTokenizer: Bloodhound.tokenizers.whitespace,
	  remote: '<?php echo $siteroot;?>/ajax/assetnamesearch?q=%QUERY',  
	  //local: $.map(assets, function(state) { return { value: state }; })
	});
	 
	// kicks off the loading/processing of `local` and `prefetch`
	assetlist.initialize();
	<?php
	
	$defaults = array();	
	
	foreach($relset as $row)
	{ ?>
	$('#rel<?php echo $row['id'];?>').typeahead({
    	hint: true,
        highlight: true,
        minLength: 2
    },{
	    name: 'assets',
        displayKey: 'text',
        source: assetlist.ttAdapter(),
        templates: {
            empty: [
              '<div class="tt-suggestions" style="font-size: small;"><div class="tt-suggestion">No Matching Asset Found</div>'
            ].join('\n'),
			suggestion: function(data){
				return '<p class="searchresult">' + data.text + '<span>' + data.path + '</span></p>';
			}            
        }        
    });
	
	$('#rel<?php echo $row['id'];?>').on('typeahead:selected',function (evt,item) {    	
        $('#rel<?php echo $row['id'];?>id').val(item.id);
    });
            
<?php }; 
    SS('onload');  ?>
	<script src="/plugins/typeahead/typeahead.bundle.min.js"></script>
<?php SS('addscripts'); ?>
<link rel="stylesheet" href="<?php echo $themefolder; ?>/css/diagram.css">
<?php SS('head');
	
	T('header-basic','title='.$title);

	echo '<form method="POST">';
	
	ST('section','class=content');
		ST('row');
			ST('half');
				ST('box','title=Details');?>
				
				<input type="submit" value="Update Relationships" class="btn btn-success"/>
        <input type="hidden" name="id" value="<?php echo $itemid;?>"/><?php
				SS('footer');

		$typewas = -1;
		foreach($relset as $row)
		{
			if ($row['style'] != $typewas)
			{
				if ($row['style'] == 0)
				{
					ET();
					ET();
					ST('half');
					ST('box-collapsible','title=Physical Connections');
					//echo '<h3>Physical Connections</h3>';
				}
				if ($row['style'] == 1)
				{
					ET();
					ST('box-collapsible','title=Logical Connections');
					//echo '<h3>Logical Connections</h3>';
				}
				if ($row['style'] == 3)
				{
					
				}
				$typewas = $row['style'];
			}
			if ($row['style'] == 3)
			{
				//Only one of these allowed!
				if (isset($existing[$row['id']])) continue;
			}
			
			if (($row['flags'] & 4) == 0)
				echo '<h4>Is '.$row['upstreamname'].' ( '.$row['name'].' )</h4>';
			else
				echo '<h4>'.$row['downstreamname'].' ( '.$row['name'].' )</h4>';
			echo '<input type="hidden" id="rel'.$row['id'].'id" name="parent'.$row['id'].'id"/>';
			echo '<input type="text" value="';
			if (isset($row['default'])) echo $row['defaultval'];
			echo '" style="width: 100%; border: 1px solid black; padding: 3px; border-radius: 3px; position: relative; left: -3px;" name="parent'.$row['id'].'" id="rel'.$row['id'].'"/>';
			
		}
		
	?>	
    	
	</form>
</div>	
    