<?php
	$title = "View/Change Location";
	
	if (isset($_REQUEST['id']))
	{
		$itemid = filter_var($_REQUEST['id'],FILTER_VALIDATE_INT);
		if ($itemid === FALSE) exit;
	}
	
	if (!isset($itemid)) exit;
	
	if ($_SERVER['REQUEST_METHOD'] == 'POST')
	{
		$val = $_REQUEST['posx'].','.$_REQUEST['posy'].','.$_REQUEST['posz'];
		$val .= '|'.$_REQUEST['scalex'].','.$_REQUEST['scaley'].','.$_REQUEST['scalez'];
		$val .= '|'.$_REQUEST['roll'].','.$_REQUEST['pitch'].','.$_REQUEST['yaw'];
		
		//OK - we had better find the suitable property ID here...		
		$query = $db->query("SELECT properties.id FROM properties WHERE  typename='LOCATION'");
	
		$pid = 0;
		if($row = $query->fetch(PDO::FETCH_ASSOC)) 	
		{
			$pid = $row['id'];
		}	
		if ($pid != 0)
		{
			//$db->query("INSERT IGNORE INTO assetproperties (propertyid, assetid) VALUES (".$pid.",".$itemid.")");
			
			$db->query("INSERT INTO assetvalues (propertyid, assetid,value) VALUES (".$pid.",".$itemid.",".$db->quote($val).") ON DUPLICATE KEY UPDATE value=".$db->quote($val));
		}		
		
		header("Location: ".$siteroot."/appearance/".$itemid);
		exit;
	}
				
	$itemdata = array();		
	$query = $db->query('SELECT * FROM assets WHERE id='.$itemid);
	
	if($row = $query->fetch(PDO::FETCH_ASSOC)) 	
	{
		$itemdata = $row;
	}	

	$query = $db->query("SELECT properties.id FROM properties WHERE properties.typename='LOCATION'");
	
	if($row = $query->fetch(PDO::FETCH_ASSOC)) 	
	{
		$pid = $row['id'];
	}
	else
	{
		exit;
	}

	$query = $db->query("SELECT value FROM assetvalues WHERE propertyid=".$pid." AND assetid=".$itemid);
	
	$posx = 0;
	$posy = 0;
	$posz = 0;
	
	$scalex = 1;
	$scaley = 1;
	$scalez = 1;
	
	$roll = 0;
	$pitch = 0;
	$yaw = 0;
	
	if($row = $query->fetch(PDO::FETCH_ASSOC)) 	
	{
		$val = $row['value'];
		$bits = explode('|',$val);
		if (count($bits) > 2)
		{
			$loc = $bits[0];
			$scale = $bits[1];
			$rot = $bits[2];
			
			$bits = explode(',',$loc);
			$posx = $bits[0];
			$posy = $bits[1];
			$posz = $bits[2];
			
			$bits = explode(',',$scale);
			$scalex = $bits[0];
			$scaley = $bits[1];
			$scalez = $bits[2];
			
			$bits = explode(',',$rot);
			if (count($bits) == 3)
			{
				$roll = $bits[0];
				$pitch = $bits[1];
				$yaw = $bits[2];
			}
		}
	}	
	
	include($installfolder.'/include/tmpl.php');
	include($installfolder.'/model/property.php');					
	
	T('header-basic','title='.$title);
	
	ST('section','class=content');?>
	<form method="post"><?php
		ST('row');
			ST('half');	
				ST('box','title=Choose Method'); 
					ST('buttonmenu');?>
			<li><a href="#" class="btn btn-default">Position Editor</a></li>
			<li><a href="#" class="btn btn-default" onclick="$('.manualedit').fadeIn(500); return false;">Set Manually</a></li>
		<?php
					ET();
				ET();
			ET();
			ST('half');	
				ST('boxform','title=Manual|class=manualedit|style=display: none;');?>
					<input type="submit" value="Set Position" class="btn btn-success"/>
					<input type="hidden" name="id" value="<?php echo $itemid; ?>"/>

<?php				SS('footer');
					ST('ftable');?>
			<tr><td><label>Position:</label></td><td><input name="posx" type="text" style="width: 5em;" value="<?php echo $posx;?>"/>, <input name="posy" type="text" style="width: 5em;" value="<?php echo $posy;?>"/>, <input name="posz" type="text" style="width: 5em;" value="<?php echo $posz;?>"/></td></tr>
			<tr><td><label>Size:</label></td><td><input name="scalex" type="text" style="width: 5em;" value="<?php echo $scalex;?>"/>, <input name="scaley" type="text" style="width: 5em;" value="<?php echo $scaley;?>"/>, <input name="scalez" type="text" style="width: 5em;" value="<?php echo $scalez;?>"/></td></tr>
			<tr><td><label>Rotation:</label></td><td><input name="roll" type="text" style="width: 5em;" value="<?php echo $roll;?>"/>, <input name="pitch" type="text" style="width: 5em;" value="<?php echo $pitch;?>"/>, <input name="yaw" type="text" style="width: 5em;" value="<?php echo $yaw;?>"/></td></tr>
		<?php
					ET();
				ET();
			ET();
		ET();
	ET();
?>
