<?php
	$title = "View/Change 3D Model";
	
	if (isset($_REQUEST['id']))
	{
		$itemid = filter_var($_REQUEST['id'],FILTER_VALIDATE_INT);
		if ($itemid === FALSE) exit;
	}
	
	if (!isset($itemid)) exit;
	
	if ($_SERVER['REQUEST_METHOD'] == 'POST')
	{
		if (!isset($_REQUEST['version'])) exit;
		
		$version = filter_var($_REQUEST['version'],FILTER_VALIDATE_INT);
		if ($version === FALSE) exit;
		
		if (isset($_REQUEST['skin']))
		{
			$skin = filter_var($_REQUEST['skin'],FILTER_VALIDATE_INT);
			if ($skin === FALSE) exit;
		}
		else
			$skin = 0;
		
		$val = "";
		$val = $version;
				
		$colour = $_REQUEST['colour'];
		
		$val .= '|'.$skin.'|'.$colour;
		
		//OK - we had better find the suitable property ID here...		
		$query = $db->query("SELECT properties.id FROM properties WHERE  typename='MODEL'");
	
		$pid = 0;
		if($row = $query->fetch(PDO::FETCH_ASSOC)) 	
		{
			$pid = $row['id'];
		}	
		if ($pid != 0)
		{
			$db->query("INSERT IGNORE INTO assetproperties (propertyid, assetid) VALUES (".$pid.",".$itemid.")");
			
			$db->query("INSERT INTO assetvalues (propertyid, assetid,value) VALUES (".$pid.",".$itemid.",".$db->quote($val).") ON DUPLICATE KEY UPDATE value=".$db->quote($val));
		}		
		
		header("Location: ".$siteroot."/appearance/".$itemid);
		exit;
	}
				
	$itemdata = array();		
	$query = $db->query('SELECT * FROM assets WHERE id='.$itemid);
	
	if($row = $query->fetch(PDO::FETCH_ASSOC)) 	
	{
		$itemdata = $row;
	}	

	$query = $db->query("SELECT properties.id FROM properties WHERE properties.typename='MODEL'");
	
	if($row = $query->fetch(PDO::FETCH_ASSOC)) 	
	{
		$pid = $row['id'];
	}
	else
	{
		exit;
	}

	$modelid = 0;
	$skinid = 0;
	$colour = "#00AAAA";

	$query = $db->query("SELECT value FROM assetvalues WHERE propertyid=".$pid." AND assetid=".$itemid);
	
	if($row = $query->fetch(PDO::FETCH_ASSOC)) 	
	{
		$val = $row['value'];
		$bits = explode('|',$val);
		if (count($bits) > 2)
		{
			$modelid = $bits[0];
			$skinid = $bits[1];
			$colour = $bits[2];
		}
	}	
	
	
		
	
	include($installfolder.'/include/tmpl.php');
	include($installfolder.'/model/property.php');					
	
	?>
    
    $("#colour").spectrum({
	    color: "<?php echo $colour;?>",
        preferredFormat: "hex",
        change: function(color) {
 		   ChangeColour(color.toHexString());
           //$('#colname').html(color.toHexString());
		},
        move: function(color) {
 		   ChangeColour(color.toHexString());
           //$('#colname').html(color.toHexString());
		},
        showPalette: true,
        palette: [
<?php
		$query = $db->query("SELECT name, colour FROM relationships WHERE (style < 2) ORDER BY name");
		
		$colours = "";
		$names = "";
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 	
		{
			if ($colours != "") $colours .= ",";
			if ($row['colour'] == '') continue;
			$colours .= "'".$row['colour']."'";
		}		
		
		echo "    [".$colours."]\r\n";
		
		unset($names);
		unset($colours);
?>        	
    	]
	});
    
<?php
	SS('onload');
	?>
	<script src="/plugins/spectrum/spectrum.js"></script>
	<script src="/plugins/unity/UnityObject2.js"></script>
	
	 <script type="text/javascript">
var unityObjectUrl = "/plugins/unity/UnityObject2.js";
if (document.location.protocol == 'https:')
	unityObjectUrl = unityObjectUrl.replace("http://", "https://ssl-");
document.write('<script type="text\/javascript" src="' + unityObjectUrl + '"><\/script>');
</script>

<script type="text/javascript">
		<!--
			var config = {
				width: 650, 
				height: 400,
				params: { enableDebugging:"0" }
				
			};
			var u = new UnityObject2(config);

			jQuery(function() {

				var $missingScreen = jQuery("#unityPlayer").find(".missing");
				var $brokenScreen = jQuery("#unityPlayer").find(".broken");
				$missingScreen.hide();
				$brokenScreen.hide();
				
				u.observeProgress(function (progress) {
					switch(progress.pluginStatus) {
						case "broken":
							$brokenScreen.find("a").click(function (e) {
								e.stopPropagation();
								e.preventDefault();
								u.installPlugin();
								return false;
							});
							$brokenScreen.show();
						break;
						case "missing":
							$missingScreen.find("a").click(function (e) {
								e.stopPropagation();
								e.preventDefault();
								u.installPlugin();
								return false;
							});
							$missingScreen.show();
						break;
						case "installed":
							$missingScreen.remove();
						break;
						case "first":
						break;
					}
				});
				u.initPlugin(jQuery("#unityPlayer")[0], "/plugins/optrix/ModelSelector.unity3d");
			});
</script> 
<?php
	SS('addscripts');?>
	<link rel="stylesheet" href="/plugins/spectrum/spectrum.css">
<?php
	SS('head');
?>
 <script>
			
			var Initialised = 0;
			
			function ModelLoaded(  )
			{
				if (Initialised == 0)
				{
					Initialised = 1;
					var unity = u.getUnity();
					unity.SendMessage("Comms","SetServerName","<?php echo $_SERVER['HTTP_HOST'];?>");<?php
					if ($modelid != 0) { ?>
					ChangeModel(); <?php }; ?>
					return;
				}
				if (Initialised == 1)
				{
					Initialised = 2;
					ChangeColour('<?php echo $colour; ?>');
					ChangeSkin();
					return;
				}
			}
			
			function ChangeModel()
			{
				var unity = u.getUnity();
				var v = $('#version').val();
				unity.SendMessage("Comms","ChangeModel","" + v);
			}
			
			function ChangeSkin()
			{
				var unity = u.getUnity();
				var v = $('#skin').val();
				unity.SendMessage("Comms","ChangeSkin","" + v);
				//alert('Requesting Unity Skin Change!');
			}
			
			function ChangeColour(c)
			{
				var unity = u.getUnity();				
				unity.SendMessage("Comms","ChangeColour","" + c);
				//alert('Colour Change Request: ' + c);
			}
		-->
		</script>
        
<script>


var NewRequest = null;
var Category = "";
var Type = "";
var Style = "";

var Trigger = -1;

function ChangedCat()
{
	if (Trigger != -1) window.clearTimeout(Trigger);
	Category = $('#cat').val();
	NewRequest = { base: 'cat', cat: Category };
	Trigger = window.setTimeout(function () {
		SendRequest();
	},750);
}

function ChangedType()
{
	if (Trigger != -1) window.clearTimeout(Trigger);
	Type = $('#type').val();
	NewRequest = { base: 'type', cat: Category, type: Type };	
	window.setTimeout(function () {
		SendRequest();
	},750);
}

function ChangedStyle()
{
	if (Trigger != -1) window.clearTimeout(Trigger);
	Style = $('#style').val();
	NewRequest = { base: 'style', cat: Category, type: Type, style: Style };	
	window.setTimeout(function () {
		SendRequest();
	},750);
}

function ChangedVersion()
{
	//alert('Version Changed!');
	if (Trigger != -1) window.clearTimeout(Trigger);
	var ver = $('#version').val();
	NewRequest = { base: 'version', version: ver };	
	window.setTimeout(function () {
		SendRequest();
	},750);	
}

function SendRequest()
{
	Trigger = -1;
	if (NewRequest.base == 'cat')
	{
		//alert('<?php echo $siteroot; ?>/asset/modeldetail');
		$.post('<?php echo $siteroot; ?>/asset/modeldetail',NewRequest,function (data) {
			//alert(data);
			$('#styleset').remove();
			$('#typeset').remove();
			$('#typeset').remove();
			$('#skinset').remove();
			$('#modelset').remove();
			$('#category').after(data);
		});
	}
	if (NewRequest.base == 'type')
	{
		$.post('<?php echo $siteroot; ?>/asset/modeldetail',NewRequest,function (data) {
			//alert(data);
			$('#styleset').remove();
			$('#skinset').remove();
			$('#modelset').remove();
			$('#typeset').after(data);
		});
	}
	if (NewRequest.base == 'style')
	{
		$.post('<?php echo $siteroot; ?>/asset/modeldetail',NewRequest,function (data) {
			//alert(data);
			$('#modelset').remove();
			$('#skinset').remove();
			$('#styleset').after(data);
		});
	}	
	if (NewRequest.base == 'version')
	{
		//alert('Bing!');
		ChangeModel();
		$.post('<?php echo $siteroot; ?>/asset/modeldetail',NewRequest,function (data) {
			//alert(data);
			$('#skinset').remove();
			$('#modelset').after(data);
		});
	}
}

</script>
	
    <?php
	T('header-basic','title='.$title);
	
	ST('section','class=content');?>
	<form method="post"><?php
		ST('row');
			ST('half');	
				ST('box','title=Select Style');
	?>
        
        <input type="hidden" name="id" value="<?php echo $itemid; ?>"/>
		<input type="submit" value="Save Model" class="btn btn-success"/><?php
				SS('footer');
					ST('ftable');?>
        <tr id="category"><td><label>Category : </label></td><td>
        <select name="cat" id="cat" onchange="ChangedCat();">
        	<option value="" selected>None</option>
<?php

	$cat = "";
	if ($modelid != 0)
	{
		$query = $db->query('SELECT * FROM models WHERE id='.$modelid);
	
		if($row = $query->fetch(PDO::FETCH_ASSOC)) 	
		{
			$info = $row;
		}	
	
		$_REQUEST['base'] = 'all';
		$_REQUEST['cat'] = $info['category'];
		$_REQUEST['type'] = $info['type'];
		$_REQUEST['style'] = $info['style'];
		$_REQUEST['version'] = $info['id'];
		$_REQUEST['skin'] = $skinid;
		
		$cat = $info['category'];
	}

	$query = $db->query('SELECT DISTINCT category FROM models ORDER BY category ASC');
	
	while($row = $query->fetch(PDO::FETCH_ASSOC)) 	
	{
		echo '<option';
		if ($row['category'] == $cat) echo ' selected';
		echo '>'.$row['category'].'</option>';
	}	
?>
        </select></td></tr>
		<tr id="typeset"><td collspan="2"></td>
        	<?php
	if ($modelid != 0) include('modeldetail.php');				
			?>
        </tr>
		<tr><td>
        <label>Paint Colour : </label></td><td>
        <div style="display: inline-block; width: 60%; text-align: left;">
        <input type="text" name="colour" id="colour" value=""/>       
        </div></td></tr>
        
		<?php
			ET();
		ET();
		ET();
		
		ST('half');
		ST('box','title=Preview'); ?>
        
       
        <div id="unityPlayer" style="width: 100%;">
				<div class="missing">
					<a href="http://unity3d.com/webplayer/" title="Unity Web Player. Install now!">
						<img alt="Unity Web Player. Install now!" src="http://webplayer.unity3d.com/installation/getunity.png" width="193" height="63" />
					</a>
				</div>
				<div class="broken">
					<a href="http://unity3d.com/webplayer/" title="Unity Web Player. Install now! Restart your browser after install.">
						<img alt="Unity Web Player. Install now! Restart your browser after install." src="http://webplayer.unity3d.com/installation/getunityrestart.png" width="193" height="63" />
					</a>
				</div>
			</div><br/>
   
<?php
		ET();
		ET();
		ET();
		ET();
?>
