<?php

	//echo 'Calculating All Members...';
	include($installfolder.'/model/asset.php');
	include($installfolder.'/model/relationship.php');
	
	$property = $_REQUEST['prop'];
	//$property = 26;
	
	$matches = array();
	global $matches;
	
	$touched = array();
	global $touched;
	
	$visited = array();
	global $visited;
	
	function GetItems($id,$prop, $rel, $upstream,$position)
	{
		global $asset;
		global $matches;
		global $touched;
		global $visited;
		
		if (in_array($id,$visited))
		{
			return;
		}
		$visited[] = $id;
		
		$me = new Asset($id);
		$props = $me->GetLocalProperties();
		$me->GetValues($props);
		
		//print_r($props);
		
		foreach($props as $p)
		{
			if ($p->origintype == 'reference') continue;
			if ($p->id == $prop)
			{
				//echo 'Auditioning '.$p->name;
				if ($p->origin != $p->id)
				{
					//Measured Externally - Check for cycle...
					$unique = true;
					foreach($matches as $m)
					{
						if ($m == $p->origin)
						{
							$unique = false;
							break;
						}
					}
					if ($unique == false)
					{
						continue;
					}
				}
				if (isset($p->value['_dynamics']))
				{
					if (!isset($matches[$position]))
					{
						$matches[$position] = array();
					}
					$itm = array();
					$itm['assetname'] = $me->name;
					$itm['assetid'] = $me->id;
					$itm['propertyid'] = $p->id;
					$itm['originid'] = $p->origin;
					
					if (in_array($itm['assetid'],$touched))
					{
						continue;
					}
					$matches[$position][] = $itm;
					$touched[] = $itm['assetid'];
				}
			}
		}
		
		$rx = $me->GetRelationships();
		$px = $position;
			
		if (isset($rx[$rel->id]))
		{
			foreach($rx[$rel->id] as $r)
			{
				if (($upstream === FALSE) || ($r['upstream'] == $upstream))
				{
					$nx = $px;
					if ($r['upstream'] == false)
						$nx = $px-1;
					else
						$nx = $px+1;
						
					GetItems($r['target'],$prop,$rel,$upstream,$nx);
				}
			}
		}
		
	}
	
	//print_r($_REQUEST);
	//$mode = "horizontal";
	
	if ($mode == "horizontal")
	{
		//echo 'Gathering Chart Details...';
	
		$q = array();
		$relset = Relationships::GetAllRelationships();
		foreach($relset as $r)
		{
			if ($r->id == $rel)
			{
				$q = $r;
				break;
			}
		}
	
		//Get the items before this one...
		GetItems($assetid,$property,$q,FALSE,0);
		
		//Get the items after this one...
		//GetItems($assetid,$property,$q,false,0);
		
		//print_r($matches);
	}
	
	if ($mode == "vertical")
	{
		//echo 'Gathering Chart Details...';
	
		$q = array();
		$relset = Relationships::GetAllRelationships();
		foreach($relset as $r)
		{
			if ($r->id == $rel)
			{
				$q = $r;
				break;
			}
		}
	
		//Get the items before this one...
		//GetItems($assetid,$property,$q,true,0);
		
		//Get the items under this one only...
		GetItems($assetid,$property,$q,false,0);
		
		//print_r($matches);
	}
	
	if (count($matches) > 0)
	{
		
		include($installfolder.'/pages/measurements/chart-live.php');
	}
	

?>