<?php

//$editable = true;

$itemid = filter_var($_REQUEST['assetid'],FILTER_VALIDATE_INT);
if ($itemid === FALSE) 
{
	echo 'No Asset ID'; 
	exit;
}

include($installfolder.'/model/asset.php');
include($installfolder.'/model/relationship.php');

$thisasset = new Asset($itemid);
$thisasset->Load();

$title = $thisasset->name.' Chart';

global $installfolder;

//echo 'Charted.';

include('include/tmpl.php');



?>

	<li class="active treeview">
	  <a href="/">
		<i class="fa fa-photo"></i> <span>Current Asset</span>
	  </a>
	  <ul class="treeview-menu">
		<li>
			<a href="<?php echo $siteroot;?>/diagram/<?php echo $itemid;?>/2"><i class="fa fa-circle-o"></i> Diagram</a>
			<a href="<?php echo $siteroot;?>/dashboard/<?php echo $itemid;?>"><i class="fa fa-circle-o"></i> Dashboard</a>
			<a href="<?php echo $siteroot;?>/detail/<?php echo $itemid;?>"><i class="fa fa-circle-o"></i> Detail</a>
			<a href="<?php echo $siteroot;?>/chart/<?php echo $itemid;?>"><i class="fa fa-circle"></i> Charts</a>
		</li>
	  </ul>
    </li>

<?php SS('sidebar'); 

$dta = $thisasset->GetProperties();
$thisasset->GetValues($dta);

$defaultprop = 0;
$fullset = "";
$first = true;
foreach($dta as $vl)
{
	if ($vl->type != "MEASUREMENT") continue;
	if (!isset($vl->value['_dynamics'])) continue;
	
	if ($first == true)
	{
		$first = false;
		$defaultprop = $vl->id;
	}
	else
		$fullset .= '_';
	
	$fullset .= $vl->id;
}	

				?>

<script>

var activeproperty = '<?php echo $defaultprop; ?>';

function SetProperty(ob,vl)
{
	activeproperty = vl;
	$('.propbutton').removeClass("btn-success");
	$('.propbutton').addClass("btn-default");
	$(ob).addClass("btn-success");
	
	$('.propbased').hide();
	
	$('.prop' + vl).show(500);
	
	$('.choicer').each(function (index, ob) {
		var link = $(ob).attr('href');
		var ps = link.lastIndexOf('/');
		link = link.substr(0,ps+1) + vl;
		$(ob).attr('href',link);
		//alert(link);
	});
}

function ShowBasicChart()
{
	window.location = '<?php echo $siteroot; ?>/measurement/<?php echo $itemid; ?>/' +  activeproperty;
}

</script>

<?php 

T('header-basic','title='.$title);

ST('section','class=content');
	ST('row');
		ST('half');
			ST('box','title=Show Me');
					
				ST('buttonmenu');
					//echo '<li><a href="#" class="btn btn-default propbutton" onclick="SetProperty(this,\''.$fullset.'\'); return false;">All Measurements</a></li>';
					$first = true;
					foreach($dta as $vl)
					{
						if ($vl->type != "MEASUREMENT") continue;
						if (!isset($vl->value['_dynamics'])) continue;
						if ($vl->origintype == 'reference') continue;
						
						echo '<li><a href="#" class="btn propbutton btn-';
						
						if ($first == false)
							echo 'default';
						else
						{
							echo 'success';
							$first = false;
							$defprop = $vl->id;
						}
						
						echo '" onclick="SetProperty(this,\''.$vl->id.'\'); return false;">'.$vl->name.'</a></li>';
					}
				ET();
			ET();
		ET();
		ST('half');
			ST('box','title=For');
				$dta = $thisasset->GetRelationships();
				$rels = Relationships::GetAllRelationships();
				
				$process = array();
				foreach($rels as $rl)
				{
					if ($rl->id== 6) continue;
					foreach($dta as $k => $v)
					{
						if ($k == $rl->id)
						{
							if ($rl->type == 'physical') 
							{
								$st = "The ".$rl->name.' for this Asset';
								
								$match= false;
								foreach($process as $t)
								{
									if ($t['name'] == $st)
									{
										$match = true;
										break;
									}
								}
								if ($match == true)
								{
									$t['rels'][] = $rl->id;
									continue;
								}
							
								$itm = array();
								$itm['name'] = $st;
								$itm['rels'] = array($rl->id);
								$itm['ob'] = $itemid;
								$itm['mode'] = 'linkedto';
								$itm['validprops'] = $rl->pass;
								$process[] = $itm;
								
								//echo '<li><a href="#" class="btn btn-default">'.$rl->downname.' / '.$rl->upname.' this Asset</a></li>';
							}
							else
							{
								foreach($v as $n)
								{
									if ($n['upstream'] == false) continue;
									$otherasset = new Asset($n['target']);
									$st = $rl->FormatString("",$otherasset->name,$n['upstream']);
									$st = substr($st,3);
									
									$itm = array();
									$itm['name'] = "All Assets ".$st;
									$itm['ob'] = $n['target'];
									$itm['mode'] = 'under';
									$itm['rels'] = array($rl->id);
									$process[] = $itm;
									//echo '<li><a href="#" class="btn btn-default">'.$st.'</a></li>';
								}
							}
						}
					}
				}
				
				ST('buttonmenu');
					
					echo '<li><a href="#" onclick="ShowBasicChart(); return false;" class="btn btn-default">This Asset Only</a></li>';
					$dstyle = "";
					foreach($process as $itm)
					{
						echo '<li><a href="'.$siteroot.'/chart/'.$itm['mode'].'/'.$itm['ob'].'/'.implode('-',$itm['rels']).'/'.$defprop.'" class="btn btn-default choicer';
						if (isset($itm['validprops']))
						{
							$dstyle = "display: none;";
							foreach($itm['validprops'] as $prp)
							{
								if ($prp == $defprop) $dstyle = "";
								echo ' prop'.$prp;
							}
							echo ' propbased';
						}
						echo '" style="'.$dstyle.'">'.$itm['name'].'</a></li>';
					}
					
				ET();
			ET();
		ET();
		
		
	ET();
ET(); 
?>
