<?php	
/**
 * Provides a CSV file of historical information
 *
 * Note that this page expects incoming dates to be Javascript-style dates
 * (milliseconds from epoch), so times will need to be converted.
 *
 * @author Steven Harding
 */
 
	require_once($_SERVER['DOCUMENT_ROOT'].'/include/historian.php');			
	
	if (isset($_REQUEST['id']))
	{
		$itemid = $_REQUEST['id'];
	}
			
	if ($itemid != 0)
	{
		$itemdata = array();		
		$query = $db->query('SELECT * FROM assets WHERE id='.$itemid);

		if($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$itemdata = $row;
		}	
	}	
	
	//echo 'Property Check!';
	
	if (isset($_REQUEST['prop']))
	{
		$property = $_REQUEST['prop'];
	}
	
	if (!isset($property)) exit;
	
	include($installfolder.'/model/asset.php');
	include($installfolder.'/model/property.php');
	
	$thisasset = new Asset($itemid);
	$thisprop = new Property($property);
	$thisprop->Load();
	
	$fname = $thisasset->name.' '.$thisprop->name;
	
	header('Content-Type: text/csv');
	header('Content-Disposition: attachment; filename="'.$fname.'.csv"');
	
	
	$profile = 1;
	
	$query = $db->query('SELECT * FROM properties JOIN assetvalues ON (assetvalues.propertyid = properties.id) WHERE assetid='.$itemid.' AND properties.id = '.$property);

	if($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$propdata = $row;
	}
	
	//echo 'Checking For Dynamic Data';
	
	$isdynamic = false;
	
	$query = $db->query('SELECT * FROM datalinks WHERE assetid='.$itemid.' AND propertyid = '.$property.' AND node=\'measurement\' AND profile='.$profile.' AND mode=1');

	if($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$dynamic = $row;
		$isdynamic = true;
	}
	
	$start = $_REQUEST['start'];
	$end = $_REQUEST['end'];
	
	if ($isdynamic == true)
	{	
	
		date_default_timezone_set('Australia/Sydney');
		
		$p = strpos($start,"-");
		if ($p === FALSE)
		{
			$start = date('Y-m-d H:i:s', $start/1000);
		}
		
		$p = strpos($end,"-");
		if ($p === FALSE)
		{
			$end = date('Y-m-d H:i:s', $end/1000);
		}
	
		$res = GetHistoryRaw($itemid,$property,"measurement",$start,$end);		
		
		echo "Timestamp,Value\r\n";
		foreach($res as $q)
		{
			if (!isset($q[2])) continue;
			echo $q[1].','.$q[2]."\r\n";
		}
	}	
?>