<?php
	
$forimport = false;
$forscreen = false;

if (isset($_REQUEST['form']))
{
	if ($_REQUEST['form'] == 'screen') $forscreen = true;
}

if (!class_exists('Asset'))
	include($installfolder.'/model/asset.php');
if (!class_exists('Relationship'))
	include($installfolder.'/model/relationship.php');

$relset = Relationships::GetAll();

if (isset($exportlocation))
{
	ob_start();
}

if ($forscreen == true) { ?>

<html>
	<head>
		<title>Form Export</title>
	</head>
	<body>
		<table style="width: auto;">
<?php
	$leader = '<tr style="border: 1px solid silver;"><td style="vertical-align: top; background-color: #F2F2F2; border-top: 2px solid black">';
	$header = '<tr style="border: 1px solid silver;"><td style="vertical-align: top; background-color: #F2F2F2; border-top: 1px solid #EEEEEE">';
	$footer = '</td></tr>'."\r\n";
	$joiner = '</td><td style="vertical-align: top; background-color: #F2F2F2; border-top: 1px solid #EEEEEE">';
	$blank = '<tr><td colspan="4" style="border-top: 2px solid black;"">&nbsp;</td></tr>';
	
	/*$header = '';
	$footer = "\r\n";
	$joiner = "\t";
	$blank = "\r\n";*/
}
else
{
	if (!isset($exportlocation)) {
		header('Content-Type: text/tab-separated-values');
		header('Content-Disposition: attachment; filename="'.$companyname.' Form Export.txt"');
	}
	$header = '';
	$leader = $header;
	$footer = "\r\n";
	$joiner = "\t";
	$blank = "\r\n";
}

	//First, get the base details down...
	
	$slist = array();
	$profilename = array();
	$propname = array();
	
	$qry = 'SELECT id,name FROM profiles';
	$query = $db->query($qry);
		
	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$profilename[$row['id']] = $row['name'];
	}
	
	$relset = Relationships::GetAll();
	
	$metadata = false;
	if (isset($_REQUEST['metadata']))
	{
		if ($_REQUEST['metadata'] == 1)
		{
			$metadata = true;
		}
	}
	
	$limited = false;
	
	if (isset($alist))
	{
		$usedrels = array();
		$qry = 'SELECT DISTINCT relationship FROM assetrelationships WHERE childasset IN ('.implode(',',$alist).') OR parentasset IN ('.implode(',',$alist).')';
		$query = $db->query($qry);
			
		$limited = true;
			
		if ($query !== FALSE)
		{
			while($row = $query->fetch(PDO::FETCH_ASSOC)) 
			{
				$usedrels[] = $row['relationship'];
			}
		}
		
		//print_r($usedrels);
	}
	
	foreach($relset as $rel)
	{
		if ($rel->id >= 10)
		{
			if (isset($alist))
			{
				if (!in_array($rel->id,$usedrels)) continue;
			}
			echo $header.'_relationship'.$joiner.$rel->name.$joiner.'id'.$joiner.$rel->id.$footer;
			echo $header.$joiner.$joiner.'style'.$joiner.$rel->type.$footer;
			echo $header.$joiner.$joiner.'upname'.$joiner.$rel->upname.$footer;
			echo $header.$joiner.$joiner.'downname'.$joiner.$rel->downname.$footer;
			echo $blank;
		}
	}
	
	$propcondition = "";
	
	if (isset($alist))
	{
		$propcondition = " JOIN assetvalues ON (assetvalues.propertyid = properties.id) WHERE assetvalues.assetid IN (".implode(',',$alist).")";
	}
	
	$qry = 'SELECT DISTINCT name,typename,id,options,builtin FROM properties'.$propcondition;
	$query = $db->query($qry);
		
	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$propname[$row['id']] = $row['name'];
		if ($row['builtin'] == 0)
		{
			echo $header.'_property'.$joiner.$row['name'].$joiner.'type'.$joiner.$row['typename'].$footer;
			if ($row['options'] != "")
			{
				echo $header.$joiner.$joiner.'options'.$joiner.$row['options'].$footer;
			}
			echo $blank;
		}
	}
	
	$qry = 'SELECT * FROM datasources';
	$query = $db->query($qry);
		
	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$slist[] = $row;
	}
	
	if (!isset($alist))
	{
		$alist = array();
		$qry = 'SELECT id FROM assets ORDER BY id';
		$query = $db->query($qry);
			
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			if ($row['id'] < 5) continue;
			$alist[] = $row['id'];
		}
	}
	
	//print_r($alist);
	
	foreach($alist as $assetid)
	{
		$thisasset = new Asset($assetid);
		$thisasset->Load();
		
		echo $header;
		echo $thisasset->name;
		echo $joiner."_id".$joiner.$assetid.$footer;
		echo $header.$joiner."description".$joiner.$thisasset->description.$footer;
		
		$typename = "";
		if ($thisasset->tag == true)
		{
			$typename = "tag";
		}
		if ($thisasset->root == true)
		{
			$typename = "root";
		}
		if ($typename != "")
		{
			echo $header.$joiner."_type".$joiner.$typename.$footer;
		}
		
		$first = true;
		foreach($slist as $src)
		{
			if ($src['assetid'] == $assetid)
			{
				$targ = $profilename[$src['profile']];
				if ($src['mode'] == 0) 
					$targ .= '>live>';
				else
					$targ .= '>hist>';
				
				$targ .= $src['driver'].'>'.$src['address'];
				
				if ($first == true)
					echo $header.$joiner.'_source'.$joiner.$targ.$footer;
				else
					echo $header.$joiner.$joiner.$targ.$footer;
			}	
		}
		
		$rels = $thisasset->GetRelationships();
		
		foreach($rels as $k => $v)
		{
			$r = null;
			foreach($relset as $rx)
			{
				if ($rx->id == $k)
				{
					$r = $rx;
					break;
				}
			}
			
			if ($r === null) continue;
			
			$first = true;
			foreach($v as $rev)
			{
				if (in_array($rev['target'],$alist))
				{		
					if ($rev['upstream'] == false) continue;
					$ta = new Asset($rev['target']);
					$targ = $ta->name;
					
					$targ .= ' ( '.$rev['target'].' )';	
					
					if ($first == true)
					{
						echo $header.$joiner.$r->name.$joiner.$targ.$footer;
						$first = false;
					}
					else
					{
						echo $header.$joiner.$joiner.$targ.$footer;
					}
				}
				else
				{
					$char = "*";
					
					if ($rev['upstream'] == false)
					{
						if ($r->id == 3) continue;
						$char = "+";
					}
					if ($first == true)
					{
						echo $header.$joiner.$r->name.$joiner.$char.$footer;
						$first = false;
					}
					else
					{
						echo $header.$joiner.$joiner.$char.$footer;
					}
				}
			}
			
			
		}
		
		$props = $thisasset->GetLocalProperties();
		$thisasset->GetValues($props);
		$dynamicrows = array();
		
		$qry = 'SELECT propertyid, sourceid,node,datalinks.profile,datalinks.mode,assets.name as aname, datasources.driver, datalinks.profile, datalinks.address FROM datalinks JOIN assets ON (assets.id = sourceid) JOIN datasources ON (datasources.assetid = assets.id AND datasources.profile = datalinks.profile AND datasources.mode = datalinks.mode) WHERE datalinks.assetid='.$assetid;
		//echo $qry;
		$query = $db->query($qry);
			
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			if (!isset($dynamicrows[$row['propertyid']]))
			{
				$dynamicrows[$row['propertyid']] = array();
			}
			
			$dynamicrows[$row['propertyid']][] = $row;
		}
		
		foreach($props as $prp)
		{
			if ($prp->origin != $assetid) continue;
			if ($prp->origintype != 'local') continue;
			if (count($prp->value) == 1)
			{
				echo $header.$joiner.$prp->name.$joiner.$prp->value[array_keys($prp->value)[0]].$footer;
			}
			else
			{
				$first = true;
				foreach($prp->value as $k => $v)
				{
					$handled = false;
					if ($k[0] == "_") continue;
					if ($k == 'live') continue;
					$val = $v;
					if (isset($dynamicrows[$prp->id]))
					{
						$fst = true;
						foreach($dynamicrows[$prp->id] as $dr)
						{
							if ($dr['node'] != $k) continue;
							
							$constring = '>'.$profilename[$dr['profile']].'>';
							if ($dr['mode'] == '0')
								$constring .= 'live>';
							else
								$constring .= 'hist>';
								
							//OK - is an asset called 'aname' somewhere in this collection?
							$local = false;
							
							if ($limited == true)
							{
								$qry = 'SELECT id FROM assets WHERE name='.$db->quote($dr['aname']).' AND id IN ('.implode(',',$alist).')';
								$query = $db->query($qry);
									
								if($row = $query->fetch(PDO::FETCH_ASSOC)) 
								{
									$local = true;
								}
							}
							if ($local == false) $dr['aname'] = '*:'.$dr['driver'];
								
							$constring .= $dr['aname'].'>'.$dr['address'];
							
							$handled = true;
							
							if ($first == true)
							{
								echo $header.$joiner.$prp->name.$joiner.$k.$joiner.$constring.$footer;
								$first = false;
								$fst = false;
							}
							else
							{
								if ($fst == true)
								{
									echo $header.$joiner.$joiner.$k.$joiner.$constring.$footer;
								}
								else
								{
									echo $header.$joiner.$joiner.$joiner.$constring.$footer;
								}
							}
						}	
					}
					
					if ($handled == false)
					{
						if ($first == true)
						{
							echo $header.$joiner.$prp->name.$joiner.$k.$joiner.$val.$footer;
							$first = false;
						}
						else
						{
							echo $header.$joiner.$joiner.$k.$joiner.$val.$footer;
						}
					}
				}
			}
		}
		
		foreach($props as $prp)
		{
			$first = true;
			if ($prp->origintype != 'reference') continue;
			
			$other = new Asset($prp->origin);
			$refexpa = $other->name;
			$refexpa .= " ( ".$prp->origin." )";
			
			if (!in_array($other->id,$alist))
			{
				$refexpa = "*";
			}
			
			$refexpb = $propname[$prp->id];
			$refexpb .= " ( ".$prp->id." )";
			
			if ($first == true)
			{
				echo $header.$joiner."_reference".$joiner.$refexpa.$joiner.$refexpb.$footer;
				$first = false;
			}
			else
			{
				echo $header.$joiner.$joiner.$refexpa.$joiner.$refexpb.$footer;
			}
		}
		
		echo $blank;
	}

if ($forscreen == true)
{
?>
		</table>
	</body>
</html>
<?php }; 

if (isset($exportlocation))
{
	$response = ob_get_clean();
	file_put_contents($exportlocation,$response);
}
?>