<?php
$title = "Spreadsheet Guide: Properties";

include('include/tmpl.php');

T('header-basic','title='.$title);

ST('section','class=content');
	ST('row');
		ST('half');
			ST('box','title=Property Names');
?>
            <p>Below is a list of your property names - add them to your form to import them.<hr/></p>
            <p><ul>
            <?php
            //Load names of properties and relationships
		$properties = array();
		$query = $db->query('SELECT name,typename FROM properties ORDER BY name ASC');
	
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{			
			$fl = $_SERVER['DOCUMENT_ROOT'].'/modules/inputs/'.strtolower($row['typename']).'.php';
			if (file_exists($fl))
			{
				echo '<li>'.$row['name'].'<br/>';
				include($fl);				
				echo '<div style="font-family: \'Courier New\', Courier, monospace; font-weight: bold; font-size: small;">';
				if (count($inputs) == 1)
				{
					echo '&lt; value &gt;';
				}
				else
				{
					for($x = 0; $x < count($inputs); $x++)
					{
						echo $inputs[$x]['name'].' = &lt; value &gt;<br/>';
						//if ($x < count($inputs) -1) echo ' | ';
					}
				}
				
				echo '</div><br/>';
				echo '</li>';
			}			
		}	?></ul>
            </p>
            <br/>
            <p>You can also see your <a href="relationships">Relationships</a> and <a href="links" >Data Links</a></p>
            <!--<p style="font-size: small">For detailed information on making spreadsheets to improve asset creation time, please see the <a href="/docs/spreadsheet.html">Spreadsheet Import Module Documentation</a></p>-->
     
<?php
			ET();
		ET();
	ET();
ET();
?>