<?php
	require_once($_SERVER['DOCUMENT_ROOT'].'/include/templateengine.php');
	require_once($_SERVER['DOCUMENT_ROOT'].'/config/settings.php');
	require_once($_SERVER['DOCUMENT_ROOT'].'/include/db.php');	
	
	if ($_SERVER['REQUEST_METHOD'] == 'POST')
	{
		if (!isset($_REQUEST['uname'])) exit;
		if (!isset($_REQUEST['email'])) exit;	
		
		$uname = $_REQUEST['uname'];
		$email = $_REQUEST['email'];
		
		if (($email == "") || ($uname == ""))
		{
			$errormsg = "You must specify BOTH your username and email address to reset your password";
		}
		else
		{		
			require_once($_SERVER['DOCUMENT_ROOT'].'/include/login.php');
			
			$Auth = new AuthSystem();		
			$resp = $Auth->PasswordResetRequest($uname,$email);
			$errormsg = "If the user and email address exist, a password reset email has been sent.";			
		}
		
	}
		
						
	$template = new Template('ARDI',$templatename);
	$template->Set('description','Email Action');			
	$template->Set('heading',$companyname);		
	$template->PublicPage();
	
	$template->AddStyleSheet('/css/linker.css');	
	$template->AddStyleSheet('/css/viewlist.css');		
	$template->AddStyleSheet('/css/alerts.css');		
	$template->AddStyleSheet('/css/err.css');				
	
function stripit($n)
{
	//return str_replace(" ","_",$n);
	return preg_replace("/[^a-zA-Z]/", "", $n);
}
	
	$template->Set('params','');

	if (isset($errormsg)) {
	$template->StartSection('onload');  ?>
	$('.errormessage').fadeIn(1000);
<?php	
	};
	
	$template->StartSection('content'); 
?>	

<div class="12u" >	
	<br/>
    <h3>Password Reset</h3>   
    
</div>

<div class="12u" >		      
    <?php
	if (isset($errormsg))
	{?>
		<div class="errormessage" style="display: none;"><?php echo $errormsg; ?></div><?php
	}
	?>
    <p>
    You can request a password reset by filling in both of the fields below...
    </p>
   <form method="POST">	
    <table style="width: 50%;margin-left: auto; margin-right: auto;"><tr><td style="text-align: right; margin-right: 10px; width: 50%;"><label style="text-align: right;">Username:</label></td><td style="text-align: left; padding-left: 10px;"><input type="text" name="uname"/></td> </tr>
       	<tr><td><label style="text-align: right;">Email Address:</label></td><td style="text-align: left; padding-left: 10px;"><input type="text" name="email"/></td></tr>  </table>
        <input type="submit" value="Request Password Update"/>        
    </form>
</div>

    <?php
		
	$template->Write();
?>