<?php

include($installfolder.'/include/simpletest/autorun.php');
include($installfolder.'/model/asset.php');
require_once($installfolder.'/include/creator.php');
require_once($installfolder.'/include/deletor.php');

function PostForm($url,$params)
{
	global $siteroot;
	
	$fields_string = "";
	$fields = array();
	$bits = explode('^',$params);
	foreach($bits as $b)
	{
		$p = explode('=',$b);
		$fields[$p[0]] = $p[1];
	}
	$url = 'http://localhost'.$siteroot.$url;

	//url-ify the data for the POST
	foreach($fields as $key=>$value) { $fields_string .= $key.'='.$value.'&'; }
	$fields_string = substr($fields_string,0,strlen($fields_string)-1);

	//echo ($url).'<br/>';
	//echo ($fields_string).'<br/>';
	//open connection
	$ch = curl_init();

	//set the url, number of POST vars, POST data
	curl_setopt($ch,CURLOPT_URL, $url);
	curl_setopt($ch,CURLOPT_POST, count($fields));
	curl_setopt($ch,CURLOPT_POSTFIELDS, $fields_string);
	curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true); 

	//execute post
	$result = curl_exec($ch);
	
	//print_r(curl_getinfo($ch));

	//close connection
	curl_close($ch);
	return $result;
}

function CheckAssetExists($name)
{
	global $db;
	
	$query = $db->query("SELECT id FROM assets WHERE name='".$name."'");

	$id = -1;
	$already = false;
	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		if ($already == false)
		{
			$already = true;
			$id = $row['id'];
		}
		else
		{
			echo 'Excessive Results!';
			$id = -1;
			return false;
		}
	}	
	
	return $id;
}

function CheckDirectRelationship($assetid, $toid)
{
	return true;
}

function CheckClosureTable($assetid, $list)
{
	return true;
}

class TestAssetCreationFunctions extends UnitTestCase
{	
	private $relno = 0;
	
	function testAddPropertiesFirst() {    
	   
	   echo 'Adding AR Properties to First Asset<br/>';
	   require_once($_SERVER['DOCUMENT_ROOT'].'/model/asset.php');
	   
	   $upper = CheckAssetExists('First Asset');
	   
	   $ass = new Asset($upper);
	   $ass->SetProperty(2,'OPTRX-021');
	   $ass->SetProperty(12,'0');
	   $props = $ass->GetProperties();
	   $ass->GetValues($props);
	   
	   //print_r($props);
	   
	   $this->assertEqual(count($props),4);
		
	}
	
	function testAddPropertiesSecond() {    
	   
	   echo 'Adding AR Properties to Second Asset<br/>';
	   require_once($_SERVER['DOCUMENT_ROOT'].'/model/asset.php');
	   
	   $upper = CheckAssetExists('Second Asset');
	   
	   $ass = new Asset($upper);
	   $ass->SetProperty(2,'OPTRX-022');
	   $ass->SetProperty(12,'1');
	   $props = $ass->GetProperties();
	   $ass->GetValues($props);
	   
	   //print_r($props);
	   
	   $this->assertEqual(count($props),3);
		
	}
}

?>