<?php

include($installfolder.'/include/simpletest/autorun.php');
include($installfolder.'/model/asset.php');

class AssetTest extends UnitTestCase
{
	function testAssetName()
	{
		$ob = new Asset(1);
		$this->assertTrue($ob->name == 'Location');
		echo 'Asset Information - Name<br/>';
	}
	
	function testAssetProperties()
	{
		$ob = new Asset(5);
		$this->assertTrue($ob->name == 'Site');
		$props = $ob->GetProperties();
		$this->assertTrue(count($props) == 1);
		$this->assertTrue($props[0]->name == "Address");
		$this->assertTrue($props[0]->id == 3);
		$this->assertTrue($props[0]->origin == 5);
		
		echo 'Asset Information - Basic Properties<br/>';
	}
	
	function testAssetDescription()
	{
		$ob = new Asset(5);
		$ob->Load();
		//echo $ob->description;
		$this->assertTrue($ob->description == 'This is your initial ARDI site');
		echo 'Asset Information - Desc<br/>';
	}
	
	function testAssetPropertyValues()
	{
		$ob = new Asset(5);
		$props = $ob->GetProperties();
		$ob->GetValues($props);
		//echo $props[0]->value['address'];
		$this->assertTrue($props[0]->value['address'] == '18/2 Memorial Drive, Shellharbour City Center, NSW, Australia');
		echo 'Asset Information - Simple Property Values<br/>';
	}
}

?>