<?php

if ($siteroot != '/s/_test')
{
	header('Location: /');
}

//OnlyShowIf(CheckAdmin());

$title = "Automated Software Testing";

include($installfolder.'/include/tmpl.php');

global $db;
global $siteroot;

T('header-basic','title='.$title);
	
?>

<script>

function StartStep(str,cmd)
{
	//alert(str + " / " + cmd);
	var tmp = $('#results').html();
	tmp += '<br/>' + str + '...';
	$('#results').html(tmp);
	
	$.post('<?php echo $siteroot; ?>/test/' + cmd,{ mode: 'automated' }, function (data) {
		var tmp = $('#results').html();
		tmp += data.replace('core.php','') + '<br/>';
		//alert(tmp);
		$('#results').html(tmp);
		if (tmp.indexOf('class="fail"') <= 0)
		{
			RunQueue();
		}
		else
		{
			tmp += "<br/><h4>FAILED</h4>";
			$('#results').html(tmp);
			$('#starter').fadeIn(1000);
		}
	});
}

var sequence = [];

function QueueSet(txt,cmd)
{
	sequence.push(txt + "|" + cmd);
}

function RunQueue()
{
	if (sequence.length > 0)
	{
		tx = sequence.shift();
		bits = tx.split('|');
		StartStep(bits[0],bits[1]);
	}
	else
	{
		var tmp = $('#results').html();
		tmp += '<br/>Testing Complete<br/>';
		$('#results').html(tmp);
		$('#starter').fadeIn(1000);
	}
}

function BeginSequence()
{
	$('#starter').fadeOut(1000);
	$('#results').html("");
	
	QueueSet('Initialising Database','initialise');
	QueueSet('Fundamental Asset Functions','assets-basic');
	QueueSet('Creating &amp; Deleting Assets','assets-creation');
	QueueSet('Relating Assets','relationship-creation');
	QueueSet('Property Flow','relationship-properties');
	QueueSet('Digital Properties','properties-digital');
	QueueSet('AR Markers','armarkers');
	/*QueueSet('Checking Configuration Files','configuration');
	QueueSet('Backing Up Existing Data &amp; Erasing DB','backup');
	QueueSet('Adding Assets','assetcreationfunctions');
	QueueSet('Removing Assets','assetdeletefunctions');	
	QueueSet('Asset Linking','assetlinkingfunctions');	
	QueueSet('Property Functions','propertyfunctions');
	QueueSet('Template Functions','templatefunctions');			
	QueueSet('Alert Functions','assetalertfunctions');
	QueueSet('Add Relationships and Properties','addrelandprop');
	QueueSet('Favourites and Recents','userprefs');*/
	//QueueSet('Basic Data Links','datalinkfunctions');
	RunQueue();
}
</script>

<?php 
	ST('section','class=content');
		ST('row');
			ST('full');
				ST('box','title=Results'); ?>
    <button onclick="BeginSequence();" id="starter" class="btn btn-success">Begin Test Sequence</button>
<?php			SS('footer'); ?>
    <div id="results" style="font-size: small;">
    </div><?php
				ET();
			ET();
		ET();
	ET();
?>