<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="description" content="">
    <meta name="author" content="">
    <link rel="shortcut icon" href="assets/ico/favicon.ico">

    <title><?php echo $content['title']; ?></title>

    <!-- Bootstrap core CSS -->
    <link href="/themes/default/css/bootstrap.css" rel="stylesheet">

    <!-- Custom styles for this template -->
    <link href="/themes/default/css/style.css" rel="stylesheet">
    <link href="/themes/default/css/font-awesome.min.css" rel="stylesheet">


    <!-- Just for debugging purposes. Don't actually copy this line! -->
    <!--[if lt IE 9]><script src="../../assets/js/ie8-responsive-file-warning.js"></script><![endif]-->

    <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
    <!--[if lt IE 9]>
      <script src="https://oss.maxcdn.com/libs/html5shiv/3.7.0/html5shiv.js"></script>
      <script src="https://oss.maxcdn.com/libs/respond.js/1.4.2/respond.min.js"></script>
    <![endif]-->
    
    <script src="/themes/default/js/modernizr.js"></script>
  </head>

  <body>

    <!-- Fixed navbar -->
    <div class="navbar navbar-default navbar-fixed-top" role="navigation">
      <div class="container">
        <div class="navbar-header">
          <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-collapse">
            <span class="sr-only">Toggle navigation</span>
            <span class="icon-bar"></span>
            <span class="icon-bar"></span>
            <span class="icon-bar"></span>
          </button>
          <a class="navbar-brand" href="index.html"><?php echo $content['title']; ?></a>
        </div>
        <div class="navbar-collapse collapse navbar-right">
          <ul class="nav navbar-nav">
            <li class="active"><a href="index.html">HOME</a></li>
            <li><a href="about.html">ABOUT</a></li>
            <li><a href="contact.html">CONTACT</a></li>
            <li class="dropdown">
              <a href="#" class="dropdown-toggle" data-toggle="dropdown">PAGES <b class="caret"></b></a>
              <ul class="dropdown-menu">
                <li><a href="blog.html">BLOG</a></li>
                <li><a href="single-post.html">SINGLE POST</a></li>
                <li><a href="portfolio.html">PORTFOLIO</a></li>
                <li><a href="single-project.html">SINGLE PROJECT</a></li>
              </ul>
            </li>			
        <li class="dropdown">
          <a href="#" class="dropdown-toggle" data-toggle="dropdown"><b><?php if (!isset($_SESSION['userid'])) echo 'LOGIN'; else echo 'ACCOUNT'; ?></b> <span class="caret"></span></a>
			<ul id="login-dp" class="dropdown-menu">
				<li>
					 <div class="row">
							<div class="col-md-12">
								<?php if (!isset($_SESSION['userid'])) { ?>
								<div class="social-buttons">
									<a href="#" class="btn btn-fb"><i class="fa fa-facebook"></i> Sign In With Facebook</a>
									<!--<a href="#" class="btn btn-tw"><i class="fa fa-twitter"></i> Twitter</a>-->
								</div>
                                <hr/>
								 <form class="form" role="form" method="post" action="/user/login" accept-charset="UTF-8" id="login-nav">
										<div class="form-group">
											 <label class="sr-only" for="exampleInputEmail2">Email Address</label>
											 <input type="email" class="form-control" id="exampleInputEmail2" name="email" placeholder="Email Address" required>
										</div>
										<div class="form-group">
											 <label class="sr-only" for="exampleInputPassword2">Password</label>
											 <input type="password" class="form-control" id="exampleInputPassword2" placeholder="Password" name="password" required>
                                             <!--<div class="help-block text-right"><a href="">Forget the password ?</a></div>-->
										</div>
										<div class="form-group">
											 <button type="submit" class="btn btn-primary btn-block">Sign in</button>
										</div>
										<div class="checkbox">
											 <label>
											 <input type="checkbox"> Keep Me Signed In
											 </label>
										</div>
								 </form>
								<?php }; ?>
							</div>
							<div class="bottom text-center">
								<a href="#"><b>Register Now</b></a>
							</div>
					 </div>
				</li>
          </ul>
        </div><!--/.nav-collapse -->
      </div>
    </div>
	
	<?php
	
	//echo 'Error: '.$errormessage;
	if ((isset($errormessage)) && ($errormessage != ""))
	{?>
		<div class="row">
			<div class="col-lg-12">			
				<div class="alert alert-warning alert-dismissible" role="alert">
				<?php echo $errormessage; ?>
					<button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>  
				</div>
			</div>
		</div><?php
	}
	?>
	
	<!-- Content -->
	<?php echo $content['']; ?>	
	 
	 
	<!-- *****************************************************************************************************************
	 MIDDLE CONTENT
	 ***************************************************************************************************************** -->	 	

	<!-- *****************************************************************************************************************
	 FOOTER
	 ***************************************************************************************************************** -->
	 <div id="footerwrap">
	 	<div class="container">
		 	<div class="row">
		 		<div class="col-lg-4">
		 			<h4>Legal</h4>
		 			<div class="hline-w"></div>
		 			<p><a href="#">Privacy Policy</a><br/>
					<a href="#">Terms of Service</a><br/></p>
					
		 		</div>
		 		<div class="col-lg-4">
		 			<h4>Social Links</h4>
		 			<div class="hline-w"></div>
		 			<p>		 				
		 				<a href="#"><i class="fa fa-facebook"></i></a>
		 				<a href="#"><i class="fa fa-twitter"></i></a>
		 				<a href="#"><i class="fa fa-instagram"></i></a>
		 				<a href="#"><i class="fa fa-tumblr"></i></a>
		 			</p>
		 		</div>
		 		<div class="col-lg-4">
		 			<h4>Support</h4>
		 			<div class="hline-w"></div>
		 			<p>
						<a href="#">Downloads</a><br/>
		 				<a href="#">FAQ / Manual</a><br/>
						<a href="#">Feedback</a><br/>
		 				<a href="#">Community</a><br/>						
		 			</p>
		 		</div>
		 	
		 	</div><! --/row -->
	 	</div><! --/container -->
	 </div><! --/footerwrap -->
	 
	
	 
    <!-- Bootstrap core JavaScript
    ================================================== -->
    <!-- Placed at the end of the document so the pages load faster -->
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/1.11.0/jquery.min.js"></script>
    <script src="/plugins/bootstrap.min.js"></script>
	<script src="/plugins/retina-1.1.0.js"></script>
	<script src="/plugins/jquery.hoverdir.js"></script>
	<script src="/plugins/jquery.hoverex.min.js"></script>
	<script src="/plugins/jquery.prettyPhoto.js"></script>
  	<script src="/plugins/jquery.isotope.min.js"></script>
  	<script src="/themes/default/js/custom.js"></script>


  </body>
</html>